﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//using MathNet;
//using MathNet.Numerics.LinearAlgebra.Double;
//using MathNet.Numerics.LinearAlgebra.Double.Factorization;
//using MathNet.Numerics.LinearAlgebra.Generic;

namespace Climate_toolkit
{
    class CEOFFactory
    {
       //public static double[,] get_covariance_matrix_AAT(double[,] X)
       // {
       //    // C = AAT/N, n is the sample size, usually x*y 
       //    // get covariance matrix ATA if ncols > nrows
       //     int M = X.GetLength(0);
       //     int N = X.GetLength(1);
       //     double Ndouble = Convert.ToDouble(N);

       //     var Xvar = new DenseMatrix(X);
       //     var XvarT = Xvar.Transpose();

       //     double[,] Cd = Xvar.Multiply(XvarT).Divide(N).ToArray();

       //     //double[,] XT = new double[N, M];
       //     //double[,] C = new double[M,M];
       //     //alglib.ablas.rmatrixtranspose(M, N, X, 0, 0, ref XT, 0, 0);

       //     //alglib.ablas.rmatrixgemm(M, M, N, 1 / Ndouble, X, 0, 0, 0, XT, 0, 0, 0, 0, ref C, 0, 0);

       //     return Cd;


           
       //     //return Cd;
       // }

       public static double[,] get_covariance_matrix_AAT_alglib(double[,] X)
       {
           // C = AAT/N, n is the sample size, usually x*y 
           // get covariance matrix ATA if ncols > nrows
           int M = X.GetLength(0);
           int N = X.GetLength(1);
           double Ndouble = Convert.ToDouble(N);

           //var Xvar = new DenseMatrix(X);
           //var XvarT = Xvar.Transpose();

           //double[,] Cd = Xvar.Multiply(XvarT).Divide(N).ToArray();

           double[,] XT = new double[N, M];
           double[,] C = new double[M, M];
           alglib.ablas.rmatrixtranspose(M, N, X, 0, 0, ref XT, 0, 0);

           alglib.ablas.rmatrixgemm(M, M, N, 1 / Ndouble, X, 0, 0, 0, XT, 0, 0, 0, 0, ref C, 0, 0);

           return C;



           //return Cd;
       }

        public static double[,] get_covariance_matrix_ATA(double[,] X)
        {
            // get covariance matrix ATA if nrows > ncols
            int M = X.GetLength(0);
            int N = X.GetLength(1);
            double Ndouble = Convert.ToDouble(N);

            //var Xvar = new DenseMatrix(X);
            //var XvarT = Xvar.Transpose();

            double[,] XT = new double[N, M];
            double[,] C = new double[M, M];
            alglib.ablas.rmatrixtranspose(M, N, X, 0, 0, ref XT, 0, 0);
            alglib.ablas.rmatrixgemm(M, M, N, 1 / Ndouble, X, 0, 0, 0, XT, 0, 0, 0, 0, ref C, 0, 0);

            //double[,] Cd = XvarT.Multiply(Xvar).ToArray();
            return C;
            //return Cd;
        }

        static public void get_EVD(double[,] A, out double[] eigenvalues, out double[,] eigenvectors)
        {
                        //public static bool rmatrixevd(
            //double[,] a,
            //int n,
            //int vneeded,
            //out double[] wr,
            //out double[] wi,
            //out double[,] vl,
            //out double[,] vr)
            int N = A.GetLength(0);
            double[,] evec = new double[N, N];
            double[,] evright = new double[N, N];
            double[] evalues = new double[N];
            double[] evaluesi = new double[N];

            double[,] evec_reorder = new double[N, N];

            eigenvalues = new double[N];
            bool converged;
            //converged = alglib.evd.rmatrixevd(A, N, 3, ref evalues, ref evaluesi, ref evleft, ref evright);
            converged = alglib.evd.smatrixevd(A, N, 1, true, ref evalues, ref evec);

            for (int i = 0; i < N; i++)
            {
                eigenvalues[i] = evalues[N - 1 - i];
            }

            for (int i = 0; i < N; i++)
            {
                for (int j = 0; j < N; j++)
                {
                    evec_reorder[i, j] = evec[i, N - 1 - j];
                }
            }

            eigenvectors = evec_reorder;
        }

        static public double[,] get_EOFS_by_projection(double[,] X, double[,] eigenvectors)
        {
            int M = X.GetLength(0);
            int N = X.GetLength(1);
            double[,] evT = new double[M, M];

            double[,] EOFs = new double[M, N];
            double[,] EOFsT = new double[N, M];
            alglib.ablas.rmatrixtranspose(M, M, eigenvectors, 0, 0, ref evT, 0, 0);
            alglib.ablas.rmatrixgemm(M, N, M, 1, evT, 0, 0, 0, X, 0, 0, 0, 0, ref EOFs, 0, 0);

            alglib.ablas.rmatrixtranspose(M, N, EOFs, 0, 0, ref EOFsT, 0, 0);
            return EOFsT;
        }

        //static public double[] get_eigenvalues(DenseMatrix mat1)
        //{




        //    double[,] x = mat1.ToArray();
        //    int n = x.GetLength(0);
        //    double[] eval = new double[n];

        //    Evd eigen = new DenseEvd(mat1);
        //    Vector<System.Numerics.Complex> val = eigen.EigenValues();

        //    for (int i = 0; i < n; i++)
        //    {
        //        eval[i] = val[n - 1 - i].Real;
        //    }
        //    return eval;
        //}

        //static public double[,] get_eigenvectors(DenseMatrix mat1)
        //{


        //    double[,] x = mat1.ToArray();
        //    int nr = x.GetLength(0);
        //    int nc = x.GetLength(1);
        //    double[,] evec = new double[nr, nc];
        //    double[,] evec_reorder = new double[nr, nc];
        //    Evd eigen = new DenseEvd(mat1);
        //    evec = eigen.EigenVectors().ToArray();

        //    for (int i = 0; i < nr; i++)
        //    {
        //        for (int j = 0; j < nc; j++)
        //        {
        //            evec_reorder[i, j] = evec[i, nc - 1 - j];
        //        }
        //    }

        //    return evec_reorder;
        //}
    }
}
