﻿using System;

namespace Climate_toolkit
{
    /// <summary>
    /// This class reads the rdb header line and figures out the index of each field used in CSWSite.cs
    /// </summary>
    public class CSWIndexes
    {
        public CSWIndexes(string headerLn)
        {
            string[] fldNames = headerLn.Split('\t');
            Agency = Array.IndexOf(fldNames, "agency_cd");
            SiteNumber = Array.IndexOf(fldNames, "site_no");
            SiteName = Array.IndexOf(fldNames, "station_nm");
            Lat = Array.IndexOf(fldNames, "dec_lat_va");
            Long = Array.IndexOf(fldNames, "dec_long_va");
            LatLongDatum = Array.IndexOf(fldNames, "dec_coord_datum_cd");
            StartDt = Array.IndexOf(fldNames, "begin_date");
            EndDt = Array.IndexOf(fldNames, "end_date");
            Count = Array.IndexOf(fldNames, "count_nu");
        }

        public int Agency { get; private set; }
        public int SiteNumber { get; private set; }
        public int SiteName { get; private set; }
        public int Lat { get; private set; }
        public int Long { get; private set; }
        public int LatLongDatum { get; private set; }
        public int StartDt { get; private set; }
        public int EndDt { get; private set; }
        public int Count { get; private set; }

    }
}
