﻿namespace Climate_toolkit
{
    public class CSWSite
    {

        public CSWSite(CSWIndexes indexes, string siteLn)
        {
            string[] siteVals = siteLn.Trim().Split('\t');
            agencyCd = siteVals[indexes.Agency];
            siteNumber = siteVals[indexes.SiteNumber];
            siteName = siteVals[indexes.SiteName];
            lat_dec = siteVals[indexes.Lat];
            long_dec = siteVals[indexes.Long];
            latlong_dec_datum = siteVals[indexes.LatLongDatum];
            startDt = siteVals[indexes.StartDt];
            endDt = siteVals[indexes.EndDt];
            swCnt = siteVals[indexes.Count];
            dataType = "Streamflow";
            queryURL =
                "http://waterservices.usgs.gov/nwis/dv/?format=waterml,1.1&sites=";
            queryURL += siteNumber;
            queryURL += "&";
            if (!string.IsNullOrEmpty(startDt)) queryURL += "startDT=" + startDt + "&";
            if (!string.IsNullOrEmpty(endDt)) queryURL += "endDT=" + endDt + "&";
            queryURL += "siteType=ST";
        }

        public string queryURL { get; private set; }
        public string siteName { get; private set; }
        public string siteNumber { get; private set; }
        public string agencyCd { get; private set; }
        public string lat_dec { get; private set; }
        public string long_dec { get; private set; }
        public string latlong_dec_datum { get; private set; }
        public string startDt { get; private set; }
        public string endDt { get; private set; }
        public string swCnt { get; private set; }
        public string dataType { get; private set; }

    }
}
