﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace Climate_toolkit
{
    public class CTablesFactory
    {
        private Cdatamaster datamaster;

        public CTablesFactory(Cdatamaster datamasterToUse)
        {
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            add_basic_tables();
            build_datatable_sites();
            build_datatable_preprocess();
            foreach (DataTable tab in datamaster.Tables)
            {
                string x = tab.TableName;

            }
        }

        public void add_basic_tables()
        {
            DataTable sites = new DataTable(); // holds ID, tablenames for tables that hold data, and attributes for each site
            DataTable preprocess = new DataTable(); // holds ID, tablenames for tables that hold data, and processing parameters
            DataTable sta = new DataTable(); // holds ID, tablenames for tables that hold data, and processing parameters

            sites.TableName = "sites";
            preprocess.TableName = "preprocess";
            sta.TableName = "sta";

            // add the datatable to datamaster
            this.datamaster.Tables.Add(sites);
            this.datamaster.Tables.Add(preprocess);
            this.datamaster.Tables.Add(sta);
        }

        public void build_datatable_sites()
        {
            DataColumn sitesPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn sitesIDColumn = new DataColumn("ID", typeof(string));
            DataColumn sitesTablenameColumn = new DataColumn("DataTablename", typeof(string));
            DataColumn sitesSiteIDColumn = new DataColumn("SiteID", typeof(string));
            DataColumn sitesStationNameColumn = new DataColumn("StationName", typeof(string));
            DataColumn sitesCommentsColumn = new DataColumn("Comments", typeof(string));
            DataColumn sitesLatitudeDMSColumn = new DataColumn("LatitudeDMS", typeof(float));
            DataColumn sitesLongitudeDMSColumn = new DataColumn("LongitudeDMS", typeof(float));
            DataColumn sitesLatLongDMSDatumColumn = new DataColumn("LatlongDMSDatum", typeof(string));
            DataColumn sitesLatitudeDECColumn = new DataColumn("LatitudeDEC", typeof(float));
            DataColumn sitesLongitudeDECColumn = new DataColumn("LongitudeDEC", typeof(float));
            DataColumn sitesLatlongDECDatumColumn = new DataColumn("LatlongDECDatum", typeof(string));
            DataColumn sitesUTMNColumn = new DataColumn("UTMN", typeof(float));
            DataColumn sitesUTMEColumn = new DataColumn("UTME", typeof(float));
            DataColumn sitesZoneColumn = new DataColumn("Zone", typeof(string));
            DataColumn sitesUTMDatumColumn = new DataColumn("UTMDatum", typeof(string));
            DataColumn sitesDataTypeColumn = new DataColumn("DataType", typeof(string));
            DataColumn sitesTimeUnitsColumn = new DataColumn("TimeUnits", typeof(string));
            DataColumn sitesVarUnitsColumn = new DataColumn("VarUnits", typeof(string));
            DataColumn sitesDataFormColumn = new DataColumn("DataForm", typeof(string));
            DataColumn sitesDim1Column = new DataColumn("Dim1", typeof(int));
            DataColumn sitesDim2Column = new DataColumn("Dim2", typeof(int));
            DataColumn sitesDim3Column = new DataColumn("Dim3", typeof(int));

            //sitesPrimaryKey.AutoIncrement = true;
            //sitesPrimaryKey.AutoIncrementSeed = 0;
            //sitesPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.datamaster.Tables["sites"].Columns.AddRange(new DataColumn[]
            {sitesPrimaryKey,sitesIDColumn,sitesTablenameColumn,sitesSiteIDColumn,sitesStationNameColumn,
                sitesCommentsColumn,sitesLatitudeDMSColumn,sitesLongitudeDMSColumn,sitesLatLongDMSDatumColumn,
                sitesLatitudeDECColumn,sitesLongitudeDECColumn,sitesLatlongDECDatumColumn,sitesUTMNColumn,
                sitesUTMEColumn,sitesZoneColumn,sitesUTMDatumColumn,sitesDataTypeColumn,sitesTimeUnitsColumn,
                sitesVarUnitsColumn, sitesDataFormColumn, sitesDim1Column, sitesDim2Column, sitesDim3Column
            });


        }
        public void build_datatable_preprocess()
        {
            DataColumn preprocessPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn preprocessIDColumn = new DataColumn("ID", typeof(string));
            DataColumn preprocessTablenameColumn = new DataColumn("DataTablename", typeof(string));
            DataColumn preprocessOperation = new DataColumn("Operation", typeof(string));
            DataColumn preprocessParsTablename = new DataColumn("ParsTablename", typeof(string));

            preprocessPrimaryKey.AutoIncrement = true;
            preprocessPrimaryKey.AutoIncrementSeed = 0;
            preprocessPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.datamaster.Tables["Preprocess"].Columns.AddRange(new DataColumn[]
            {preprocessPrimaryKey,preprocessIDColumn,preprocessTablenameColumn,preprocessOperation,preprocessParsTablename,
            });

        }
    }
}
