﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace Climate_toolkit
{
    [Serializable]
    public class Cdatamaster : DataSet
    {
        public DataSet dataset = new DataSet();
        // constructor

        

        public Cdatamaster()
        {
            this.dataset = new DataSet();

             //One nice reason to do it here is, if for some reason you needed to have
             //varables passed to the new DataSet(), you could have them here.  Done 
             //the way it's done up above, you can only call a constructor that
             //takes zero parameters, or pass constants like integers. 

            add_basic_tables();
            build_datatable_sites();
            //build_datatable_preprocess();
            build_datatable_Fourier();
            build_datatable_SSA();
            build_datatable_SSA_vectors();
            build_datatable_EOF();
            build_datatable_EOF_SPC_vectors();
            build_datatable_EOF_scaledEOF_vectors();
            build_datatable_AR();
            build_datatable_Regression();
            build_datatable_Projection();
            build_datatable_ProjectionSum();
            build_datatable_interpolation();
            build_datatable_standardize();
            build_datatable_cumulative_departure();
            build_datatable_Differencing();
            build_datatable_CurveFitting();
            build_datatable_MEM();
            build_datatable_ACF();
            build_datatable_CCF();

            foreach (DataTable tab in this.dataset.Tables)
            {
                string x = tab.TableName;

            }
        }





        private void add_basic_tables()
        {
            DataTable sites = new DataTable(); // holds ID, tablenames for tables that hold data, and attributes for each site
            DataTable preprocess = new DataTable(); // holds ID, tablenames for tables that hold data, and processing parameters
            DataTable stationarity = new DataTable(); // holds ID, tablenames for tables that hold data, and processing parameters
            DataTable Fourier = new DataTable(); // holds ID, tablenames for tables that hold results and parameters
            DataTable SSA = new DataTable(); // holds ID, tablenames for tables that hold results and parameters
            DataTable SSA_vectors = new DataTable();
            DataTable EOF = new DataTable(); // holds ID, tablenames for tables that hold results and parameters
            DataTable EOF_SPC_vectors = new DataTable();
            DataTable EOF_ScaledEOF_vectors = new DataTable();
            DataTable AR = new DataTable();
            DataTable Regression = new DataTable();
            DataTable Projection = new DataTable();
            DataTable ProjectionSum = new DataTable();

            DataTable Interpolation = new DataTable();
            DataTable Standardize = new DataTable();
            DataTable CumulativeDeparture = new DataTable();
            DataTable CurveFitting = new DataTable();
            DataTable Differencing = new DataTable();
            DataTable MEM = new DataTable();
            DataTable CCF = new DataTable();
            DataTable ACF = new DataTable();

            sites.TableName = "sites";
            preprocess.TableName = "preprocess";
            stationarity.TableName = "stationarity";
            Fourier.TableName = "Fourier";
            SSA.TableName = "SSA";
            SSA_vectors.TableName = "SSA_vectors";
            EOF.TableName = "EOF";
            EOF_SPC_vectors.TableName = "EOF_SPC_vectors";
            EOF_ScaledEOF_vectors.TableName = "EOF_ScaledEOF_vectors";
            AR.TableName = "AR";
            Regression.TableName = "Regression";
            Projection.TableName = "Projection";
            ProjectionSum.TableName = "ProjectionSum";

            Interpolation.TableName = "Interpolation";
            Standardize.TableName = "Standardize";
            CumulativeDeparture.TableName = "CumulativeDeparture";
            CurveFitting.TableName = "CurveFitting";
            Differencing.TableName = "Differencing";
            MEM.TableName = "MEM";
            CCF.TableName = "CCF";
            ACF.TableName = "ACF";

            // add the datatables to datamaster

            this.Tables.Add(sites);
            //this.Tables.Add(preprocess);
            //this.Tables.Add(stationarity);
            this.Tables.Add(Fourier);
            this.Tables.Add(SSA);
            this.Tables.Add(SSA_vectors);
            this.Tables.Add(EOF);
            this.Tables.Add(EOF_SPC_vectors);
            this.Tables.Add(EOF_ScaledEOF_vectors);
            this.Tables.Add(AR);
            this.Tables.Add(Regression);
            this.Tables.Add(Projection);
            this.Tables.Add(ProjectionSum);

            this.Tables.Add(Interpolation);
            this.Tables.Add(Standardize);
            this.Tables.Add(CumulativeDeparture);
            this.Tables.Add(CurveFitting);
            this.Tables.Add(Differencing);
            this.Tables.Add(MEM);
            this.Tables.Add(CCF);
            this.Tables.Add(ACF);
        }


        private void build_datatable_sites()
        {
            DataColumn sitesPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn sitesIDColumn = new DataColumn("ID", typeof(string));
            DataColumn sitesTablenameColumn = new DataColumn("DataTablename", typeof(string));
            DataColumn sitesSiteIDColumn = new DataColumn("SiteID", typeof(string));
            DataColumn sitesStationNameColumn = new DataColumn("StationName", typeof(string));
            DataColumn sitesCommentsColumn = new DataColumn("Comments", typeof(string));
            DataColumn sitesLatitudeDMSColumn = new DataColumn("LatitudeDMS", typeof(string));
            DataColumn sitesLongitudeDMSColumn = new DataColumn("LongitudeDMS", typeof(string));
            DataColumn sitesLatLongDMSDatumColumn = new DataColumn("LatlongDMSDatum", typeof(string));
            DataColumn sitesLatitudeDECColumn = new DataColumn("LatitudeDEC", typeof(string));
            DataColumn sitesLongitudeDECColumn = new DataColumn("LongitudeDEC", typeof(string));
            DataColumn sitesLatlongDECDatumColumn = new DataColumn("LatlongDECDatum", typeof(string));
            DataColumn sitesUTMNColumn = new DataColumn("UTMN", typeof(string));
            DataColumn sitesUTMEColumn = new DataColumn("UTME", typeof(string));
            DataColumn sitesZoneColumn = new DataColumn("Zone", typeof(string));
            DataColumn sitesUTMDatumColumn = new DataColumn("UTMDatum", typeof(string));
            DataColumn sitesDataTypeColumn = new DataColumn("DataType", typeof(string));
            DataColumn sitesTimeUnitsColumn = new DataColumn("TimeUnits", typeof(string));
            DataColumn sitesVarUnitsColumn = new DataColumn("VarUnits", typeof(string));
            DataColumn sitesDataFormColumn = new DataColumn("DataForm", typeof(string));
            DataColumn sitesDim1Column = new DataColumn("Dim1", typeof(int));
            DataColumn sitesDim2Column = new DataColumn("Dim2", typeof(int));
            DataColumn sitesDim3Column = new DataColumn("Dim3", typeof(int));
            DataColumn sitesDescriptiveStatisticsTable = new DataColumn("DescriptiveStatisticsTablename", typeof(string));

            //sitesPrimaryKey.AutoIncrement = true;
            //sitesPrimaryKey.AutoIncrementSeed = 0;
            //sitesPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["sites"].Columns.AddRange(new DataColumn[]
            {sitesPrimaryKey,sitesIDColumn,sitesTablenameColumn,sitesSiteIDColumn,sitesStationNameColumn,
                sitesCommentsColumn,sitesLatitudeDMSColumn,sitesLongitudeDMSColumn,sitesLatLongDMSDatumColumn,
                sitesLatitudeDECColumn,sitesLongitudeDECColumn,sitesLatlongDECDatumColumn,sitesUTMNColumn,
                sitesUTMEColumn,sitesZoneColumn,sitesUTMDatumColumn,sitesDataTypeColumn,sitesTimeUnitsColumn,
                sitesVarUnitsColumn, sitesDataFormColumn, sitesDim1Column, sitesDim2Column, sitesDim3Column,sitesDescriptiveStatisticsTable
            });
            //this.Tables["sites"].Rows.Add();

        }
        //private void build_datatable_preprocess()
        //{
        //    DataColumn preprocessPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
        //    DataColumn preprocessIDColumn = new DataColumn("ID", typeof(string));
        //    DataColumn preprocessTablenameColumn = new DataColumn("DataTablename", typeof(string));
        //    DataColumn preprocessOperation = new DataColumn("Operation", typeof(string));
        //    DataColumn preprocessParsTablename = new DataColumn("ParsTablename", typeof(string));

        //    preprocessPrimaryKey.AutoIncrement = true;
        //    preprocessPrimaryKey.AutoIncrementSeed = 0;
        //    preprocessPrimaryKey.AutoIncrementStep = 1;
        //    // add the columns to the table
        //    this.Tables["Preprocess"].Columns.AddRange(new DataColumn[]
        //    {preprocessPrimaryKey,preprocessIDColumn,preprocessTablenameColumn,preprocessOperation,preprocessParsTablename,
        //    });
        //}

        private void build_datatable_interpolation()
        {
            DataColumn intpPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn intpIDColumn = new DataColumn("ID", typeof(string));
            DataColumn intpSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn intpSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn intpMethodColumn = new DataColumn("InterpMethod", typeof(string));
            DataColumn intpStartColumn = new DataColumn("InterpStart", typeof(int));
            DataColumn intpEndColumn = new DataColumn("InterpEnd", typeof(int));
            DataColumn intpNumpointsColumn = new DataColumn("InterpNumpoints", typeof(int));
            DataColumn intpOperation = new DataColumn("Operation", typeof(string));

            intpPrimaryKey.AutoIncrement = true;
            intpPrimaryKey.AutoIncrementSeed = 0;
            intpPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["Interpolation"].Columns.AddRange(new DataColumn[] { intpPrimaryKey, intpIDColumn, intpSeriesnameinColumn,
                intpSeriesnameoutColumn,intpMethodColumn,intpStartColumn,intpEndColumn,intpNumpointsColumn,intpOperation
            });
            //this.Tables["Interpolation"].Rows.Add();
        }

        private void build_datatable_standardize()
        {
            DataColumn stanPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn stanIDColumn = new DataColumn("ID", typeof(string));
            DataColumn stanSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn stanSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn stanMethodColumn = new DataColumn("StandardizeMethod", typeof(string));
            DataColumn stanMeanColumn = new DataColumn("Mean", typeof(double));
            DataColumn stanVarianceColumn = new DataColumn("Variance", typeof(double));
            DataColumn stanAlphaColumn = new DataColumn("Alpha", typeof(double));
            DataColumn stanBetaColumn = new DataColumn("Beta", typeof(double));
            DataColumn stanOperation = new DataColumn("Operation", typeof(string));

            stanPrimaryKey.AutoIncrement = true;
            stanPrimaryKey.AutoIncrementSeed = 0;
            stanPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["Standardize"].Columns.AddRange(new DataColumn[] { stanPrimaryKey, stanIDColumn, stanSeriesnameinColumn, 
                stanSeriesnameoutColumn, stanMethodColumn,stanMeanColumn,stanVarianceColumn,stanAlphaColumn,stanBetaColumn,stanOperation });
            //this.Tables["Standardize"].Rows.Add();
        }

        private void build_datatable_cumulative_departure()
        {
            DataColumn cdepPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn cdepIDColumn = new DataColumn("ID", typeof(string));
            DataColumn cdepSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn cdepSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn cdepMeanColumn = new DataColumn("Mean", typeof(double));
            DataColumn cdepOperation = new DataColumn("Operation", typeof(string));

            cdepPrimaryKey.AutoIncrement = true;
            cdepPrimaryKey.AutoIncrementSeed = 0;
            cdepPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["CumulativeDeparture"].Columns.AddRange(new DataColumn[]
            {cdepPrimaryKey, cdepIDColumn, cdepSeriesnameinColumn, cdepSeriesnameoutColumn, cdepMeanColumn,cdepOperation });
            //this.Tables["CumulativeDeparture"].Rows.Add();
        }

        private void build_datatable_Differencing()
        {
            DataColumn DifferencingPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn DifferencingIDColumn = new DataColumn("ID", typeof(string));
            DataColumn DifferencingSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn DifferencingSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn DifferencingOrderColumn = new DataColumn("Order", typeof(int));
            DataColumn DifferencingOperation = new DataColumn("Operation", typeof(string));

            DifferencingPrimaryKey.AutoIncrement = true;
            DifferencingPrimaryKey.AutoIncrementSeed = 0;
            DifferencingPrimaryKey.AutoIncrementStep = 1;

            // add the columns to the table
            this.Tables["Differencing"].Columns.AddRange(new DataColumn[]
            {DifferencingPrimaryKey,DifferencingIDColumn,DifferencingSeriesnameinColumn,
                DifferencingSeriesnameoutColumn,DifferencingOrderColumn,DifferencingOperation
            });
            //this.Tables["Differencing"].Rows.Add();
        }

        private void build_datatable_CurveFitting()
        {
            DataColumn CurveFittingPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn CurveFittingIDColumn = new DataColumn("ID", typeof(string));
            DataColumn CurveFittingSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn CurveFittingCurvenameoutColumn = new DataColumn("Curvenameout", typeof(string));
            DataColumn CurveFittingResidualsnameoutColumn = new DataColumn("Residualsnameout", typeof(string));
            DataColumn CurveFittingMethodColumn = new DataColumn("Method", typeof(string));
            DataColumn CurveFittingOperationColumn = new DataColumn("Operation", typeof(string));

            CurveFittingPrimaryKey.AutoIncrement = true;
            CurveFittingPrimaryKey.AutoIncrementSeed = 0;
            CurveFittingPrimaryKey.AutoIncrementStep = 1;

            // add the columns to the table
            this.Tables["CurveFitting"].Columns.AddRange(new DataColumn[]
            {CurveFittingPrimaryKey,CurveFittingIDColumn,CurveFittingSeriesnameinColumn,CurveFittingCurvenameoutColumn,
                CurveFittingResidualsnameoutColumn,CurveFittingMethodColumn,CurveFittingOperationColumn
            });
            //this.Tables["CurveFitting"].Rows.Add();
        }

        private void build_datatable_Fourier()
        {
            DataColumn FourierPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn FourierIDColumn = new DataColumn("ID", typeof(string));
            DataColumn FourierSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn FourierSpectrumnameoutColumn = new DataColumn("Spectrumnameout", typeof(string));
            DataColumn FourierSampleIntervalColumn = new DataColumn("SampleInterval", typeof(double));
            DataColumn FourierSigTestColumn = new DataColumn("SigTest", typeof(string));
            DataColumn FourierWindowColumn = new DataColumn("Window", typeof(string));
            DataColumn FourierSmoothingWindowWidthColumn = new DataColumn("SmoothingWidth", typeof(int));
            DataColumn FourierNumberRealizationsColumn = new DataColumn("NumberRealizations", typeof(int));
            DataColumn FourierOperation = new DataColumn("Operation", typeof(string));

            FourierPrimaryKey.AutoIncrement = true;
            FourierPrimaryKey.AutoIncrementSeed = 0;
            FourierPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["Fourier"].Columns.AddRange(new DataColumn[]
            {FourierPrimaryKey,FourierIDColumn,FourierSeriesnameinColumn,FourierSpectrumnameoutColumn,FourierSampleIntervalColumn,
                FourierSigTestColumn,FourierWindowColumn,FourierSmoothingWindowWidthColumn,FourierNumberRealizationsColumn,
                FourierOperation
            });
            //this.Tables["Fourier"].Rows.Add();
        }

        private void build_datatable_MEM()
        {
            DataColumn MEMPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn MEMIDColumn = new DataColumn("ID", typeof(string));
            DataColumn MEMSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn MEMSpectrumnameoutColumn = new DataColumn("Spectrumnameout", typeof(string));
            DataColumn MEMSampleIntervalColumn = new DataColumn("SampleInterval", typeof(double));
            DataColumn MEMOrderColumn = new DataColumn("MEMOrder", typeof(int));
            DataColumn MEMOperation = new DataColumn("Operation", typeof(string));

            MEMPrimaryKey.AutoIncrement = true;
            MEMPrimaryKey.AutoIncrementSeed = 0;
            MEMPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["MEM"].Columns.AddRange(new DataColumn[]
            {MEMPrimaryKey,MEMIDColumn,MEMSeriesnameinColumn,MEMSpectrumnameoutColumn,MEMSampleIntervalColumn,
                MEMOrderColumn,MEMOperation
            });
            //this.Tables["MEM"].Rows.Add();
        }

        private void build_datatable_SSA()
        {
            DataColumn SSAPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn SSAIDColumn = new DataColumn("ID", typeof(string));
            DataColumn SSASeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn SSASpectrumnameoutColumn = new DataColumn("Spectrumnameout", typeof(string));
            DataColumn SSATEOFnameoutMatrixColumn = new DataColumn("TEOFnameoutMatrix", typeof(string));
            DataColumn SSATPCnameoutMatrixColumn = new DataColumn("TPCnameoutMatrix", typeof(string));
            DataColumn SSARCnameoutMatrixColumn = new DataColumn("RCnameoutMatrix", typeof(string));

            DataColumn SSAIntervalColumn = new DataColumn("Interval", typeof(double));
            DataColumn SSAWindowColumn = new DataColumn("Window", typeof(int));
            DataColumn SSAOperation = new DataColumn("Operation", typeof(string));

            SSAPrimaryKey.AutoIncrement = true;
            SSAPrimaryKey.AutoIncrementSeed = 0;
            SSAPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["SSA"].Columns.AddRange(new DataColumn[]
            {SSAPrimaryKey,SSAIDColumn,SSASeriesnameinColumn,SSASpectrumnameoutColumn,SSATEOFnameoutMatrixColumn,
                SSATPCnameoutMatrixColumn,SSARCnameoutMatrixColumn,
                SSAIntervalColumn,SSAWindowColumn,SSAOperation
            });
            //this.Tables["SSA"].Rows.Add();
        }

        private void build_datatable_SSA_vectors()
        {
            DataColumn SSAPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn SSAIDColumn = new DataColumn("ID", typeof(string));
            DataColumn SSASeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn SSARCnameoutVectorColumn = new DataColumn("RCnameoutVector", typeof(string));
            DataColumn SSAResidualnameoutVectorColumn = new DataColumn("ResidualnameoutVector", typeof(string));
            DataColumn SSAInlengthColumn = new DataColumn("Inlength", typeof(int));
            DataColumn SSAOutlengthColumn = new DataColumn("Outlength", typeof(int));

            SSAPrimaryKey.AutoIncrement = true;
            SSAPrimaryKey.AutoIncrementSeed = 0;
            SSAPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["SSA_vectors"].Columns.AddRange(new DataColumn[]
            {SSAPrimaryKey,SSAIDColumn,SSASeriesnameinColumn,SSARCnameoutVectorColumn,
                SSAResidualnameoutVectorColumn, SSAInlengthColumn, SSAOutlengthColumn});
            //this.Tables["SSA_vectors"].Rows.Add();
        }

        private void build_datatable_EOF()
        {
            DataColumn EOFPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn EOFIDColumn = new DataColumn("ID", typeof(string));
            DataColumn EOFSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn EOFEigennameoutColumn = new DataColumn("Eigennameout", typeof(string));
            DataColumn EOFSEOFnameoutMatrixColumn = new DataColumn("SEOFnameoutMatrix", typeof(string));
            DataColumn EOFSPCnameoutMatrixColumn = new DataColumn("SPCnameoutMatrix", typeof(string));
            DataColumn EOFScalednameoutMatrixColumn = new DataColumn("SEOFScalednameoutMatrix", typeof(string));
            DataColumn EOFLatitudeMinColumn = new DataColumn("LatitudeMin", typeof(double));
            DataColumn EOFLatitudeMaxColumn = new DataColumn("LatitudeMax", typeof(double));
            DataColumn EOFOperation = new DataColumn("Operation", typeof(string));

            EOFPrimaryKey.AutoIncrement = true;
            EOFPrimaryKey.AutoIncrementSeed = 0;
            EOFPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["EOF"].Columns.AddRange(new DataColumn[]
            {EOFPrimaryKey,EOFIDColumn,EOFSeriesnameinColumn,EOFEigennameoutColumn,EOFSEOFnameoutMatrixColumn,
                EOFSPCnameoutMatrixColumn,EOFScalednameoutMatrixColumn,
                EOFLatitudeMinColumn,EOFLatitudeMaxColumn,EOFOperation});
            //this.Tables["EOF"].Rows.Add();
        }

        private void build_datatable_EOF_scaledEOF_vectors()
        {
            DataColumn EOFPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn EOFIDColumn = new DataColumn("ID", typeof(string));
            DataColumn EOFSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn EOFScalednameoutVectorColumn = new DataColumn("SEOFScalednameoutVector", typeof(string));

            EOFPrimaryKey.AutoIncrement = true;
            EOFPrimaryKey.AutoIncrementSeed = 0;
            EOFPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["EOF_ScaledEOF_vectors"].Columns.AddRange(new DataColumn[]
            {EOFPrimaryKey,EOFIDColumn,EOFSeriesnameinColumn,EOFScalednameoutVectorColumn});
            //this.Tables["EOF_ScaledEOF_vectors"].Rows.Add();
        }

        private void build_datatable_EOF_SPC_vectors()
        {
            DataColumn EOFPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn EOFIDColumn = new DataColumn("ID", typeof(string));
            DataColumn EOFSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn EOFSPCnameoutVectorColumn = new DataColumn("SPCnameoutVector", typeof(string));

            EOFPrimaryKey.AutoIncrement = true;
            EOFPrimaryKey.AutoIncrementSeed = 0;
            EOFPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["EOF_SPC_vectors"].Columns.AddRange(new DataColumn[] { EOFPrimaryKey, EOFIDColumn, EOFSeriesnameinColumn, EOFSPCnameoutVectorColumn });
            //this.Tables["EOF_SPC_vectors"].Rows.Add();
        }

        private void build_datatable_AR()
        {
            DataColumn ARPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn ARIDColumn = new DataColumn("ID", typeof(string));
            DataColumn ARSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn ARSeriesnameSimoutColumn = new DataColumn("SeriesnameSimout", typeof(string));
            DataColumn ARSeriesnameResidualsoutColumn = new DataColumn("SeriesnameResidualsout", typeof(string));
            DataColumn ARSeriesnameResidualsACFoutColumn = new DataColumn("SeriesnameResidualsACFout", typeof(string));
            DataColumn ARSeriesnameARFitStatisticsoutColumn = new DataColumn("SeriesnameARFitStatisticsout", typeof(string));
            DataColumn ARSeriesnameARCoeffoutColumn = new DataColumn("SeriesnameARCoeffout", typeof(string));
            DataColumn AROrderColumn = new DataColumn("Order", typeof(string));
            DataColumn AROperation = new DataColumn("Operation", typeof(string));

            ARPrimaryKey.AutoIncrement = true;
            ARPrimaryKey.AutoIncrementSeed = 0;
            ARPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["AR"].Columns.AddRange(new DataColumn[]
            {ARPrimaryKey,ARIDColumn,ARSeriesnameinColumn,ARSeriesnameSimoutColumn,ARSeriesnameResidualsoutColumn,
                ARSeriesnameResidualsACFoutColumn,ARSeriesnameARFitStatisticsoutColumn,ARSeriesnameARCoeffoutColumn,
                AROrderColumn,AROperation
            });
            //this.Tables["AR"].Rows.Add();
        }

        private void build_datatable_Regression()
        {
            DataColumn RegressionPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn RegressionIDColumn = new DataColumn("ID", typeof(string));
            DataColumn RegressionPredictorSeriesnameinColumn = new DataColumn("PredictorSeriesnamein", typeof(string));
            DataColumn RegressionPredictandSeriesnameinColumn = new DataColumn("PredictandSeriesnamein", typeof(string));
            DataColumn RegressionSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn RegressionStatisticsColumn = new DataColumn("RegressionStatistics", typeof(string));
            DataColumn RegressionOperation = new DataColumn("Operation", typeof(string));

            RegressionPrimaryKey.AutoIncrement = true;
            RegressionPrimaryKey.AutoIncrementSeed = 0;
            RegressionPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["Regression"].Columns.AddRange(new DataColumn[]
            {RegressionPrimaryKey,RegressionIDColumn,RegressionPredictorSeriesnameinColumn,RegressionPredictandSeriesnameinColumn,
                RegressionSeriesnameoutColumn,RegressionStatisticsColumn,RegressionOperation
            });
            //this.Tables["Regression"].Rows.Add();
        }

        private void build_datatable_ACF()
        {
            DataColumn ACFPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn ACFIDColumn = new DataColumn("ID", typeof(string));
            DataColumn ACFSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn ACFSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn ACFOperation = new DataColumn("Operation", typeof(string));

            ACFPrimaryKey.AutoIncrement = true;
            ACFPrimaryKey.AutoIncrementSeed = 0;
            ACFPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["ACF"].Columns.AddRange(new DataColumn[]
            {ACFPrimaryKey,ACFIDColumn,ACFSeriesnameinColumn,ACFSeriesnameoutColumn,ACFOperation
            });
            //this.Tables["ACF"].Rows.Add();
        }

        private void build_datatable_CCF()
        {
            DataColumn CCFPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn CCFIDColumn = new DataColumn("ID", typeof(string));
            DataColumn CCFSeriesnameinColumn = new DataColumn("Seriesnamein", typeof(string));
            DataColumn CCFSeriesnameoutColumn = new DataColumn("Seriesnameout", typeof(string));
            DataColumn CCFOperation = new DataColumn("Operation", typeof(string));

            CCFPrimaryKey.AutoIncrement = true;
            CCFPrimaryKey.AutoIncrementSeed = 0;
            CCFPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["CCF"].Columns.AddRange(new DataColumn[]
            {CCFPrimaryKey,CCFIDColumn,CCFSeriesnameinColumn,CCFSeriesnameoutColumn,CCFOperation
            });
            //this.Tables["CCF"].Rows.Add();
        }

        private void build_datatable_Projection()
        {
            DataColumn ProjectionPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn ProjectionIDColumn = new DataColumn("ID", typeof(string));
            DataColumn ProjectionSeriesnamein = new DataColumn("Seriesnamein", typeof(string));
            DataColumn ProjectionSeriesnameout = new DataColumn("Seriesnameout", typeof(string));
            DataColumn ProjectionSeriesnameinLength = new DataColumn("SeriesnameinLength", typeof(int));
            DataColumn ProjectionLength = new DataColumn("Length", typeof(int));
            DataColumn ProjectionNumRealizations = new DataColumn("NumRealizations", typeof(int));
            DataColumn ProjectionOperation = new DataColumn("Operation", typeof(string));


            ProjectionPrimaryKey.AutoIncrement = true;
            ProjectionPrimaryKey.AutoIncrementSeed = 0;
            ProjectionPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["Projection"].Columns.AddRange(new DataColumn[]
            {ProjectionPrimaryKey,ProjectionIDColumn,ProjectionSeriesnamein,ProjectionSeriesnameout,ProjectionSeriesnameinLength,
                ProjectionLength,ProjectionNumRealizations,ProjectionOperation});
            //this.Tables["Projection"].Rows.Add();
        }

        private void build_datatable_ProjectionSum()
        {
            DataColumn ProjectionSumPrimaryKey = new DataColumn("PrimaryKey", typeof(int));
            DataColumn ProjectionSumIDColumn = new DataColumn("ID", typeof(string));
            DataColumn ProjectionSumSeriesnamein = new DataColumn("Seriesnamein", typeof(string));
            DataColumn ProjectionSumSeriesnameout = new DataColumn("Seriesnameout", typeof(string));
            DataColumn ProjectionSumSeriesmean = new DataColumn("Seriesnameoutmean", typeof(string));
            DataColumn ProjectionSumSerieslower = new DataColumn("Seriesnameoutlower", typeof(string));
            DataColumn ProjectionSumSeriesupper = new DataColumn("Seriesnameoutupper", typeof(string));
            DataColumn ProjectionSumSeriesmin = new DataColumn("Seriesnameoutmin", typeof(string));
            DataColumn ProjectionSumSeriesmax = new DataColumn("Seriesnameoutmax", typeof(string));
            DataColumn ProjectionSumSeriesrand1 = new DataColumn("Seriesnameoutrand1", typeof(string));
            DataColumn ProjectionSumSeriesrand2 = new DataColumn("Seriesnameoutrand2", typeof(string));
            DataColumn ProjectionSumSeriesrand3 = new DataColumn("Seriesnameoutrand3", typeof(string));
            DataColumn ProjectionSumSeriesnameinLength = new DataColumn("SeriesnameinLength", typeof(int));
            DataColumn ProjectionSumLength = new DataColumn("Length", typeof(int));
            DataColumn ProjectionSumNumRealizations = new DataColumn("NumRealizations", typeof(int));
            DataColumn ProjectionSumOperation = new DataColumn("Operation", typeof(string));


            ProjectionSumPrimaryKey.AutoIncrement = true;
            ProjectionSumPrimaryKey.AutoIncrementSeed = 0;
            ProjectionSumPrimaryKey.AutoIncrementStep = 1;
            // add the columns to the table
            this.Tables["ProjectionSum"].Columns.AddRange(new DataColumn[]
            {ProjectionSumPrimaryKey,ProjectionSumIDColumn,ProjectionSumSeriesnamein,ProjectionSumSeriesnameout,
                ProjectionSumSeriesmean, ProjectionSumSerieslower, ProjectionSumSeriesupper,ProjectionSumSeriesmin,
                ProjectionSumSeriesmax, ProjectionSumSeriesrand1, ProjectionSumSeriesrand2, ProjectionSumSeriesrand3,                              
                ProjectionSumSeriesnameinLength, ProjectionSumLength,ProjectionSumNumRealizations,ProjectionSumOperation});
                
            //this.Tables["Projection"].Rows.Add();
        }
    }
}
