﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Data.OleDb;
using System.Windows.Forms.DataVisualization.Charting;
using System.Runtime.Serialization.Formatters.Binary;

namespace Climate_toolkit
{

    public partial class FormToolkit : Form
    {
        Cdatamaster datamaster = new Cdatamaster();

        bool savefileexists = false;
        bool showplot = true;

        string savefilename = null;
        string projectname = null;
        
        string selecteddataseriesname;
        string selecteddataseriesname_predictand;
        string selecteddataseriesname_preprocess;

        string selecteddataseriesname_preprocess_interpolate;
        string selecteddataseriesname_preprocess_interpolate_input;
        string selecteddataseriesname_preprocess_interpolate_output;
        string selecteddataseriesname_preprocess_standardize_input;
        string selecteddataseriesname_preprocess_standardize_output;
        string selecteddataseriesname_preprocess_cumdep_input;
        string selecteddataseriesname_preprocess_cumdep_output;

        string selectedseries_mostrecent;

        string selecteddataseriesname_preprocess_standardize;
        string selecteddataseriesname_preprocess_cumdep;
        string selectedinterpmethod;

        double interp_startdate;
        double interp_enddate;
        int interp_numpoints;

    
        string selecteddataseriesname_stationarity_detrend_input;
        string selecteddataseriesname_stationarity_detrend_trend_output;
        string selecteddataseriesname_stationarity_detrend_residuals_output;

        string selecteddataseriesname_detrend_differencing_input;
        string selecteddataseriesname_detrend_differencing_trend_output;
        string selecteddataseriesname_detrend_differencing_residuals_output;

        string selecteddataseriesname_detrend_spline_trend_output;
        string selecteddataseriesname_detrend_spline_residuals_output;

        string selecteddetrendmethod;


        // variables for clamped cubic spline
        double fp0;
        double fpn;

        // variables for standardizing data
        string selectedstandardmethod;

        // variables for removing nonstationarity
        int num_autocorrelation_lags;

        // variables for SSA analysis
        string selected_SSA_method;

        // variables for AR model;
        string selectedARstatisic;
                
        public FormToolkit()
        {
            InitializeComponent();
            this.datamaster = new Cdatamaster();

            this.selecteddataseriesname = "";

            this.interp_startdate = new double();
            this.interp_enddate = new double();
            this.interp_numpoints = new int();

            this.checkBox_identifymodel_fitmultiple.Checked = true;
            this.checkBox_identifymodel_fitone.Checked = false;

            // set option defaults
            automaticallyGeneratePlotsToolStripMenuItem.Checked = true;

        }

        public void clear_combobox_selecteddataseries()
        {
            Combobox_selecteddataseries.Items.Clear();
        }

        //public void fill_combobox_with_datatablenames(string comboboxname)
        //{
        //    comboBox_regression_predictor_dataseriesname.Items.Clear();


        //    foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["ID"].ToString());
        //        }
        //    }
        //    foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
        //        }
        //    }
        //    foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
        //        }
        //    }
        //    foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
        //        }
        //    }
        //    foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
        //        }
        //    }
        //    foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
        //        }
        //    }
        //    foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
        //    {
        //        if (dr["ID"].ToString() == selecteddataseriesname)
        //        {
        //            comboBox_regression_predictor_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
        //        }
        //    }



        //    if (selectedseries_mostrecent == null)
        //    {
        //        comboBox_regression_predictor_dataseriesname.SelectedItem = selecteddataseriesname;
        //    }
        //    else
        //    {
        //        comboBox_regression_predictor_dataseriesname.SelectedItem = selectedseries_mostrecent;
        //    }
        //}

        public void fill_combobox_with_datatablenames_selecteddataseries()
        {
            Combobox_selecteddataseries.Items.Clear();
            foreach (DataTable dt in datamaster.Tables)
            {
                string dtable = dt.TableName;
            }
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                {
                    Combobox_selecteddataseries.Items.Add(dr["SiteID"].ToString());
                }
            }
            //Combobox_selecteddataseries.SelectedItem = selecteddataseriesname;
        }

 
        private void FormToolkit_Load(object sender, EventArgs e)
        {

        }



        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            string _text;
            // Called whenever text changes.
            _text = comboBox_describedata_timeunits.Text;
            MessageBox.Show(_text);

        }


        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void flowLayoutPanel1_Paint(object sender, PaintEventArgs e)
        {

        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void label1_Click_1(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {

        }

        private void toolStripMenuItem7_Click(object sender, EventArgs e)
        {

        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }

        private void label2_Click_1(object sender, EventArgs e)
        {

        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void label6_Click(object sender, EventArgs e)
        {

        }

        private void label7_Click(object sender, EventArgs e)
        {

        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void mnuExit_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Really Quit?", "Exit", MessageBoxButtons.OKCancel) == DialogResult.OK)
            {
                Application.Exit();
            }
        }

        private void label9_Click(object sender, EventArgs e)
        {

        }

        private void mnuCut_Click(object sender, EventArgs e)
        {

        }

        private void mnuPaste_Click(object sender, EventArgs e)
        {

        }

        private void mnuUndo_Click(object sender, EventArgs e)
        {

        }




        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {

        }

        public void textFiletoolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Open the form for loading a text file. Pass the datamaster dataset to it.

            Form_import_csv import_csv_form = new Form_import_csv(datamaster, this);
            import_csv_form.Show();

        }



        public void fill_combobox_with_datatablenames_preprocess_data()
        {
            //comboBox_preprocess_dataseriesname.Items.Clear();
            //foreach (DataTable table in datamaster.Tables)
                //if (table.TableName.Substring(0, 4).Equals("raw_") | table.TableName.Substring(0, 4).Equals("pre_"))
                //{
                    //comboBox_preprocess_dataseriesname.Items.Add(table.TableName.Substring(5, table.TableName.Length-5));
                //if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity")
                    //comboBox_preprocess_dataseriesname.Items.Add(table.TableName);
                //}
        }

        private void excelFileToolStripMenuItem_Click(object sender, EventArgs e)
        {

            //CImportDataFactory.CExcelFactory exceldata = new CImportDataFactory.CExcelFactory();
            Form_openExcel import_Excel = new Form_openExcel(datamaster, this);
            import_Excel.Show();
        }
        

        private void shapeFileToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void uSGSNWISToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form_import_NWIS import_NWIS_form = new Form_import_NWIS(datamaster, this);
            import_NWIS_form.Show();
        }

        private void richTextBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void chart1_Click(object sender, EventArgs e)
        {
         
        }

        private void dataGridView1_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void label9_Click_1(object sender, EventArgs e)
        {

        }

        private void label10_Click(object sender, EventArgs e)
        {

        }



        private void label11_Click(object sender, EventArgs e)
        {

        }


        private void toolStripMenuItem8_Click(object sender, EventArgs e)
        {
            AboutBox1 about = new AboutBox1();
            about.Show();

        }

        private void label17_Click(object sender, EventArgs e)
        {

        }





        public static double DataColumnToDouble(DataColumn dc)
        {
            return Convert.ToDouble(dc.ToString());
        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
        
        }

        private void label24_Click(object sender, EventArgs e)
        {

        }

        private void label25_TextChanged(object sender, EventArgs e)
        {
            
        }

        private void button_plot_data_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it.
            if (selecteddataseriesname != null & selecteddataseriesname != "")
            {
                Form_series_plot form_plot = new Form_series_plot(datamaster, this.selecteddataseriesname_describe_data, this);
                form_plot.Show();
            }
            else
            {
                MessageBox.Show("Please select a data series first");
            }
        }

        private void label24_Click_1(object sender, EventArgs e)
        {

        }

        private void checkBox_interpolate_CheckedChanged(object sender, EventArgs e)
        {

            //if (checkBox_interpolate.Checked==true)
            //{
            //    comboBox_preprocess_interpolation_method.Enabled=true;
            //    button_interpolate_details.Enabled = true;
            //}
            //if (checkBox_interpolate.Checked==false)
            //{
            //    comboBox_preprocess_interpolation_method.Enabled = false;
            //    button_interpolate_details.Enabled = false;
            //}
                

        }

        private void label26_Click(object sender, EventArgs e)
        {

        }
      


        private void button_describedata_datatable_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            if (selecteddataseriesname != null)
            {
                Form_datagrid form_grid = new Form_datagrid(datamaster, this.selecteddataseriesname_describe_data);
                form_grid.Show();
            }
            else
            {
                MessageBox.Show("Please select a data series first");
            }
        }



        private void button4_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_preprocess_interpolate_output);
            form_grid.Show();
        }

        public string get_ID
        {
            set { ID = value; }
        }

        public string get_selecteddataseriesname
        {
            set { selecteddataseriesname = value; }
        }

        public string get_rawdatatable
        {
            set { RawTablename = value; }
        }

        private void get_new_datatable_in_datamaster(string tablename)
        {
            // creates a table in datamaster
            DataTable dt = new DataTable();
            dt.TableName = tablename;
            // a table might already exist under this name
            try
            {
                // add the datatable to datamaster
                datamaster.Tables.Add(dt);
            }
            catch (DuplicateNameException e)
            {
                //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

                datamaster.Tables.Remove(datamaster.Tables[tablename]);
                datamaster.Tables.Add(dt);                  
            }
        }


        private double ConvertDate_To_Double(DateTime dt)
        {
            double date = 0;
            try
            {
                date = 1900 + Convert.ToDouble(dt.ToOADate());
                //double date = Convert.ToDouble(DateTime.Now.ToOADate());
                //MessageBox.Show("Date to Double is: " + date.ToString());

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
            return date;
        }
 

        public static double DataRowToDoubleCol0(DataRow dr)
        {
            //convert data column to double
            double x;
            DateTime y;
            //DateTime yeardatetime;
            string z;
            if (dr[0] is DateTime)
            {
                y = (DateTime)dr[0];
                double date = Convert.ToSingle(y.ToOADate());

                date = date/365.25 + 1900;
                int year = y.Year;
                //yeardatetime = (DateTime)year;
                //x = y.Ticks;
                
                return date;
            }
            else
            {
                return Convert.ToDouble(dr[0]);
            }
        }

        //public static double DataRowToDouble(convval cv, int col)
        //{
        //    return Convert.ToDouble(cv.dr[cv.index].ToString());
        //}

        public static double DataRowToDoubleCol1(DataRow dr)
        {
            return Convert.ToDouble(dr[1].ToString());
        }

        public static double DataRowToDoubleCol2(DataRow dr)
        {
            return Convert.ToDouble(dr[2].ToString());
        }

        public static double DataRowToDoubleCol3(DataRow dr)
        {
            return Convert.ToDouble(dr[3].ToString());
        }

        public static double DataRowToDoubleCol4(DataRow dr)
        {
            return Convert.ToDouble(dr[4].ToString());
        }

        public static double DataRowToDoubleCol5(DataRow dr)
        {
            return Convert.ToDouble(dr[5].ToString());
        }

        public static double DataRowToDoubleCol6(DataRow dr)
        {
            return Convert.ToDouble(dr[6].ToString());
        }

        public static double DataRowToDoubleCol7(DataRow dr)
        {
            return Convert.ToDouble(dr[7].ToString());
        }

        public static double DataRowToDoubleCol8(DataRow dr)
        {
            return Convert.ToDouble(dr[8].ToString());
        }

        public static double DataRowToDoubleCol9(DataRow dr)
        {
            return Convert.ToDouble(dr[9].ToString());
        }



        private void button_viewhistogram_Click(object sender, EventArgs e)
        {
            if (selecteddataseriesname != null)
            {
                Form_plot_histogram form_histogram = new Form_plot_histogram(datamaster, this.selecteddataseriesname_describe_data, this);
                form_histogram.Show();
            }
            else
            {
                MessageBox.Show("Please select a data series first");
            }
        }


        private void button_savedatadescription_Click(object sender, EventArgs e)
        {
            if (selecteddataseriesname != null)
            {
                string site = comboBox_Describe_data_series_name.SelectedItem.ToString();
                save_row_sites_table(site);
                MessageBox.Show("Data description is saved");
            }
            else
            {
                MessageBox.Show("Please select a data series first");
            }
        }



        public void add_row_sites_table()
        {
            DataRow sitesrow = datamaster.Tables["sites"].NewRow();
            // check to see if a row for this site already exists
            primarykey = primarykey ++;
            sitesrow["PrimaryKey"] = primarykey;




            //sitesrow = datamaster.Tables["sites"].NewRow();
            //sitesrow[1] = ID;
            //return sitesrow;
        }

        public void fill_data_descriptions_from_NWIS(string siteID, string sitename, string lat_dms, string long_dms, string latlong_dms_datum, string lat_dec, string long_dec, string latlong_dec_datum, string sitetype, string altitude)
        {
            int indexes;

            bool notexists = true;
            DataForm = "vector";

            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["siteID"].ToString() == siteID)
                {
                    notexists = false;
                }
                primarykey = Convert.ToInt32(dr[0]);
            }

            DataRow sites_row = datamaster.Tables["sites"].NewRow();

            if (notexists)
            {
                this.primarykey++;

                sites_row["PrimaryKey"] = primarykey;
                sites_row["ID"] = siteID;
                //sites_row["DataTablename"] = RawTablename;
                sites_row["siteID"] = siteID;
                sites_row["StationName"] = sitename;
                //sites_row["Comments"] = Comments;
                sites_row["LatitudeDMS"] = lat_dms;
                sites_row["longitudeDMS"] = long_dms;
                //sites_row["Format"] = LatLong_format;
                sites_row["LatlongDMSDatum"] = latlong_dms_datum;
                sites_row["LatitudeDEC"] = lat_dec;
                sites_row["LongitudeDEC"] = long_dec;
                sites_row["LatlongDECDatum"] = latlong_dec_datum;
                //sites_row["UTMN"] = UTM_N;
                //sites_row["UTME"] = UTM_E;
                //sites_row["Zone"] = UTM_zone;
                //sites_row["UTMDatum"] = UTM_datum;
                sites_row["DataType"] = sitetype;
                //sites_row["TimeUnits"] = Time_units;
                //sites_row["VarUnits"] = Var_units;
                sites_row["DataForm"] = DataForm;
                sites_row["Dim1"] = 1;
                sites_row["Dim2"] = 1;
                sites_row["Dim3"] = 1;
                sites_row["DescriptiveStatisticsTablename"] = siteID + "_StatsTable";

                datamaster.Tables["sites"].Rows.Add(sites_row);

                //fill_describedata_with_site_info
                textBox_describedata_USGS_siteId.Text = siteID;
                textBox_describedata_StationName.Text = sitename;
                textBox_describedata_latitudeDMS.Text = lat_dms;
                textBox_describedata_longitudeDMS.Text = long_dms;
                //comboBox_describedata_latlongDMS_datum.Items.Clear();
                //comboBox_describedata_latlongDMS_datum.Items.Add(Convert.ToString(latlong_dms_datum));
                comboBox_describedata_latlongDMS_datum.Text = latlong_dms_datum;
                textBox_describedata_latitudeDEC.Text = lat_dec;
                textBox_describedata_longitudeDEC.Text = long_dec;
                //comboBox_describedata_datum_latlongDEC.Items.Clear();
                //comboBox_describedata_datum_latlongDEC.Items.Add(Convert.ToString(latlong_dec_datum));
                comboBox_describedata_latlongDEC_datum.Text = latlong_dec_datum;
                comboBox_describedata_dataType.Text = sitetype;
            }
            else
            {
                // a row for this ID already exists
                // show a messagebox that checks if you want to erase the old row, and add a new one
                MessageBox.Show("A record for this site already exists");
            }
        }

        public void fill_row_sites_table(string site, string RawTablename, string DataForm, int dim1, int dim2, int dim3)
        {
            int indexes;

            bool notexists = true;

            foreach(DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["siteID"].ToString() == site)
                {
                    notexists = false;
                }
                primarykey = Convert.ToInt32(dr[0]);
            }

            DataRow sites_row = datamaster.Tables["sites"].NewRow();

            //indexes = Array.IndexOf(array, ID);
            if (notexists)
            {
                this.primarykey++;

                sites_row["PrimaryKey"] = primarykey;
                sites_row["ID"] = site;
                sites_row["DataTablename"] = RawTablename;
                sites_row["siteID"] = site;
                //sites_row["StationName"] = Station_name;
                //sites_row["Comments"] = Comments;
                //sites_row["LatitudeDMS"] = LatitudeDMS;
                //sites_row["longitudeDMS"] = LongitudeDMS;
                //sites_row["Format"] = LatLong_format;
                //sites_row["LatlongDMSDatum"] = LatLongDMS_datum;
                //sites_row["LatitudeDEC"] = LatitudeDEC;
                //sites_row["longitudeDEC"] = LongitudeDEC;
                //sites_row["LatlongDECDatum"] = LatLongDEC_datum;
                //sites_row["UTMN"] = UTM_N;
                //sites_row["UTME"] = UTM_E;
                //sites_row["Zone"] = UTM_zone;
                //sites_row["UTMDatum"] = UTM_datum;
                //sites_row["DataType"] = Data_type;
                //sites_row["TimeUnits"] = Time_units;
                //sites_row["VarUnits"] = Var_units;
                sites_row["DataForm"] = DataForm;
                sites_row["Dim1"] = dim1;
                sites_row["Dim2"] = dim2;
                sites_row["Dim3"] = dim3;
                sites_row["DescriptiveStatisticsTablename"] = site + "_StatsTable";
                datamaster.Tables["sites"].Rows.Add(sites_row);
            }
            else
            {
                // a row for this ID already exists
                // show a messagebox that checks if you want to erase the old row, and add a new one
                MessageBox.Show("A record for this site already exists");
            }
        }

        public void fill_row_preprocess_table(string site, string outputtablename, string operation)
        {
            bool notexists = true;
            int preprocess_primarykey = 0;
            int count = 0;
            string tablename = "";
            string parsTablename = "";

            foreach (DataRow dr in datamaster.Tables["preprocess"].Rows)
            {
                count++;
                preprocess_primarykey = count;
            }

            parsTablename = outputtablename + "intp_pars";

            DataRow preprocess_row = datamaster.Tables["preprocess"].NewRow();

            preprocess_row["PrimaryKey"] = preprocess_primarykey;
            preprocess_row["ID"] = site;
            preprocess_row["DataTablename"] = outputtablename;
            preprocess_row["Operation"] = operation;
            preprocess_row["ParsTablename"] = parsTablename;

            datamaster.Tables["preprocess"].Rows.Add(preprocess_row);

        }

        public void fill_describedata_with_site_info()
        {


            //    sites_row["LatitudeDMS"] = lat_dms;
            //sites_row["longitudeDMS"] = long_dms;
            ////sites_row["Format"] = LatLong_format;
            //sites_row["LatlongDMSDatum"] = LatLong_datum;
            //sites_row["LatitudeDEC"] = lat_dec;
            //sites_row["LongitudeDEC"] = long_dec;
            //sites_row["LatlongDECDatum"] = latlong_dec_datum;
            ////sites_row["UTMN"] = UTM_N;
            ////sites_row["UTME"] = UTM_E;
            ////sites_row["Zone"] = UTM_zone;
            ////sites_row["UTMDatum"] = UTM_datum;
            //sites_row["DataType"] = sitetype;
            ////sites_row["TimeUnits"] = Time_units;
            ////sites_row["VarUnits"] = Var_units;
            //datamaster.Tables["sites"].Rows.Add(sites_row);

        }

        public void save_row_sites_table(string site)
        {


            DataRow sites_row = datamaster.Tables["sites"].NewRow();


                    //textBox_describedata_StationName.Text = dr["StationName"].ToString();
                    //textBox_describedata_comments.Text = dr["Comments"].ToString();

                    //textBox_describedata_latitudeDMS.Text = dr["LatitudeDMS"].ToString();
                    //textBox_describedata_longitudeDMS.Text = dr["LongitudeDMS"].ToString();

                    //textBox_describedata_latitudeDEC.Text = dr["LatitudeDEC"].ToString();
                    //textBox_describedata_longitudeDEC.Text = dr["LongitudeDEC"].ToString();

                    //textBox_describedata_utmnorthing.Text = dr["UTMN"].ToString();
                    //textBox_describedata_utmeasting.Text = dr["UTME"].ToString();

                    //comboBox_describedata_latlongDMS_datum.SelectedItem = dr["LatlongDMSDatum"].ToString();
                    //comboBox_describedata_latlongDEC_datum.SelectedItem = dr["LatlongDECDatum"].ToString();
                    //comboBox_describedata_utmdatum.SelectedItem = dr["UTMDatum"].ToString();

                    //comboBox_describedata_utmzone.SelectedItem = dr["Zone"].ToString();
                    //comboBox_describedata_dataType.SelectedItem = dr["DataType"].ToString();

                    //comboBox_describedata_timeunits.SelectedItem = dr["TimeUnits"].ToString();
                    //comboBox_describedata_varUnits.SelectedItem = dr["VarUnits"].ToString();

            sites_row["PrimaryKey"] = primarykey;
            sites_row["ID"] = ID;
            sites_row["DataTablename"] = RawTablename;
            sites_row["siteID"] = site;
            sites_row["StationName"] = textBox_describedata_StationName.Text;//Station_name;
            sites_row["Comments"] = textBox_describedata_comments.Text;//Comments;
            sites_row["LatitudeDMS"] = textBox_describedata_latitudeDMS.Text;//LatitudeDMS;
            sites_row["LongitudeDMS"] = textBox_describedata_longitudeDMS.Text;//LongitudeDMS;
            sites_row["LatlongDMSDatum"] = comboBox_describedata_latlongDMS_datum.SelectedItem;//LatLongDMS_datum;
            sites_row["LatitudeDEC"] = textBox_describedata_latitudeDEC.Text;//LatitudeDEC;
            sites_row["LongitudeDEC"] = textBox_describedata_longitudeDEC.Text;//LongitudeDEC;
            sites_row["LatlongDECDatum"] = comboBox_describedata_latlongDEC_datum.SelectedItem;//LatLongDEC_datum;
            sites_row["UTMN"] = textBox_describedata_utmnorthing.Text;//UTM_N;
            sites_row["UTME"] = textBox_describedata_utmeasting.Text;//UTM_E;
            sites_row["Zone"] = comboBox_describedata_utmzone.SelectedItem;//UTM_zone;
            sites_row["UTMDatum"] = comboBox_describedata_utmdatum.SelectedItem;//UTM_datum;
            sites_row["DataType"] = comboBox_describedata_dataType.SelectedItem;// Data_type;
            sites_row["TimeUnits"] = comboBox_describedata_timeunits.SelectedItem;// Time_units;
            sites_row["VarUnits"] = comboBox_describedata_varUnits.SelectedItem;// Var_units;
            sites_row["DescriptiveStatisticsTablename"] = site + "_StatsTable";

            datamaster.Tables["sites"].Rows.Add(sites_row);
        }

        public void save_row_projection_table(string dataseriesname, string seriesnamein, string seriesnameout, int seriesnameinlength, int projectionlength, int numrealizations)
        {
            bool notexists = true;
            primarykey = 0;

            foreach (DataRow dr in datamaster.Tables["Projection"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    notexists = false;
                    dr.Delete();
                    break;
                }
                primarykey = Convert.ToInt32(dr[0]);
            }

            DataRow projection_row = datamaster.Tables["Projection"].NewRow();

            primarykey++;

            projection_row["PrimaryKey"] = primarykey;
            projection_row["ID"] = dataseriesname;
            projection_row["Seriesnamein"] = seriesnamein;
            projection_row["Seriesnameout"] = seriesnameout;
            projection_row["SeriesnameinLength"] = seriesnameinlength;
            projection_row["Length"] = projectionlength;
            projection_row["NumRealizations"] = numrealizations;
            projection_row["Operation"] = "proj";

            datamaster.Tables["Projection"].Rows.Add(projection_row);

        }

        public void save_row_projectionsum_table(string dataseriesname, string seriesnamein, string seriesnameout, 
            string seriesnameoutmean, string seriesnameoutlower, string seriesnameoutupper, string seriesnameoutmin,
            string seriesnameoutmax, string seriesnameoutrand1, string seriesnameoutrand2, string seriesnameoutrand3,
            int seriesnameinlength, int projectionlength, int numrealizations)
        {
            bool notexists = true;
            primarykey = 0;

            foreach (DataRow dr in datamaster.Tables["ProjectionSum"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    notexists = false;
                    dr.Delete();
                    break;
                }
                primarykey = Convert.ToInt32(dr[0]);
            }

            DataRow projectionsum_row = datamaster.Tables["ProjectionSum"].NewRow();

            primarykey++;

            projectionsum_row["PrimaryKey"] = primarykey;
            projectionsum_row["ID"] = dataseriesname;
            projectionsum_row["Seriesnamein"] = seriesnamein;
            projectionsum_row["Seriesnameout"] = seriesnameout;

            projectionsum_row["Seriesnameoutmean"] = seriesnameoutmean;
            projectionsum_row["Seriesnameoutlower"] = seriesnameoutlower;
            projectionsum_row["Seriesnameoutupper"] = seriesnameoutupper;
            projectionsum_row["Seriesnameoutmin"] = seriesnameoutmin;
            projectionsum_row["Seriesnameoutmax"] = seriesnameoutmax;
            projectionsum_row["Seriesnameoutrand1"] = seriesnameoutrand1;
            projectionsum_row["Seriesnameoutrand2"] = seriesnameoutrand2;
            projectionsum_row["Seriesnameoutrand3"] = seriesnameoutrand3;
            
            projectionsum_row["SeriesnameinLength"] = seriesnameinlength;
            projectionsum_row["Length"] = projectionlength;
            projectionsum_row["NumRealizations"] = numrealizations;
            projectionsum_row["Operation"] = "projsum";

            datamaster.Tables["ProjectionSum"].Rows.Add(projectionsum_row);
        }

        public void save_row_interpolation_table(string dataseriesname, string seriesnamein, string seriesnameout, string interpmethod, 
            double start, double end, int numpoints)
        {
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow interpolation_row = datamaster.Tables["Interpolation"].NewRow();

            this.primarykey++;

            interpolation_row["PrimaryKey"] = primarykey;
            interpolation_row["ID"] = dataseriesname;
            interpolation_row["Seriesnamein"] = seriesnamein;
            interpolation_row["Seriesnameout"] = seriesnameout;
            interpolation_row["InterpMethod"] = interpmethod;
            interpolation_row["InterpStart"] = start;
            interpolation_row["InterpEnd"] = end;
            interpolation_row["InterpNumpoints"] = numpoints;
            interpolation_row["Operation"] = "intp";

            datamaster.Tables["Interpolation"].Rows.Add(interpolation_row);
        }

        public void save_row_standardize_table(string dataseriesname, string seriesnamein, string seriesnameout, string stanmethod,
                   double mean, double variance, double alpha, double beta)
        {
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow standardize_row = datamaster.Tables["Standardize"].NewRow();

            this.primarykey++;

            standardize_row["PrimaryKey"] = primarykey;
            standardize_row["ID"] = dataseriesname;
            standardize_row["Seriesnamein"] = seriesnamein;
            standardize_row["Seriesnameout"] = seriesnameout;
            standardize_row["StandardizeMethod"] = stanmethod;
            standardize_row["Mean"] = mean;
            standardize_row["Variance"] = variance;
            standardize_row["Alpha"] = alpha;
            standardize_row["Beta"] = beta;
            standardize_row["Operation"] = "stan";

            datamaster.Tables["Standardize"].Rows.Add(standardize_row);
        }

        public void save_row_cumulative_departure_table(string dataseriesname, string seriesnamein, string seriesnameout, double mean)
        {
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow cdep_row = datamaster.Tables["CumulativeDeparture"].NewRow();

            this.primarykey++;

            cdep_row["PrimaryKey"] = primarykey;
            cdep_row["ID"] = dataseriesname;
            cdep_row["Seriesnamein"] = seriesnamein;
            cdep_row["Seriesnameout"] = seriesnameout;
            cdep_row["Mean"] = mean;
            cdep_row["Operation"] = "cdep";

            datamaster.Tables["CumulativeDeparture"].Rows.Add(cdep_row);
        }

        public void save_row_differencing_table(string dataseriesname, string seriesnamein, string seriesnameout, int order)
        {
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow differencing_row = datamaster.Tables["Differencing"].NewRow();

            this.primarykey++;

            differencing_row["PrimaryKey"] = primarykey;
            differencing_row["ID"] = dataseriesname;
            differencing_row["Seriesnamein"] = seriesnamein;
            differencing_row["Seriesnameout"] = seriesnameout;
            differencing_row["Order"] = order;
            differencing_row["Operation"] = "diff";

            datamaster.Tables["Differencing"].Rows.Add(differencing_row);
        }

        public void save_row_curvefitting_table(string dataseriesname, string seriesnamein, string curvenameout, 
            string residualsnameout, string method)
        {
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["Residualsnameout"].ToString() == residualsnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow curvefitting_row = datamaster.Tables["CurveFitting"].NewRow();

            this.primarykey++;

            curvefitting_row["PrimaryKey"] = primarykey;
            curvefitting_row["ID"] = dataseriesname;
            curvefitting_row["Seriesnamein"] = seriesnamein;
            curvefitting_row["Curvenameout"] = curvenameout;
            curvefitting_row["Residualsnameout"] = residualsnameout;
            curvefitting_row["Method"] = method;
            curvefitting_row["Operation"] = "curv";

            datamaster.Tables["CurveFitting"].Rows.Add(curvefitting_row);
        }

        public void save_row_fourier_table(string dataseriesname, string seriesnamein, string seriesnameout, double sampleinterval,
            string sigtest, string window, int SmoothingWidth, int numberrealizations)
        {
            foreach (DataRow dr in datamaster.Tables["Fourier"].Rows)
            {
                if (dr["Spectrumnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow fourier_row = datamaster.Tables["Fourier"].NewRow();

            this.primarykey++;

            fourier_row["PrimaryKey"] = primarykey;
            fourier_row["ID"] = dataseriesname;
            fourier_row["Seriesnamein"] = seriesnamein;
            fourier_row["Spectrumnameout"] = seriesnameout;
            fourier_row["SampleInterval"] = sampleinterval;
            fourier_row["SigTest"] = sigtest;
            fourier_row["Window"] = window;
            fourier_row["SmoothingWidth"] = SmoothingWidth;
            fourier_row["NumberRealizations"] = numberrealizations;
            fourier_row["Operation"] = "four";

            datamaster.Tables["Fourier"].Rows.Add(fourier_row);
        }

        public void save_row_MEM_table(string dataseriesname, string seriesnamein, string seriesnameout, double interval,
            int order)
        {
            foreach (DataRow dr in datamaster.Tables["MEM"].Rows)
            {
                if (dr["Spectrumnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow MEM_row = datamaster.Tables["MEM"].NewRow();

            this.primarykey++;

            MEM_row["PrimaryKey"] = primarykey;
            MEM_row["ID"] = dataseriesname;
            MEM_row["Seriesnamein"] = seriesnamein;
            MEM_row["Spectrumnameout"] = seriesnameout;
            MEM_row["SampleInterval"] = interval;
            MEM_row["MEMOrder"] = order;
            MEM_row["Operation"] = "MEM";

            datamaster.Tables["MEM"].Rows.Add(MEM_row);
        }

        public void save_row_SSA_table(string dataseriesname, string seriesnamein, string seriesnameout, string TEOFnameoutMatrix,
            string TPCnameoutMatrix, string RCnameoutMatrix, double interval, int window)
        {
            foreach (DataRow dr in datamaster.Tables["SSA"].Rows)
            {
                if (dr["Spectrumnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow SSA_row = datamaster.Tables["SSA"].NewRow();

            this.primarykey++;

            SSA_row["PrimaryKey"] = primarykey;
            SSA_row["ID"] = dataseriesname;
            SSA_row["Seriesnamein"] = seriesnamein;
            SSA_row["Spectrumnameout"] = seriesnameout;
            SSA_row["TEOFnameoutMatrix"] = TEOFnameoutMatrix;
            SSA_row["TPCnameoutMatrix"] = TPCnameoutMatrix;
            SSA_row["RCnameoutMatrix"] = RCnameoutMatrix;
            SSA_row["Interval"] = interval;
            SSA_row["Window"] = window;
            SSA_row["Operation"] = "SSA";

            datamaster.Tables["SSA"].Rows.Add(SSA_row);
        }

        public void save_row_SSA_vectors_table(string dataseriesname, string seriesnamein, 
            string RCnameoutVector, string ResidualnameoutVector, int inlength, int outlength)
        {
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["RCnameoutVector"].ToString() == RCnameoutVector)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow SSA_vectors_row = datamaster.Tables["SSA_vectors"].NewRow();

            this.primarykey++;

            SSA_vectors_row["PrimaryKey"] = primarykey;
            SSA_vectors_row["ID"] = dataseriesname;
            SSA_vectors_row["Seriesnamein"] = seriesnamein;
            SSA_vectors_row["RCnameoutVector"] = RCnameoutVector;
            SSA_vectors_row["ResidualnameoutVector"] = ResidualnameoutVector;
            SSA_vectors_row["Inlength"] = inlength;
            SSA_vectors_row["Outlength"] = outlength;

            datamaster.Tables["SSA_vectors"].Rows.Add(SSA_vectors_row);
        }

        public void save_row_EOF_table(string dataseriesname, string seriesnamein, string seriesnameout, string SEOFnameoutMatrix,
     string SPCnameoutMatrix, string SEOFScalednameoutMatrix, double LatitudeMin, double LatitudeMax)
        {
            foreach (DataRow dr in datamaster.Tables["EOF"].Rows)
            {
                if (dr["Eigennameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow EOF_row = datamaster.Tables["EOF"].NewRow();

            this.primarykey++;

            EOF_row["PrimaryKey"] = primarykey;
            EOF_row["ID"] = dataseriesname;
            EOF_row["Seriesnamein"] = seriesnamein;
            EOF_row["Eigennameout"] = seriesnameout;
            EOF_row["SEOFnameoutMatrix"] = SEOFnameoutMatrix;
            EOF_row["SPCnameoutMatrix"] = SPCnameoutMatrix;
            EOF_row["SEOFScalednameoutMatrix"] = SEOFScalednameoutMatrix;
            EOF_row["LatitudeMin"] = LatitudeMin;
            EOF_row["LatitudeMax"] = LatitudeMax;
            EOF_row["Operation"] = "EOF";

            datamaster.Tables["EOF"].Rows.Add(EOF_row);
        }

        public void save_row_EOF_SPC_vectors_table(string dataseriesname, string seriesnamein,
              string SPCnameoutVector)
        {
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["SPCnameoutVector"].ToString() == SPCnameoutVector)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow EOF_SPC_vectors_row = datamaster.Tables["EOF_SPC_vectors"].NewRow();

            this.primarykey++;

            EOF_SPC_vectors_row["PrimaryKey"] = primarykey;
            EOF_SPC_vectors_row["ID"] = dataseriesname;
            EOF_SPC_vectors_row["Seriesnamein"] = seriesnamein;
            EOF_SPC_vectors_row["SPCnameoutVector"] = SPCnameoutVector;

            datamaster.Tables["EOF_SPC_vectors"].Rows.Add(EOF_SPC_vectors_row);
        }

        public void save_row_EOF_ScaledEOF_vectors_table(string dataseriesname, string seriesnamein,
               string EOFScalednameoutVectorColumn)
        {
            foreach (DataRow dr in datamaster.Tables["EOF_ScaledEOF_vectors"].Rows)
            {
                if (dr["SEOFScalednameoutVector"].ToString() == EOFScalednameoutVectorColumn)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow EOF_ScaledEOF_vectors_row = datamaster.Tables["EOF_ScaledEOF_vectors"].NewRow();

            this.primarykey++;

            EOF_ScaledEOF_vectors_row["PrimaryKey"] = primarykey;
            EOF_ScaledEOF_vectors_row["ID"] = dataseriesname;
            EOF_ScaledEOF_vectors_row["Seriesnamein"] = seriesnamein;
            EOF_ScaledEOF_vectors_row["SEOFScalednameoutVector"] = EOFScalednameoutVectorColumn;

            datamaster.Tables["EOF_ScaledEOF_vectors"].Rows.Add(EOF_ScaledEOF_vectors_row);
        }

        public void save_row_regression_table(string dataseriesname, string predictorseriesnamein,string predictandseriesnamein,
            string seriesnameout, string regressionstatistics)
        {
            foreach (DataRow dr in datamaster.Tables["Regression"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow regression_row = datamaster.Tables["Regression"].NewRow();

            this.primarykey++;

            regression_row["PrimaryKey"] = primarykey;
            regression_row["ID"] = dataseriesname;
            regression_row["PredictorSeriesnamein"] = predictorseriesnamein;
            regression_row["PredictandSeriesnamein"] = predictandseriesnamein;
            regression_row["Seriesnameout"] = seriesnameout;
            regression_row["RegressionStatistics"] = regressionstatistics;
            regression_row["Operation"] = "regr";

            datamaster.Tables["Regression"].Rows.Add(regression_row);
        }

        public void save_row_CCF_table(string dataseriesname, string seriesnamein, string seriesnameout)
        {
            foreach (DataRow dr in datamaster.Tables["CCF"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow CCF_row = datamaster.Tables["CCF"].NewRow();

            this.primarykey++;

            CCF_row["PrimaryKey"] = primarykey;
            CCF_row["ID"] = dataseriesname;
            CCF_row["Seriesnamein"] = seriesnamein;
            CCF_row["Seriesnameout"] = seriesnameout;
            CCF_row["Operation"] = "CCF";

            datamaster.Tables["CCF"].Rows.Add(CCF_row);
        }

        public void save_row_AR_table(string dataseriesname, string seriesnamein, string seriesnamesimout,
            string seriesnameresidualsout,string seriesnameresidualsACFout, string ARfitstatistics, string ARcoefficients,
                int ARorder)
        {
            foreach (DataRow dr in datamaster.Tables["AR"].Rows)
            {
                if (dr["SeriesnameSimout"].ToString() == seriesnamesimout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow AR_row = datamaster.Tables["AR"].NewRow();

            this.primarykey++;

            AR_row["PrimaryKey"] = primarykey;
            AR_row["ID"] = dataseriesname;
            AR_row["Seriesnamein"] = seriesnamein;
            AR_row["SeriesnameSimout"] = seriesnamesimout;
            AR_row["SeriesnameResidualsout"] = seriesnameresidualsout;
            AR_row["SeriesnameResidualsACFout"] = seriesnameresidualsACFout;
            AR_row["SeriesnameARFitStatisticsout"] = ARfitstatistics;
            AR_row["SeriesnameARCoeffout"] = ARcoefficients;
            AR_row["Order"] = ARorder;
            AR_row["Operation"] = "AR";

            datamaster.Tables["AR"].Rows.Add(AR_row);
        }

        public void save_row_ACF_table(string dataseriesname, string seriesnamein, string seriesnameout)
        {
            foreach (DataRow dr in datamaster.Tables["ACF"].Rows)
            {
                if (dr["Seriesnameout"].ToString() == seriesnameout)
                {
                    // if a row already exists for this output, then delete the existing row
                    dr.Delete();
                    break;
                }
                else
                {
                    primarykey = Convert.ToInt32(dr[0]);
                }
            }

            DataRow ACF_row = datamaster.Tables["ACF"].NewRow();

            this.primarykey++;

            ACF_row["PrimaryKey"] = primarykey;
            ACF_row["ID"] = dataseriesname;
            ACF_row["Seriesnamein"] = seriesnamein;
            ACF_row["Seriesnameout"] = seriesnameout;
            ACF_row["Operation"] = "ACF";

            datamaster.Tables["ACF"].Rows.Add(ACF_row);
        }

        public void add_to_row_string(string tablename, DataRow dr, int colnum, string stringtoadd)
        {
            dr[colnum] = stringtoadd;
        }

        public void add_value_sites_row(string value)
        {
            datamaster.Tables["sites"].Rows.Add();


        }

        private void label2_Click_2(object sender, EventArgs e)
        {

        }



        private void textBox_seriesname_spectrum_output_TextChanged(object sender, EventArgs e)
        {

        }

        private void label_spectral_realizations_integer_Click(object sender, EventArgs e)
        {

        }

        private void tabPage7_EOF_Click(object sender, EventArgs e)
        {

        }

        private void mnu_import_2D_text_Click(object sender, EventArgs e)
        {
            Form_import_2D_csv import_2D_csv = new Form_import_2D_csv(datamaster, this);
            import_2D_csv.Show();
        }

        private void importGriddedTimeSeriesAsAMatrixToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void textBox_comments_TextChanged(object sender, EventArgs e)
        {

        }

        public void setcombobox_dataseriesname(string series)
        {
            Combobox_selecteddataseries.Text = "";
            Combobox_selecteddataseries.SelectedText = series.ToString();
        }

        public void setcombobox_predictand_dataseriesname(string series)
        {
            //Combobox_selecteddataseries.SelectedItem = series.ToString();

            Combobox_selecteddataseries.Text = "";
            Combobox_selecteddataseries.SelectedText = series.ToString();

        }

        //private void textBox_latitude_Validating(object sender, CancelEventArgs e)
        //{

        //}
        #region data_read_write_methods

        //private void get_fourCol_Datatable(string tablename)
        //{
        //    // creates a table in datamaster
        //    DataTable dt = new DataTable();
        //    dt.TableName = tablename;
        //    // a table might already exist under this name
        //    try
        //    {
        //        // add the datatable to datamaster
        //        datamaster.Tables.Add(dt);
        //    }
        //    catch (DuplicateNameException e)
        //    {
        //        //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

        //        datamaster.Tables.Remove(datamaster.Tables[tablename]);
        //        datamaster.Tables.Add(dt);
        //    }
        //}

        public List<string> get_oneColListString_from_datatable(DataSet ds, string tablename, int colnum)
        {
            List<string> strlist = new List<string>();
            string strval;
            double otval;
            foreach (DataRow rowval in ds.Tables[tablename].Rows)
            {
                strval = rowval[colnum].ToString();
                strlist.Add(strval.ToString());

                //if (String.TryParse(rowval[colnum].ToString(), out otval))
                //{
                //    stringvals.Add(otval);
                //}
                //else
                //{
                //    otval = DataRowToDoubleCol0(rowval);
                //    stringvals.Add(otval);
                //}

            }
            return strlist;
        }

        public double[] get_oneColArray_from_datatable(DataSet ds, string tablename, int colnum)
        {
            List<double> dblvals = new List<double>();
            double otval;
            foreach (DataRow rowval in ds.Tables[tablename].Rows)
            {
                if (double.TryParse(rowval[colnum].ToString(), out otval))
                {
                    dblvals.Add(otval);
                }
                else
                {
                    otval = DataRowToDoubleCol0(rowval);
                    dblvals.Add(otval);
                    //dblvals.Add(double.NaN);
                }
                
            }
            return dblvals.ToArray();
        }

        public string[,] get_stringArray_from_datatable(DataSet ds, string tablename)
        {
            int nrows = ds.Tables[tablename].Rows.Count;
            int ncols = ds.Tables[tablename].Columns.Count;
            string[,] stringarray = new string[nrows, ncols];

            for (int row = 0; row < nrows; ++row)
            {
                for (int col = 0; col < ncols; col++)
                {
                    stringarray[row, col] = ds.Tables[tablename].Rows[row][col].ToString();
                }
            }
            return stringarray;
        }
 
        public double[,] get_twoColArray_from_datatable(DataSet ds, string tablename)
        {
            // copy datatable rows into an array
            DataRow[] dr = new DataRow[ds.Tables[tablename].Rows.Count];
            ds.Tables[tablename].Rows.CopyTo(dr, 0);

            double[] a = new double[ds.Tables[tablename].Rows.Count];
            double [] b = new double[ds.Tables[tablename].Rows.Count];
            double[,] c = new double[ds.Tables[tablename].Rows.Count,2];

            a = Array.ConvertAll(dr, new Converter<DataRow, Double>(DataRowToDoubleCol0));
            b = Array.ConvertAll(dr, new Converter<DataRow, Double>(DataRowToDoubleCol0));
            for (int i = 0; i > 2; i++)
            {
                c[i, 0] = a[i];
                c[i, 1] = b[i];
            }

            return c;
        }

        private void get_datatable_from_twoColArray(double[] arraycol0, double[] arraycol1, string tablename)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add("Date", typeof(double));
                datamaster.Tables[tablename].Columns.Add("Value", typeof(double));
            }
            catch (DuplicateNameException e)
            {
                //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i], arraycol1[i]);
            }
        }

        private void get_datatable_from_oneColArray(double[] arraycol0, string tablename)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add("Value", typeof(double));
            }
            catch (DuplicateNameException e)
            {
                //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i]);
            }
        }

        private void get_SSA_spectrum_datatable(double[] arraycol0, double[] arraycol1, double [] arraycol2, double[] arraycol3, string tablename, string yaxisname)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add("Component", typeof(double));
                datamaster.Tables[tablename].Columns.Add("Frequency", typeof(double));
                datamaster.Tables[tablename].Columns.Add("Period", typeof(double));
                datamaster.Tables[tablename].Columns.Add(yaxisname, typeof(double));
            }
            catch (DuplicateNameException e)
            {
                MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i], arraycol1[i], arraycol2[i],arraycol3[i]);
            }
        }

        private void get_EOF_spectrum_datatable(double[] arraycol0, double[] arraycol1, string tablename, string yaxisname)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add("Component", typeof(double));
                datamaster.Tables[tablename].Columns.Add(yaxisname, typeof(double));
            }
            catch (DuplicateNameException e)
            {
                MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i], arraycol1[i]);
            }
        }

        private void get_datatable_from_string_and_double(string[] arraycol0, string arraycol0name, double[] arraycol1, string arraycol1name, string tablename)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add(arraycol0name, typeof(string));
                datamaster.Tables[tablename].Columns.Add(arraycol1name, typeof(double));
            }
            catch (DuplicateNameException e)
            {
                //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i], arraycol1[i]);
            }
        }

        private void get_spectrum_datatable_from_fourColArray(double[] arraycol0, double[] arraycol1, double[] arraycol2, double[] arraycol3, string tablename)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add("wavenumber", typeof(double));
                datamaster.Tables[tablename].Columns.Add("period", typeof(double));
                datamaster.Tables[tablename].Columns.Add("frequency", typeof(double));
                datamaster.Tables[tablename].Columns.Add("power", typeof(double));
            }
            catch (DuplicateNameException e)
            {
                //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i], arraycol1[i], arraycol2[i], arraycol3[i]);
            }
        }

        private void get_spectrum_datatable_from_sevenColArray(double[] arraycol0, double[] arraycol1, double[] arraycol2, 
            double[] arraycol3, double[] arraycol4, double[] arraycol5, double[] arraycol6, string tablename)
        {
            int n;
            n = arraycol0.GetLength(0);
            try
            {
                datamaster.Tables[tablename].Columns.Add("Date", typeof(double));
                datamaster.Tables[tablename].Columns.Add("mean", typeof(double));
                datamaster.Tables[tablename].Columns.Add("05", typeof(double));
                datamaster.Tables[tablename].Columns.Add("95", typeof(double));
                datamaster.Tables[tablename].Columns.Add("Random 1", typeof(double));
                datamaster.Tables[tablename].Columns.Add("Random 2", typeof(double));
                datamaster.Tables[tablename].Columns.Add("Random 3", typeof(double));
            }
            catch (DuplicateNameException e)
            {
                //MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());

            }

            for (int i = 0; i < n; i++)
            {
                datamaster.Tables[tablename].Rows.Add(arraycol0[i], arraycol1[i], arraycol2[i], arraycol3[i], arraycol4[i], arraycol5[i], arraycol6[i]);
            }
        }

        private void get_datatable_from_array(double[,] array, string tablename)
        {
            // get a 1D vector of column names based on the number of columns in input array


            int ncol = array.GetLength(1);
            int nrow = array.GetLength(0);
            int[] colnum = new int[ncol];

            //for (int n = 0; n < ncol; n++)
            //{
            //    colnum[n] = n;
            //}

            // set up column names
            string[] colname = new string[ncol];
            for (int n = 0; n < ncol; n++)
            {
                colname[n] = tablename + Convert.ToString(n);
            }

            foreach (DataTable tab in this.datamaster.Tables)
            {
                string x = tab.TableName;

            }
            for (int n = 0; n < ncol; n++)
            {
                try
                {
                    datamaster.Tables[tablename].Columns.Add(colname[n], typeof(double));
                }
                catch (DuplicateNameException e)
                {
                    MessageBox.Show("Exception of type {0} occurred.", e.GetType().ToString());
                }

            }


            //for (int n = 0; n < ncol; n++)
            //{
            //    for (int i = 0; i < nrow; i++)
            //    {
            //        datamaster.Tables[tablename].Rows.Add(foreach (DataColumn col in this.datamaster.Tables[tablename]) {array[i,col]});
            //    }
            //}

            for (int i = 0; i < nrow; i++)
            {
                datamaster.Tables[tablename].Rows.Add(array[i, 0], array[i, 1], array[i, 2], array[i, 3], array[i, 4], array[i, 5], array[i, 6], array[i, 7], array[i, 8], array[i, 9]);
            }



        }

        public double [,] get_2Darray_from_datatable(string tablename, int nrow, int ncol)
        {
            double[,] a = new double[nrow, ncol];
            double[] col = new double[nrow];

            for (int nc = 0; nc < ncol; nc++)
            {
                col = get_oneColArray_from_datatable(datamaster, tablename, nc);
                for (int nr = 0; nr < nrow; nr++)
                {
                    a[nr, nc] = col[nr];
                }

            }

            return a;
        }

        //public string[,] get_2Dstringarray_from_datatable(string tablename, int nrow, int ncol)
        //{
        //    string[,] a = new string[nrow, ncol];
        //    string[] col = new string[nrow];

        //    for (int nc = 0; nc < ncol; nc++)
        //    {
        //        col = get_oneColArray_from_datatable(datamaster, tablename, nc);
        //        for (int nr = 0; nr < nrow; nr++)
        //        {
        //            a[nr, nc] = col[nr];
        //        }

        //    }

        //    return a;
        //}


        void copy2DArrayIntoDataTable(double[,] array, string tablename)
        {
            DataRow newRow;
            DataColumn newColumn;
            int ncol = array.GetLength(1);
            int nrow = array.GetLength(0);
            int[] colnum = new int[ncol];

            // set up column names
            string[] colname = new string[ncol];
            for (int n = 0; n < ncol; n++)
            {
                colname[n] = tablename + Convert.ToString(n);
                newColumn = new DataColumn();
                newColumn.ColumnName = colname[n];
                datamaster.Tables[tablename].Columns.Add(newColumn);
            }

            for (int nr = 0; nr < array.GetLength(0); nr++)
            {
                newRow = datamaster.Tables[tablename].NewRow();
                for (int nc = 0; nc < array.GetLength(1); nc++)
                {
                    newRow[nc] = array[nr, nc];
                }
                datamaster.Tables[tablename].Rows.Add(newRow);
            }
        }

        public static double[, ,] get_3loop_array_data(double [] a, int dim1, int dim2, int dim3)
        {
            double[, ,] x = new double[dim1, dim2, dim3];

            int count = 0;

            //StreamReader sr = File.OpenText(datatablename);

            for (int q = 0; q < dim3; q++)
            {
                for (int j = 0; j < dim2; j++)
                {
                    for (int i = 0; i < dim1; i++)
                    {
                        //string strdata = sr.ReadLine();
                        //x[i, j, q] = Convert.ToDouble(strdata);
                        x[i, j, q] = a[count];
                        count++;
                    }
                }
            }

            return x;
        }

        void copy2Darray_into_Datatable_vector(double[,] a, int dim1, int dim2, string tablename)
        {

            double[] x = new double[dim1 * dim2];

            // get the 3D array into a 1D vector
            int count = 0;

            for (int j = 0; j < dim2; j++)
            {
                for (int i = 0; i < dim1; i++)
                {
                    x[count] = a[i, j];
                    count++;
                }
            }

            // put results into the table in datamaster
            get_datatable_from_oneColArray(x, tablename);
        }

        void copy3Darray_into_Datatable_vector(double[, ,] a, int dim1, int dim2, int dim3, string tablename)
        {

            double [] x = new double[dim1*dim2*dim3];

            // get the 3D array into a 1D vector
            int count = 0;
            for (int k = 0; k < dim3; k++)
            {
                for (int j = 0; j < dim2; j++)
                {
                    for (int i = 0; i < dim1; i++)
                    {
                        x[count] = a[i, j, k];
                        count++;
                    }
                }
            }

            // put results into the table in datamaster
            get_datatable_from_oneColArray(x, tablename);
        }



        #endregion data_read_write_methods

        private void mnuSave_Click(object sender, EventArgs e)
        {
            if (this.savefileexists == true)
            {
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                WriteXmlToFile(datamaster);

                MessageBox.Show("Project " + this.projectname + " Saved");
                System.Windows.Forms.Cursor.Current = Cursors.Default;
            }
            else
            {
                SaveFileDialog saveFileDialog1 = new SaveFileDialog();
                saveFileDialog1.DefaultExt = "xml";
                saveFileDialog1.Filter = "Toolkit Save File (*.xml)| *.xml";
                saveFileDialog1.Title = "Save Toolkit File";
                //saveFileDialog1.ShowDialog();

                // If the file name is not an empty string open it for saving.
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                    FileInfo fi = new FileInfo(saveFileDialog1.FileName);
                    
                    this.savefilename = saveFileDialog1.FileName;
                    this.projectname = fi.Name;
                    this.projectname = this.projectname.Substring(0, this.projectname.Length - fi.Extension.Length);
                    datamaster.WriteXml(saveFileDialog1.FileName, XmlWriteMode.WriteSchema);
                    update_text();
                    System.Windows.Forms.Cursor.Current = Cursors.Default;

                }
            }

        }

        private void mnuSaveAs_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.DefaultExt = "xml";
            saveFileDialog1.Filter = "Toolkit Save File (*.xml)| *.xml";
            saveFileDialog1.Title = "Save Toolkit File";
            //saveFileDialog1.ShowDialog();

            // If the file name is not an empty string open it for saving.
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;
                
                FileInfo fi = new FileInfo(saveFileDialog1.FileName);
                
                this.savefilename = saveFileDialog1.FileName;
                this.projectname = fi.Name;
                this.projectname = this.projectname.Substring(0, this.projectname.Length-fi.Extension.Length);

                //datamaster.WriteXml(saveFileDialog1.FileName, XmlWriteMode.WriteSchema);
                
                //using (FileStream fs = new FileStream(this.savefilename, FileMode.Create))
                FileStream fs = new FileStream(this.savefilename, FileMode.Create);
                Stream s;
                s = new System.IO.Compression.GZipStream(fs, System.IO.Compression.CompressionMode.Compress);

                datamaster.WriteXml(s, XmlWriteMode.WriteSchema);

                s.Close();

                this.savefileexists = true;
                update_text();
                System.Windows.Forms.Cursor.Current = Cursors.Default;
                
            }
        }

        private void mnuOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.InitialDirectory = Application.ExecutablePath.ToString();
            openFileDialog1.DefaultExt = "xml";
            openFileDialog1.Filter = "HydroClimAT Save File (*.xml)| *.xml";
            openFileDialog1.Title = "Open HydroClimAT File";
            openFileDialog1.RestoreDirectory = true;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                System.Windows.Forms.Cursor.Current = Cursors.WaitCursor;

                while (datamaster.Tables.Count > 0)
                {
                    DataTable table = datamaster.Tables[0];
                    if (datamaster.Tables.CanRemove(table))
                    {
                        datamaster.Tables.Remove(table);
                    }
                }

                FileInfo fi = new FileInfo(openFileDialog1.FileName);

                this.savefilename = openFileDialog1.FileName;
                this.projectname = fi.Name;
                this.projectname = this.projectname.Substring(0, this.projectname.Length - fi.Extension.Length);

                //datamaster.ReadXml(openFileDialog1.FileName);
                //ReadDatasetfromBinary(datamaster);
                FileStream fs = new FileStream(this.savefilename, FileMode.Open);
                Stream s;
                s = new System.IO.Compression.GZipStream(fs, System.IO.Compression.CompressionMode.Decompress);

                datamaster.ReadXml(s);

                s.Close();


                get_first_in_sites_table();
                setcombobox_dataseriesname(this.selecteddataseriesname);
                get_dataseries_datatables();

                fill_combobox_with_datatablenames_selecteddataseries();

                update_comboboxes();

                fill_projection_datagridview_with_datatablenames();

                update_defaults();

                this.savefileexists = true;
                update_text();

                update_plot_buttons();

                System.Windows.Forms.Cursor.Current = Cursors.Default;
            }
        }

        private void WriteXmlToFile(DataSet thisDataSet)
        {
            if (thisDataSet == null) { return; }
            // Create a file name to write to.
            //string filename = "E:\\Shared\\climate\\code\\climate_toolkit_save.xml";
            // Create the FileStream to write with.
            System.IO.FileStream myFileStream = new System.IO.FileStream
               (this.savefilename, System.IO.FileMode.Create);
            // Create an XmlTextWriter with the fileStream.
            System.Xml.XmlTextWriter myXmlWriter =
               new System.Xml.XmlTextWriter(myFileStream, System.Text.Encoding.Unicode);
            // Write to the file with the WriteXml method.
            thisDataSet.WriteXml(myXmlWriter, XmlWriteMode.WriteSchema);
            myXmlWriter.Close();
        }

        private void WriteDatasetasBinary(DataSet thisDataSet)
        {
            thisDataSet.RemotingFormat = System.Data.SerializationFormat.Binary;
            System.IO.FileStream myFileStream = new System.IO.FileStream
               (this.savefilename, System.IO.FileMode.Create);
            BinaryFormatter fmt = new BinaryFormatter();
            fmt.Serialize(myFileStream, thisDataSet);
            myFileStream.Close();
        }

        private void ReadDatasetfromBinary(DataSet thisDataSet)
        {
            FileStream fs = new FileStream(this.savefilename, FileMode.Open);
            BinaryFormatter fmt = new BinaryFormatter();
            thisDataSet = (DataSet)fmt.Deserialize(fs);
            fs.Close();
        }

        private void Combobox_selecteddataseries_SelectedIndexChanged(object sender, EventArgs e)
        {
            selecteddataseriesname = Combobox_selecteddataseries.SelectedItem.ToString();
            update_comboboxes();
            update_defaults();
            update_describedata_tab();
        }

        private void comboBox_regression_predictand_selecteddataseries_SelectedIndexChanged(object sender, EventArgs e)
        {
            selecteddataseriesname_predictand = comboBox_regression_predictand_selecteddataseries.SelectedItem.ToString();
            update_comboboxes_predictand();
        }

        public void update_comboboxes()
        {
            //fill_combobox_with_datatablenames_selecteddataseries();
            
            fill_combobox_with_datatablenames_Describe_data();
            fill_combobox_with_datatablenames_interpolate_data();
            fill_combobox_with_datatablenames_standardize_data();
            fill_combobox_with_datatablenames_cumulative_departure();
            
            fill_combobox_with_datatablenames_detrend();
            fill_combobox_with_datatablenames_differencing();
            fill_combobox_with_datatablenames_ACF();
            fill_combobox_with_datatablenames_spectralanalysis();
            fill_combobox_with_datatablenames_MEM();
            fill_combobox_with_datatablenames_SSA();
            fill_combobox_with_datatablenames_EOF();
            fill_combobox_with_datatablenames_AR();
            fill_combobox_with_datatablenames_regression_predictor();
            fill_combobox_with_datatablenames_predictand_selecteddataseries();
            fill_combobox_with_datatablenames_regression_predicand();

            comboBox_Describe_data_series_name.SelectedItem = selecteddataseriesname;
            comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_preprocessdata_standardize_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_stationarity_detrend_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_detrend_differencing_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_MEM_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_SSA_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_EOF_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_spectralanalysis_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_projection_ACF_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        private void update_comboboxes_predictand()
        {
            fill_combobox_with_datatablenames_regression_predicand();
        }

        public void set_comboboxes_to_new_series()
        {
            comboBox_Describe_data_series_name.SelectedItem = selecteddataseriesname;
            comboBox_preprocessdata_interpolate_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_preprocessdata_standardize_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_preprocessdata_cumulative_depature_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_stationarity_detrend_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_detrend_differencing_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_MEM_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_SSA_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_spectralanalysis_dataseriesname.SelectedItem = selecteddataseriesname;
            comboBox_projection_ACF_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        public void update_defaults()
        {
            get_num_autocorrelation_lags();
            get_SSA_window_length();
            get_default_significance_tests();
            get_predictor_dataseries_label();
            get_AR_model_test_highest_order();
            get_MEM_order();
            get_MEM_nofreqencies();
            get_MEM_samplinginterval();
            get_projection_length();

            update_datagridview_progress();

        }

        public void update_plot_buttons()
        {
            interp_exists = change_viewdatatable(selecteddataseriesname_preprocess_interpolate_output);
            if (interp_exists)
            {
                button_plot_interpolated_data.Enabled = true;
                button_view_interpolated_datatable.Enabled = true;
            }
            else
            {
                button_plot_interpolated_data.Enabled = false;
                button_view_interpolated_datatable.Enabled = false;
            }

            EOF_exists = change_viewdatatable(selecteddataseriesname_EOF_output_spectrum);
            if (EOF_exists)
            {
                button_plot_EOF_spectrum.Enabled = true;
                button_plot_EOF_SPC.Enabled = true;
                button_view_EOF_spectrum_datatable.Enabled = true;
                checkBox_EOF_show_percent_variance.Enabled = true;
                button_EOF_save_scaledEOF.Enabled = true;
            }
            else
            {
                button_plot_EOF_spectrum.Enabled = false;
                button_plot_EOF_SPC.Enabled = false;
                button_view_EOF_spectrum_datatable.Enabled = false;
                checkBox_EOF_show_percent_variance.Enabled = false;
                button_EOF_save_scaledEOF.Enabled = false;
            }

            MEM_exists = change_viewdatatable(selecteddataseriesname_MEM_output_spectrum);
            if (MEM_exists)
            {
                button_MEM_plotspectrum.Enabled = true;
                button_MEM_viewdatatable.Enabled = true;
            }
            else
            {
                button_MEM_plotspectrum.Enabled = false;
                button_MEM_viewdatatable.Enabled = false;
            }

            Fourier_exists = change_viewdatatable(selecteddataseriesname_periodicanalysis_spectralanalysis_output);
            if (Fourier_exists)
            {
                button_plot_fourier_spectrum.Enabled = true;
                button_view_Fourier_spectrum_datatable.Enabled = true;
            }
            else
            {
                button_plot_fourier_spectrum.Enabled = false;
                button_view_Fourier_spectrum_datatable.Enabled = false;
            }

            SSA_exists = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_spectrum);
            if (SSA_exists)
            {
                button_plot_SSA_spectrum.Enabled = true;
                button_plotTEOFs.Enabled = true;
                button_plotTPC.Enabled = true;
                button_view_SSA_spectrum_datatable.Enabled = true;
                textBox_selectTPC.Enabled = true;
                textBox_selectTEOF.Enabled = true;
                textBox_selectRCs.Enabled = true;
                textBox_seriesname_SSA_RCs_vector_output.Enabled = true;
                textBox_seriesname_SSA_residuals_vector_output.Enabled = true;
                button_SSA_save_RCvector.Enabled = true;

            }
            else
            {
                button_plot_SSA_spectrum.Enabled = false;
                button_plotTEOFs.Enabled = false;
                button_plotTPC.Enabled = false;
                button_view_SSA_spectrum_datatable.Enabled = false;
                textBox_selectTPC.Enabled = false;
                textBox_selectTEOF.Enabled = false;
                textBox_selectRCs.Enabled = false;
                textBox_seriesname_SSA_RCs_vector_output.Enabled = false;
                textBox_seriesname_SSA_residuals_vector_output.Enabled = false;
                button_SSA_save_RCvector.Enabled = false;
            }

            RCs_exist = change_viewdatatable(selecteddataseriesname_periodicanalysis_SSA_output_RCs_vector);
            if (RCs_exist)
            {
                button_plotRCs.Enabled = true;
                button_SSA_plot_residuals.Enabled = true;
            }
            else
            {
                button_plotRCs.Enabled = false;
                button_SSA_plot_residuals.Enabled = false;
            }

            standardize_exists = change_viewdatatable(selecteddataseriesname_preprocess_standardize_output);
            if (standardize_exists)
            {
                button_plot_standardized_series.Enabled = true;
                button_datatable_znorm.Enabled = true;
            }
            else
            {
                button_plot_standardized_series.Enabled = false;
                button_datatable_znorm.Enabled = false;
            }

            cdep_exists = change_viewdatatable(selecteddataseriesname_preprocess_cumdep_output);
            if (cdep_exists)
            {
                button_plot_cumulative_departure.Enabled = true;
                button_datatable_cumdep.Enabled = true;
            }
            else
            {
                button_plot_cumulative_departure.Enabled = false;
                button_datatable_cumdep.Enabled = false;
            }

            AR_res_exists = change_viewdatatable(selecteddataseriesname_projection_AR_residuals_output);
            if (AR_res_exists)
            {
                button_plot_projection_ARsim.Enabled = true;
                button_plot_ARresiduals_ACF.Enabled = true;
                button_plotARresiduals.Enabled = true;
                button_viewdatatable_projection_ARsim.Enabled = true;
                button_viewdatatable_projection_ARres.Enabled = true;
                button_viewdatatable_projection_ARresiduals_ACF.Enabled = true;
            }
            else
            {
                button_plot_projection_ARsim.Enabled = false;
                button_plot_ARresiduals_ACF.Enabled = false;
                button_plotARresiduals.Enabled = false;
                button_viewdatatable_projection_ARsim.Enabled = false;
                button_viewdatatable_projection_ARres.Enabled = false;
                button_viewdatatable_projection_ARresiduals_ACF.Enabled = false;
            }

            ACF_exists = change_viewdatatable(selecteddataseriesname_projection_ACF_output);
            if (ACF_exists)
            {
                button_plot_ACF.Enabled = true;
                button_view_ACF_datatable.Enabled = true;
            }
            else
            {
                button_plot_ACF.Enabled = false;
                button_view_ACF_datatable.Enabled = false;
            }

            foreach (DataRow row in datamaster.Tables["Projection"].Rows)
            {
                string tempstring = row["ID"].ToString();
                if (row["ID"].ToString() == selecteddataseriesname)
                {
                    AR_projection_exists = change_viewdatatable(row["Seriesnameout"].ToString());
                    if (AR_projection_exists)
                    {
                        button_plot_AR_projection.Enabled = true;
                        button_projection_plot_envelope.Enabled = true;
                        dataGridView_projections.Enabled = true;
                        button_projections_sum_projections.Enabled = true;
                    }
                    else
                    {
                        button_plot_AR_projection.Enabled = false;
                        button_projection_plot_envelope.Enabled = false;
                        dataGridView_projections.Enabled = false;
                        button_projections_sum_projections.Enabled = false;
                    }
                }
            }

            foreach (DataRow row in datamaster.Tables["ProjectionSum"].Rows)
            {
                string tempstring = row["ID"].ToString();
                if (row["ID"].ToString() == selecteddataseriesname)
                {
                    AR_projection_sum_exists = change_viewdatatable(row["Seriesnameout"].ToString());
                    if (AR_projection_sum_exists)
                    {
                        dataGridView_projections.Enabled = true;
                        button_projections_sum_projections.Enabled = true;
                        button_projection_summed_viewdatatable.Enabled = true;
                        button_projection_plot_sum_projections.Enabled = true;
                    }
                    else
                    {
                        dataGridView_projections.Enabled = false;
                        button_projections_sum_projections.Enabled = false;
                        button_projection_summed_viewdatatable.Enabled = false;
                        button_projection_plot_sum_projections.Enabled = false;
                    }
                }
            }

            //AR_projection_sum_exists = change_viewdatatable(selecteddataseriesname_projection_AR_projections_sum);
            //if (AR_projection_sum_exists)
            //{
            //    //button_plot_AR_projection.Enabled = true;
            //    //button_projection_plot_envelope.Enabled = true;
            //    //dataGridView_projections.Enabled = true;
            //    button_projection_plot_sum_projections.Enabled = true;
            //    button_projection_summed_viewdatatable.Enabled = true;
            //}
            //else
            //{
            //    //button_plot_AR_projection.Enabled = false;
            //    //button_projection_plot_envelope.Enabled = false;
            //    //dataGridView_projections.Enabled = false;
            //    button_projection_plot_sum_projections.Enabled = false;
            //    button_projection_summed_viewdatatable.Enabled = false;
            //}

            regression_exists = change_viewdatatable(selecteddataseriesname_regression_table_output);
            if (regression_exists)
            {
                button_plot_regression.Enabled = true;
                button_regression_viewdatatable.Enabled = true;

            }
            else
            {
                button_plot_regression.Enabled = false;
                button_regression_viewdatatable.Enabled = false;
            }

            ccf_exists = change_viewdatatable(selecteddataseriesname_regression_ccf_output);
            if (ccf_exists)
            {
                button_plot_regression_ccf.Enabled = true;
                button_view_CCF_datatable.Enabled = true;
            }
            else
            {
                button_plot_regression_ccf.Enabled = false;
                button_view_CCF_datatable.Enabled = false;
            }

            curve_fit_exists = change_viewdatatable(selecteddataseriesname_stationarity_detrend_trend_output);
            if (curve_fit_exists)
            {
                button_stationarity_plot_curve_trend_dataseries.Enabled = true;
                button_stationarity_plot_residuals.Enabled = true;
                button_view_datatable_residuals.Enabled = true;
            }
            else
            {
                button_stationarity_plot_curve_trend_dataseries.Enabled = false;
                button_stationarity_plot_residuals.Enabled = false;
                button_view_datatable_residuals.Enabled = false;
            }

            differencing_exists = change_viewdatatable(selecteddataseriesname_detrend_differencing_trend_output);
            if (differencing_exists)
            {
                button_detrend_differencing_plot_residuals.Enabled = true;
                button_detrend_differencing_show_datatable.Enabled = true;
            }
            else
            {
                button_detrend_differencing_plot_residuals.Enabled = false;
                button_detrend_differencing_show_datatable.Enabled = false;
            }
        }

        public void update_text()
        {
            this.Text = "HydroClimAT—Hydrologic and Climatic Analysis Toolkit" + "     [" + this.projectname + "]";
        }

        public void update_progress_textbox(string message)
        {
            textBox_progress_text.Clear();
            textBox_progress_text.Text = message;
        }

        public void update_datagridview_progress()
        {
            dataGridView_progress.Rows.Clear();

            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["Interpolate"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["Standardize"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["CumulativeDeparture"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["ACF"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["ACF"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["Differencing"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["CurveFitting"].Value = true;
                }
            }

            foreach (DataRow dr in datamaster.Tables["Fourier"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["FourierAnalysis"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["MEM"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["MEM"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["SSA"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["EOFAnalysis"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["AR"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["ARmodeling"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["Regression"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["RegressionandCorrelation"].Value = true;
                }
            }
            foreach (DataRow dr in datamaster.Tables["Projection"].Rows)
            {
                if (dr["ID"] == selecteddataseriesname)
                {
                    dataGridView_progress.Rows[0].Cells["Project"].Value = true;
                }
            }
        }

        private void label7_Click_1(object sender, EventArgs e)
        {

        }



        public void get_dataseries_datatables()
        {
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["siteID"].ToString() != "")
                {
                    string tablename = dr["siteID"].ToString();
                    try
                    {
                        datamaster.Tables.Add(tablename);
                        build_datatable_existingdata(tablename);
                    }
                    catch
                    {
                    }
                }
            }
        }

        public void build_datatable_existingdata(string tablename)
        {
            DataColumn time = new DataColumn("time", typeof(double));
            DataColumn value = new DataColumn("value", typeof(double));

            // add the columns to the table
            datamaster.Tables[tablename].Columns.AddRange(new DataColumn[] { time, value });
        }

        public void get_first_in_sites_table()
        {
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["siteID"].ToString() != "")
                {
                    this.selecteddataseriesname = dr["siteID"].ToString();
                    return;
                }
            }
        }

        private void automaticallyGeneratePlotsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            automaticallyGeneratePlotsToolStripMenuItem.Checked = !automaticallyGeneratePlotsToolStripMenuItem.Checked;
        }

        private void label_selectRCs_Click(object sender, EventArgs e)
        {

        }

        private void label_projection_AR_projection_length_Click(object sender, EventArgs e)
        {

        }

        private void textBox_projection_AR_projection_length_TextChanged(object sender, EventArgs e)
        {

        }

        public void write_ascii_raster(double[,] value, string filename, double xllcorner, double yllcorner, double cellsize, double nodata)
        {
            StreamWriter writer = File.CreateText(filename);

            int idim = value.GetLength(0);
            int jdim = value.GetLength(1);

            // write header
            writer.WriteLine("ncols         " + idim.ToString());
            writer.WriteLine("nrows         " + jdim.ToString());
            writer.WriteLine("xllcorner     " + xllcorner.ToString());
            writer.WriteLine("yllcorner     " + yllcorner.ToString());
            writer.WriteLine("cellsize      " + cellsize.ToString());
            writer.WriteLine("NODATA_value  " + nodata.ToString());


            for (int j = jdim-1; j >= 0; j--)
            {
                for (int i = 0; i < idim; i++)
                {
                    if (value[i, j].Equals("NaN")) value[i, j] = nodata;
                    writer.Write(value[i, j].ToString() + " ");
                }
                writer.Write(writer.NewLine);
            }
            writer.Close();
        }

        private void export_grid_textfile_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form_export_csv_grid form_export_csv_grid = new Form_export_csv_grid(datamaster, selecteddataseriesname, this);
            form_export_csv_grid.Show();
        }

        public void write_2D_array_double(double[,] value, string filename)
        {
            StreamWriter writer = File.CreateText(filename);
            int idim = value.GetLength(0);
            int jdim = value.GetLength(1);
            for (int i = 0; i < idim; i++)
            {
                for (int j = 0; j < jdim; j++)
                {
                    writer.Write(value[i, j].ToString() + " ");
                }
                writer.Write(writer.NewLine);
            }
        }

        public void write_2D_array_double_csv(double[,] value, string filename)
        {
            StreamWriter writer = File.CreateText(filename);
            int idim = value.GetLength(0);
            int jdim = value.GetLength(1);
            for (int i = 0; i < idim; i++)
            {
                for (int j = 0; j < jdim; j++)
                {
                    writer.Write(value[i, j].ToString());
                    if (j != jdim - 1)
                    {
                        writer.Write(",");
                    }
                }
                writer.Write(writer.NewLine);
            }
            writer.Close();
        }

        public void write_2D_array_string_csv(string[,] value, string filename)
        {
            StreamWriter writer = File.CreateText(filename);
            int idim = value.GetLength(0);
            int jdim = value.GetLength(1);
            for (int i = 0; i < idim; i++)
            {
                for (int j = 0; j < jdim; j++)
                {
                    writer.Write(value[i, j].ToString());
                    if (j != jdim - 1)
                    {
                        writer.Write(",");
                    }
                }
                writer.Write(writer.NewLine);
            }
            writer.Close();
        }

        public void write_2D_array_stringList_csv(List <string> a, List <string> b, string filename)
        {
            StreamWriter writer = File.CreateText(filename);
            string [] col1 = a.ToArray();
            string [] col2 = b.ToArray();
 
            int n = col1.Length;
            string[] str2write = new string[n];
            for (int i = 0; i < n; i++)
            {
                str2write[i] = col1[i] + ", " + col2[i];
                writer.Write(str2write[i].ToString());
                writer.Write(writer.NewLine);
            }
            writer.Close();
        }

        public void write_1D_results_double(double[] x, string filename)
        {

            StreamWriter writer = File.CreateText(filename);

            for (int i = 0; i < x.Length; i++)
            {
                writer.WriteLine(x[i]);
            }
            writer.Close();
        }

        private void export_grid_rasterFileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form_export_raster form_export_raster = new Form_export_raster(datamaster, selecteddataseriesname, this);
            form_export_raster.Show();
        }

        private void mnuImport_NWIS_Click(object sender, EventArgs e)
        {
            Form_import_NWIS import_NWIS_form = new Form_import_NWIS(datamaster, this);
            import_NWIS_form.Show();
        }

        private void workspaceToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Workspace form_workspace = new Workspace(datamaster, selecteddataseriesname);
            form_workspace.Show();
        }

        private void export_time_series_textfile_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form_export_csv_vector form_export_csv_vector = new Form_export_csv_vector(datamaster, selecteddataseriesname, this);
            form_export_csv_vector.Show();
        }

        private void textBox_selectRCs_TextChanged(object sender, EventArgs e)
        {

        }

        private void organizeinputs_ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form_organize_series form_organize_series = new Form_organize_series(datamaster);
            form_organize_series.Show();
        }








    }
    

}
