﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
//using MathNet;
//using MathNet.Numerics.LinearAlgebra.Double;
//using MathNet.Numerics.LinearAlgebra.Double.Factorization;


namespace Climate_toolkit
{
    public partial class FormToolkit
    {
        //int firstloop;
        //int secondloop;
        //int thirdloop;

        int selectedscaledEOF = 1;
        int selected_PC = 1;

        double maxlatitude = 0;
        double minlatitude = 0;

        // variables for SSA analysis

        string selecteddataseriesname_EOF_input;
        string selecteddataseriesname_EOF_output;
        string selecteddataseriesname_EOF_output_spectrum;
        string selecteddataseriesname_EOF_output_spectrum_normalized;
        string selecteddataseriesname_EOF_output_EOFs;
        string selecteddataseriesname_EOF_output_PCs;
        string selecteddataseriesname_EOF_output_scaled_EOFs;
        string selecteddataseriesname_EOF_output_selected_PC;
        string selecteddataseriesname_EOF_output_selected_scaled_EOF;
        string selecteddataseriesname_EOF_output_spectrum_error;
        string selecteddataseriesname_EOF_output_spectrum_error_normalized;

        bool EOF_plot_percent_variance = false;
        bool EOF_exists = false;

        bool EOF_scalebylatitude = false;

        bool EOF_rotate = false;

        #region page layout

        public void fill_combobox_with_datatablenames_EOF()
        {
            comboBox_EOF_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_EOF_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }

            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_EOF_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }


            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_EOF_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_EOF_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_EOF_dataseriesname.Items.Add(table.TableName);
            //                comboBox_EOF_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_EOF_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        private void comboBox_EOF_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_EOF_input = (string)comboBox_EOF_dataseriesname.SelectedItem;
            this.selecteddataseriesname_EOF_output = (string)comboBox_EOF_dataseriesname.SelectedItem;

            this.selecteddataseriesname_EOF_output_spectrum = selecteddataseriesname_EOF_output + "_EOFstm"; // add default suffix
            this.selecteddataseriesname_EOF_output_spectrum_normalized = selecteddataseriesname_EOF_output + "_EOFstm_var"; // add default suffix
            this.selecteddataseriesname_EOF_output_spectrum_error = selecteddataseriesname_EOF_output + "_EOFstm_er";
            this.selecteddataseriesname_EOF_output_spectrum_error_normalized = selecteddataseriesname_EOF_output + "_EOFstm_er_var";

            this.selecteddataseriesname_EOF_output_EOFs = selecteddataseriesname_EOF_output + "_EOFs"; // add default suffix
            this.selecteddataseriesname_EOF_output_PCs = selecteddataseriesname_EOF_output + "_PCs"; // add default suffix
            this.selecteddataseriesname_EOF_output_scaled_EOFs = selecteddataseriesname_EOF_output + "_scaled_EOFs"; // add default suffix
            this.selecteddataseriesname_EOF_output_selected_PC = selecteddataseriesname_EOF_output_PCs + "_" + this.textBox_EOF_output_select_PC.Text.ToString();
            this.selecteddataseriesname_EOF_output_selected_scaled_EOF = selecteddataseriesname_EOF_output_scaled_EOFs + "_" + this.textBox_EOF_output_select_scaledEOF.Text.ToString();

            this.textBox_seriesname_EOF_spectrum_output.Text = this.selecteddataseriesname_EOF_output_spectrum;
            this.textBox_seriesname_EOF_EOFs_output.Text = this.selecteddataseriesname_EOF_output_EOFs;
            this.textBox_seriesname_EOF_PCs_output.Text = this.selecteddataseriesname_EOF_output_PCs;
            this.textBox_seriesname_EOF_scaledEOFs_output.Text = this.selecteddataseriesname_EOF_output_scaled_EOFs;
            this.textBox_seriesname_output_EOF_selectedPC.Text = this.selecteddataseriesname_EOF_output_selected_PC;
            this.textBox_seriesname_output_EOF_selectedscaledEOF.Text = this.selecteddataseriesname_EOF_output_selected_scaled_EOF;
    
            // provide some default values to fill in textboxes
            checkBox_EOF_show_percent_variance.Checked = false;

            //comboBox_EOF_rotationmethod.SelectedItem = "varimax";

            EOF_exists = change_viewdatatable(selecteddataseriesname_EOF_output_spectrum);
            if (EOF_exists)
            {
                button_plot_EOF_spectrum.Enabled = true;
                button_plot_EOF_SPC.Enabled = true;
                button_view_EOF_spectrum_datatable.Enabled = true;
                checkBox_EOF_show_percent_variance.Enabled = true;
                button_EOF_save_scaledEOF.Enabled = true;
            }
            else
            {
                button_plot_EOF_spectrum.Enabled = false;
                button_plot_EOF_SPC.Enabled = false;
                button_view_EOF_spectrum_datatable.Enabled = false;
                checkBox_EOF_show_percent_variance.Enabled = false;
                button_EOF_save_scaledEOF.Enabled = false;
            }
        }

        private void textBox_EOF_output_scaledEOF_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox_seriesname_EOF_scaledEOFs_output_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox_seriesname_EOF_spectrum_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_spectrum = this.textBox_seriesname_EOF_spectrum_output.Text;

        }

        private void textBox_seriesname_EOF_EOFs_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_EOFs = this.textBox_seriesname_EOF_EOFs_output.Text;
        }

        private void textBox_seriesname_EOF_PCs_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_PCs = this.textBox_seriesname_EOF_PCs_output.Text;
        }

        private void textBox_seriesname_EOF_scaledEOFs_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_scaled_EOFs = this.textBox_seriesname_EOF_scaledEOFs_output.Text;
        }

        private void textBox_EOF_output_scaledEOF_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_scaled_EOFs = this.textBox_seriesname_EOF_scaledEOFs_output.Text;
        }

        private void textBox_seriesname_output_EOF_selectedPC_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_selected_PC = this.textBox_seriesname_output_EOF_selectedPC.Text;
        }

        private void textBox_seriesname_output_EOF_selectedscaledEOF_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_EOF_output_selected_scaled_EOF = this.textBox_seriesname_output_EOF_selectedscaledEOF.Text;
        }

        private void textBox_EOF_output_select_scaledEOF_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.selectedscaledEOF = Convert.ToInt32(textBox_EOF_output_select_scaledEOF.Text);
                this.selecteddataseriesname_EOF_output_selected_scaled_EOF = selecteddataseriesname_EOF_output_scaled_EOFs + "_" + this.textBox_EOF_output_select_scaledEOF.Text.ToString();
                this.textBox_seriesname_output_EOF_selectedscaledEOF.Text = this.selecteddataseriesname_EOF_output_selected_scaled_EOF;
            }
            catch
            {
                if (textBox_EOF_output_select_scaledEOF.Text != "")
                {
                    MessageBox.Show("Please enter a real number");
                    textBox_EOF_output_select_scaledEOF.Clear();
                }
            }

        }

        private void textBox_EOF_output_select_PC_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                this.selected_PC = Convert.ToInt32(textBox_EOF_output_select_PC.Text);
                this.selecteddataseriesname_EOF_output_selected_PC = selecteddataseriesname_EOF_output_PCs + "_" + this.textBox_EOF_output_select_PC.Text.ToString();
                this.textBox_seriesname_output_EOF_selectedPC.Text = this.selecteddataseriesname_EOF_output_selected_PC;
            }
            catch
            {
                if (textBox_EOF_output_select_PC.Text != "")
                {
                    MessageBox.Show("Please enter a real number");
                    textBox_EOF_output_select_PC.Clear();
                }
            }
        }

        #endregion page layout

        #region EOF_actions
        private void button_calculate_EOF_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            // first check that the dataseries is a series of arrays
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    if (dr["DataType"] == "Vector")
                    {
                        MessageBox.Show("EOF analysis requires a matrix time series. The program thinks it's a vector time series");
                        Cursor.Current = Cursors.Default;
                        return;
                    }
                }
            }

            try
            {
                // This method gets EOFs, PCS, and scaled EOFs by eigenanalysis of a covariance matrix

                // get the dimensions of the array
                int firstloop = 1;
                int secondloop = 1;
                int thirdloop = 1;

                double tempmean;
                double tempvariance;

                foreach (DataRow dr in datamaster.Tables["sites"].Rows)
                {
                    if (dr["ID"].ToString() == selecteddataseriesname && dr["DataForm"].ToString() == "matrix")
                    {
                        firstloop = Convert.ToInt32(dr["Dim1"]);
                        secondloop = Convert.ToInt32(dr["Dim2"]);
                        thirdloop = Convert.ToInt32(dr["Dim3"]);
                    }
                    break;
                }

                // get the loaded 2D data in the datatable into a 2D array
                double[] a = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_EOF_input, 0);

                double[, ,] A = get_3loop_array_data(a, firstloop, secondloop, thirdloop);

                // Prepare data
                // remove climatological mean
                double[,] A_temporal_mean = get_grid_temporal_mean(A);
                update_progress_textbox("Removing climotological mean...");
                double[, ,] A_anomaly = remove_temporal_mean(A, A_temporal_mean);



                // if the user selects, weight each grid box by the square root of the cosine of the latitude
                if (EOF_scalebylatitude == true)
                {
                    update_progress_textbox("Weighting the data based on latitude...");
                    A_anomaly = scale_by_latitude(A_anomaly, this.minlatitude, this.maxlatitude);
                }

                // When regressing the PCs onto the orginal data, only use unscaled data  
                double[,] A_anomaly_unscaled = prepare_EOF_spacebytime_matrix(A_anomaly); // this is used for regression      
                //var A_anomaly_unscaledvar = new DenseMatrix(A_anomaly_unscaled);

                // option for scaling a grid based on lat and long
                //double[, ,] A_anomaly = scale_by_latitude(A_anomaly, lat_min, lat_max);

                double[,] X = prepare_EOF_spacebytime_matrix(A_anomaly);
                //var Xvar = new DenseMatrix(X);



                int M = X.GetLength(0); // temporal dimension
                int N = X.GetLength(1); // spatial dimension


                // get covariance matrix
                //double[,] C = new double[M, M];

                // The A matrix is probably larger in column dimension (N, x and y data)
                // than row dimension (M, time). So, use AAT to first get PCs, then get EOFs
                // If the reverse, then would be better to do ATA to first get EOFs, then get PCs...
                update_progress_textbox("Getting covariance matrix...");
                //C = CEOFFactory.get_covariance_matrix_AAT(X);
                double[,] C = CEOFFactory.get_covariance_matrix_AAT_alglib(X);

                double[] eigenvalues = new double[M];
                double[] eigenvalues_normalized = new double[M];

                double[,] eigenvectors = new double[M, M];

                double[,] PCs = new double[M, M];
                double[,] EOFs = new double[N, N];

                double[] PCs_mean = new double[M];
                double[] PCs_stdev = new double[M];
                double[,] PCs_norm = new double[M, M];

                double[, ,] EOFs_scaled = new double[firstloop, secondloop, thirdloop];

                //var Cvar = new DenseMatrix(C);

                update_progress_textbox("Performing eigenanalysis of the covariance matrix...");
                //eigenvalues = CEOFFactory.get_eigenvalues(Cvar);
                //eigenvectors = CEOFFactory.get_eigenvectors(Cvar); // these are PCs since doing AAT

                //CEOFFactory.get_covariance_matrix_AAT(X);



                //var eigvvar = new DenseMatrix(eigenvectors); // var containing PCs

                // check code from alglib
                double[] eigenval = new double[M];
                double[,] eigenvec = new double[M, M];
                CEOFFactory.get_EVD(C, out eigenvalues, out eigenvec);

                // end check from alglib

                //var eigvvarT = eigvvar.Transpose();
                //double[,] eigvT = eigvvarT.ToArray();

                for (int i = 0; i < M; i++)
                {
                    for (int j = 0; j < M; j++)
                    {
                        PCs[i, j] = eigenvec[i, j];
                    }
                }

                update_progress_textbox("Getting SEOF and SPC matrices");

                // Get EOFs by projecting A (data matrix) onto the normalized PCs
                //var evvar = new DenseMatrix(eigenvectors);
                //EOFs = evvar.Transpose().Multiply(Xvar).Transpose().ToArray();
                double[,] EOFsalglib = new double[N, M];

                EOFsalglib = CEOFFactory.get_EOFS_by_projection(X, eigenvec);

                // normalize the eigenvalues for percent variance
                eigenvalues_normalized = CFourierAnalysisFactory.get_spectrum_scale_to_one(eigenvalues);

                // normalize the PCs
                double[] pctemp = new double[M];
                double[] pcnormtemp = new double[M];

                for (int j = 0; j < M; j++)
                {
                    for (int k = 0; k < M; k++)
                    {
                        pctemp[k] = PCs[k, j];
                    }
                    pcnormtemp = CStatsFactory.CStandardizeFactory.get_standardize_z(pctemp, out tempmean, out tempvariance);
                    for (int k = 0; k < M; k++)
                    {
                        PCs_norm[k, j] = pcnormtemp[k];
                    }
                }

                // get fraction of variance for each eigenvalue

                double[] fraction_variance = get_eigenvalue_fraction_variance(eigenvalues);

                // North test for significance
                // get error bars
                double[] eigenvalue_error_bars = get_eigenvalue_error_bars(eigenvalues, thirdloop); //thirdloop is the time dimension
                double[] eigenvalue_error_bars_normalized = get_eigenvalue_error_bars(eigenvalues_normalized, thirdloop); //thirdloop is the time dimension

                //regress the data onto the onto the PCs to get EOFs scaled in actual units
                double[,] EOFs_scaledtemp = new double[firstloop, secondloop];
                for (int l = 0; l < M; l++) // the number of the PC
                {
                    for (int k = 0; k < M; k++) // time along the PC
                    {
                        pcnormtemp[k] = PCs_norm[k, l];
                    }

                    double[] scaled_EOFs = new double[N];
                    // get transpose of pcnormtemp

                    alglib.ablas.rmatrixmv(N, M, A_anomaly_unscaled, 0, 0, 1, pcnormtemp, 0, ref scaled_EOFs, 0);
                    for (int i = 0; i < N; i++)
                    {
                        scaled_EOFs[i] = scaled_EOFs[i] / Convert.ToDouble(M);
                    }
                    //var scaled_EOFsvar = pcnormtemp * A_anomaly_unscaledvar / M;
                    EOFs_scaledtemp = get_EOF_map(scaled_EOFs, firstloop, secondloop);
                    //EOFs_scaledtemp = get_EOF_map(scaled_EOFsvar, firstloop, secondloop);
                    for (int j = 0; j < secondloop; j++)
                    {
                        for (int i = 0; i < firstloop; i++)
                        {
                            //EOFs_scaled[i, j, l] = EOFs_scaledtemp[i,j]; // l is the number of the scaled EOF
                            EOFs_scaled[i, j, l] = EOFs_scaledtemp[i, j]; // l is the number of the scaled EOF
                        }
                    }

                }

                save_row_EOF_table(selecteddataseriesname, selecteddataseriesname_EOF_input, selecteddataseriesname_EOF_output_spectrum,
                    selecteddataseriesname_EOF_output_EOFs, selecteddataseriesname_EOF_output_PCs, selecteddataseriesname_EOF_output_scaled_EOFs,
                    minlatitude, maxlatitude);
                update_datagridview_progress();

                // create tables in datamaster
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_spectrum);
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_spectrum_normalized);
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_spectrum_error);
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_spectrum_error_normalized);
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_EOFs);
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_PCs);
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_scaled_EOFs);

                // make a vector for x values for spectrum from 1 to number of eigenvalues
                double[] x = new double[eigenvalues.Length];
                for (int i = 0; i < eigenvalues.Length; i++)
                {
                    x[i] = i + 1;
                }

                get_EOF_spectrum_datatable(x, eigenvalues_normalized, selecteddataseriesname_EOF_output_spectrum_normalized, "Percent Variance");
                get_EOF_spectrum_datatable(x, eigenvalue_error_bars_normalized, selecteddataseriesname_EOF_output_spectrum_error_normalized, "Percent Variance");

                get_EOF_spectrum_datatable(x, eigenvalues, selecteddataseriesname_EOF_output_spectrum, "Eigenvalue");
                get_EOF_spectrum_datatable(x, eigenvalue_error_bars, selecteddataseriesname_EOF_output_spectrum_error, "Percent Variance");

                copy2DArrayIntoDataTable(EOFs, selecteddataseriesname_EOF_output_EOFs);
                copy2DArrayIntoDataTable(PCs, selecteddataseriesname_EOF_output_PCs);
                copy3Darray_into_Datatable_vector(EOFs_scaled, firstloop, secondloop, thirdloop, selecteddataseriesname_EOF_output_scaled_EOFs);

                EOF_exists = change_viewdatatable(selecteddataseriesname_EOF_output_spectrum);
                if (EOF_exists)
                {
                    button_plot_EOF_spectrum.Enabled = true;
                    button_plot_EOF_SPC.Enabled = true;
                    button_view_EOF_spectrum_datatable.Enabled = true;
                    checkBox_EOF_show_percent_variance.Enabled = true;
                    button_EOF_save_PC.Enabled = true;
                    button_EOF_save_scaledEOF.Enabled = true;
                    update_progress_textbox("EOF analysis complete.");
                }
                else
                {
                    button_plot_EOF_spectrum.Enabled = false;
                    button_plot_EOF_SPC.Enabled = false;
                    button_view_EOF_spectrum_datatable.Enabled = false;
                    checkBox_EOF_show_percent_variance.Enabled = false;
                    button_EOF_save_PC.Enabled = false;
                    button_EOF_save_scaledEOF.Enabled = false;
                    update_progress_textbox("Something went wrong. The EOF analysis is not complete.");
                }

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it.
                    if (EOF_plot_percent_variance == true)
                    {
                        Form_eigen_spectrum_plot_EOF form_eigen_plot = new Form_eigen_spectrum_plot_EOF(datamaster, selecteddataseriesname_EOF_output_spectrum_normalized, 0, 1, selecteddataseriesname_EOF_output_spectrum_error_normalized, this);
                        form_eigen_plot.Show();

                    }
                    else
                    {
                        Form_eigen_spectrum_plot_EOF form_eigen_plot = new Form_eigen_spectrum_plot_EOF(datamaster, selecteddataseriesname_EOF_output_spectrum, 0, 1, selecteddataseriesname_EOF_output_spectrum_error, this);
                        form_eigen_plot.Show();
                    }

                }
            }
            catch
            {
                MessageBox.Show("Something went wrong. The EOF analysis is not complete.");
                Cursor.Current = Cursors.Default;
            }
            Cursor.Current = Cursors.Default;
        }

        private void checkBox_EOF_show_percent_variance_CheckedChanged(object sender, EventArgs e)
        {
            EOF_plot_percent_variance =! EOF_plot_percent_variance;
        }

        private void button_plot_EOF_spectrum_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it.
            if (EOF_plot_percent_variance == true)
            {
                Form_eigen_spectrum_plot_EOF form_eigen_plot = new Form_eigen_spectrum_plot_EOF(datamaster, selecteddataseriesname_EOF_output_spectrum_normalized, 0, 1, selecteddataseriesname_EOF_output_spectrum_error_normalized, this);
                form_eigen_plot.Show();

            }
            else
            {
                Form_eigen_spectrum_plot_EOF form_eigen_plot = new Form_eigen_spectrum_plot_EOF(datamaster, selecteddataseriesname_EOF_output_spectrum, 0, 1, selecteddataseriesname_EOF_output_spectrum_error, this);
                form_eigen_plot.Show();
            }
        }

        private void button_view_EOF_spectrum_datatable_Click(object sender, EventArgs e)
        {
            if (EOF_plot_percent_variance == true)
            {
                // Open the form for plotting data. Pass the datamaster dataset to it. 
                Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_EOF_output_spectrum_normalized);
                form_grid.Show();
            }
            else
            {
                // Open the form for plotting data. Pass the datamaster dataset to it. 
                Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_EOF_output_spectrum);
                form_grid.Show();
            }
        }

        private void button_EOF_save_scaledEOF_Click(object sender, EventArgs e)
        {
            // get the number of the scaled EOF to save
            int EOFnum = Convert.ToInt32(textBox_EOF_output_select_scaledEOF.Text);

            // get the dimensions of the array
            int firstloop = 1;
            int secondloop = 1;
            int thirdloop = 1;
            
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname && dr["DataForm"].ToString() == "matrix")
                {
                    firstloop = Convert.ToInt32(dr["Dim1"]);
                    secondloop = Convert.ToInt32(dr["Dim2"]);
                    thirdloop = Convert.ToInt32(dr["Dim3"]);
                }
                break;
            }

            if (EOFnum > thirdloop || EOFnum < 1)
            {
                MessageBox.Show("The total number of EOFs is " + thirdloop.ToString() + ". Please select a number between 1 and " + thirdloop.ToString());
            }

            try
            {

                // create a datatable in datamaster to hold this
                get_new_datatable_in_datamaster(this.selecteddataseriesname_EOF_output_selected_scaled_EOF);

                // create an array to hold the scaled eof
                double[,] scaledEOF = new double[firstloop, secondloop];

                // get the scaled EOF 3D array from datamaster
                double[] a = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_EOF_output_scaled_EOFs, 0);

                // put the vector of all scaled EOFs into a 3D array
                double[, ,] A = get_3loop_array_data(a, firstloop, secondloop, thirdloop);

                for (int j = 0; j < secondloop; j++)
                {
                    for (int i = 0; i < firstloop; i++)
                    {
                        scaledEOF[i, j] = A[i, j, EOFnum-1]; // use minus 1 because the array begins with 0
                    }
                }

                save_row_EOF_ScaledEOF_vectors_table(selecteddataseriesname, selecteddataseriesname_EOF_input, selecteddataseriesname_EOF_output_selected_scaled_EOF);

                // put the matrix of the scaled EOF into a vector in datamaster
                copy2Darray_into_Datatable_vector(scaledEOF, firstloop, secondloop, this.selecteddataseriesname_EOF_output_selected_scaled_EOF);
                //copy2DArrayIntoDataTable(scaledEOF, this.selecteddataseriesname_EOF_output_selected_scaled_EOF);
                MessageBox.Show("The scaled EOF is saved and can be exported");
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void button_EOF_save_PC_Click(object sender, EventArgs e)
        {
            // get the number of the scaled EOF to save
            int PCnum = Convert.ToInt32(textBox_EOF_output_select_PC.Text);

            // get the dimensions of the array
            int firstloop = 1;
            int secondloop = 1;
            int thirdloop = 1;
            
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname && dr["DataForm"].ToString() == "matrix")
                {
                    firstloop = Convert.ToInt32(dr["Dim1"]);
                    secondloop = Convert.ToInt32(dr["Dim2"]);
                    thirdloop = Convert.ToInt32(dr["Dim3"]);
                }
                break;
            }

            if (PCnum > thirdloop || PCnum < 1)
            {
                MessageBox.Show("The total number of PCs is " + thirdloop.ToString() + ". Please select a number between 1 and " + thirdloop.ToString());
            }

            try
            {
                // get vector of the PC from datamaster
                double[] PC = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_EOF_output_PCs, PCnum - 1);

                // assign values along x axis
                double[] x = new double[PC.Length];
                for (int i = 0; i < PC.Length; i++)
                {
                    x[i] = i;
                }

                save_row_EOF_SPC_vectors_table(selecteddataseriesname, selecteddataseriesname_EOF_input, selecteddataseriesname_EOF_output_selected_PC);

                // create a table in datamaster to hold the results
                get_new_datatable_in_datamaster(selecteddataseriesname_EOF_output_selected_PC);

                // put results into the table in datamaster
                get_datatable_from_twoColArray(x, PC, selecteddataseriesname_EOF_output_selected_PC);

                selectedseries_mostrecent = selecteddataseriesname_EOF_output_selected_PC;

                fill_combobox_with_datatablenames_Describe_data();
                fill_combobox_with_datatablenames_interpolate_data();
                fill_combobox_with_datatablenames_standardize_data();
                fill_combobox_with_datatablenames_cumulative_departure();
                fill_combobox_with_datatablenames_ACF();
                fill_combobox_with_datatablenames_detrend();
                fill_combobox_with_datatablenames_differencing();
                fill_combobox_with_datatablenames_spectralanalysis();
                fill_combobox_with_datatablenames_MEM();
                fill_combobox_with_datatablenames_SSA();
                fill_combobox_with_datatablenames_AR();

                MessageBox.Show("The PC is saved and can be exported");

            }
            catch
            {
                MessageBox.Show("Something went wrong. The PC wasn't saved.");
            }
        }

        private void button_plot_EOF_SPC_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 

            int y = Convert.ToInt32(textBox_EOF_output_select_PC.Text);
            Form_plot_matrix form_plot_matrix = new Form_plot_matrix(datamaster, selecteddataseriesname_EOF_output_PCs, y, this);

            form_plot_matrix.Show();
        }

        private void checkBox_EOF_scalebylatitude_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox_EOF_scalebylatitude.Checked == true)
            {
                EOF_scalebylatitude = true;
                textBox_EOF_latitude_min.Enabled = true;
                textBox_EOF_latitude_max.Enabled = true;
            }
            else
            {
                EOF_scalebylatitude = false;
                textBox_EOF_latitude_min.Enabled = false;
                textBox_EOF_latitude_max.Enabled = false;
            }
        }

        private void textBox_EOF_latitude_min_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                minlatitude = Convert.ToDouble(textBox_EOF_latitude_min.Text);
            }
            catch
            {
                if (textBox_EOF_latitude_min.Text != "")
                {
                    MessageBox.Show("Please enter a real number");
                    textBox_EOF_latitude_min.Clear();
                }
            }
        }

        private void textBox_EOF_latitude_max_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                maxlatitude = Convert.ToDouble(textBox_EOF_latitude_max.Text);
            }
            catch
            {
                if (textBox_EOF_latitude_max.Text != "")
                {
                    MessageBox.Show("Please enter a real number");
                    textBox_EOF_latitude_max.Clear();
                }
            }
        }

        private void checkBox_EOF_rotate_CheckedChanged(object sender, EventArgs e)
        {
            //if (checkBox_EOF_rotate.Checked == true)
            //{
            //    EOF_rotate = true;
            //}
            //else
            //{
            //    EOF_rotate = false;
            //}
        }

        #endregion EOF_actions

        private static double[,] get_grid_temporal_mean(double[, ,] x)
        {
            //get the dimensions of x
            int timedim = x.GetLength(2);
            int ydim = x.GetLength(1);
            int xdim = x.GetLength(0);

            double[,] temporal_mean = new double[xdim, ydim];
            double[] local_value = new double[timedim];

            for (int i = 0; i < xdim; i++)
            {
                for (int j = 0; j < ydim; j++)
                {
                    for (int k = 0; k < timedim; k++)
                    {
                        local_value[k] = x[i, j, k];
                    }
                    temporal_mean[i, j] = CStatsFactory.get_mean(local_value);
                }
            }

            return temporal_mean;
        }

        private static double[, ,] remove_temporal_mean(double[, ,] x, double[,] xmean)
        {
            int timedim = x.GetLength(2);
            int ydim = x.GetLength(1);
            int xdim = x.GetLength(0);
            double[, ,] x_mean_removed = new double[xdim, ydim, timedim];

            for (int i = 0; i < xdim; i++)
            {
                for (int j = 0; j < ydim; j++)
                {
                    for (int k = 0; k < timedim; k++)
                    {
                        x_mean_removed[i, j, k] = x[i, j, k] - xmean[i, j];
                    }
                }
            }
            return x_mean_removed;
        }

        private static double[, ,] scale_by_latitude(double[, ,] x, double start_latitude, double end_latitude)
        {
            int timedim = x.GetLength(2);
            int ydim = x.GetLength(1);
            int xdim = x.GetLength(0);

            double ydimdouble = Convert.ToDouble(ydim);

            double[] latitude = new double[ydim];
            double[, ,] x_scaled = new double[xdim, ydim, timedim];

            //make vector of latitudes
            for (int j = 0; j < ydim; j++)
            {
                if (j == 0)
                {
                    latitude[j] = start_latitude;
                }
                else
                {
                    latitude[j] = latitude[j - 1] + (end_latitude - start_latitude) / (ydimdouble - 1);
                }
            }

            for (int i = 0; i < xdim; i++)
            {
                for (int j = 0; j < ydim; j++)
                {
                    for (int k = 0; k < timedim; k++)
                    {
                        x_scaled[i, j, k] = x[i, j, k] * Math.Sqrt(Math.Cos(latitude[j] * Math.PI / 180));
                    }
                }
            }
            return x_scaled;
        }

        public static double[,] prepare_EOF_spacebytime_matrix(double[, ,] x)
        {
            int idim = x.GetLength(0);
            int jdim = x.GetLength(1);
            int kdim = x.GetLength(2);

            double[,] A = new double[kdim, idim * jdim]; // time M by space N

            for (int k = 0; k < kdim; k++)
            {
                for (int j = 0; j < jdim; j++)
                {
                    for (int i = 0; i < idim; i++)
                    {
                        A[k, i * jdim + j] = x[i, j, k];
                    }
                }
            }
            return A;
        }

        public static double[] get_eigenvalue_fraction_variance(double[] lamda)
        {
            int numlambda = lamda.Length;
            double total_var = 0.0;
            double[] fraction_variance = new double[lamda.Length];

            for (int i = 0; i < numlambda; i++)
            {
                if (i == 0) total_var = lamda[0];
                else
                {
                    total_var = total_var + lamda[i];
                }
            }

            for (int i = 0; i < numlambda; i++)
            {
                fraction_variance[i] = lamda[i] / total_var;
            }
            return fraction_variance;
        }

        public static double[] get_eigenvalue_error_bars(double[] eigenvalues, int n)
        {
            // lamda is a vector of the eigenvalues

            /* n is the effective sample size n*
             * This is very hard to determine! Wilks (page 492) states "an appropriate 
             * modification to the effective sample size adjustment appears not to have been published."
             * Wilks suggests using lag-1 autocorrelation:
             * n* = n*Math.Pow((1-Math.Pow(p1,2))/(1+Math.Pow(p1,2)),2);
             * Calculate this for each point in the domain and then take the domain average, but this 
             * still isn't clear in Wilks or Von Storch.
             */

            /* delta_lamda is one half of the sampling error. To plot the spectrum of the eigenvalues,
            * the total sampling error for lamda[i] is 2*delta_lamda, where lamda_delta is plotted above
            * and below the eigenvalue.
            */

            double[] delta_lamda = new double[eigenvalues.Length];
            double n_double = Convert.ToDouble(n);
            for (int i = 0; i < eigenvalues.Length; i++)
            {
                delta_lamda[i] = eigenvalues[i] * Math.Sqrt(2 / n_double);
            }

            return delta_lamda;
        }

        public static double[,] get_EOF_map(double[] x, int xdim, int ydim)
        {
            // matrix of EOF values is arranged as M(time) by N(space)
            //int timedim = x.GetLength(0);
            int spacedim = x.GetLength(0);
            int count;
            double[] x_space = new double[spacedim];
            double[,] x_spacebyspace = new double[xdim, ydim];

            //// first get an array of just the PC that you want
            //for (int i = 0; i< spacedim; i++)
            //{
            //    x_space[i] = x[i];
            //}
            // next separate the desired spatial dimensions from the spatial vector
            count = 0;
            for (int i = 0; i < xdim; i++)
            {
                for (int j = 0; j < ydim; j++)
                {
                    x_spacebyspace[i, j] = x[count];
                    count++;
                }
            }
            return x_spacebyspace;
        }
    }
}
