﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
//using MathNet;
//using MathNet.Numerics.LinearAlgebra.Double;
//using MathNet.Numerics.LinearAlgebra.Double.Factorization;


namespace Climate_toolkit
{
    partial class FormToolkit
    {
        // variables for MEM analysis

        string selecteddataseriesname_MEM_input;
        string selecteddataseriesname_MEM_output;
        string selecteddataseriesname_MEM_output_spectrum;

        double MEM_sampling_interval = 1;
        int MEM_order = 10;
        int MEM_no_frequencies = 256;

        bool MEM_exists = false;

        #region pagelayout
        public void fill_combobox_with_datatablenames_MEM()
        {
            comboBox_MEM_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_MEM_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_MEM_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_MEM_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_MEM_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_MEM_dataseriesname.Items.Add(table.TableName);
            //                comboBox_MEM_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_MEM_selectseriesname.SelectedItem = selecteddataseriesname;
        }

        private void comboBox_MEM_selectseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_MEM_input = (string)comboBox_MEM_dataseriesname.SelectedItem;
            this.selecteddataseriesname_MEM_output = (string)comboBox_MEM_dataseriesname.SelectedItem;

            this.selecteddataseriesname_MEM_output_spectrum = selecteddataseriesname_MEM_output + "_MEMstm"; // add default suffix

            this.textBox_seriesname_MEM_spectrum_output.Text = this.selecteddataseriesname_MEM_output_spectrum;
        }

        //private void comboBox_MEM_selectseriesname_SelectedIndexChanged(object sender, EventArgs e)
        //{

        //}

        private void textBox_seriesname_MEM_spectrum_output_Validating(object sender, CancelEventArgs e)
        {
            this.selecteddataseriesname_MEM_output_spectrum = this.textBox_seriesname_MEM_spectrum_output.Text;
        }



        //private void textBox_seriesname_MEM_spectrum_output_Validating(object sender, CancelEventArgs e)
        //{

        //}

        private void textBox_MEM_samplinginterval_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                MEM_sampling_interval = Convert.ToInt32(textBox_MEM_samplinginterval.Text);
            }
            catch
            {
                if (textBox_MEM_samplinginterval.Text != "")
                {
                    MessageBox.Show("Please enter a real number");
                    textBox_MEM_samplinginterval.Clear();
                    textBox_MEM_samplinginterval.Text = "1";
                    MEM_sampling_interval = Convert.ToInt32(textBox_MEM_samplinginterval.Text);
                }
            }
        }
        //private void textBox_MEM_samplinginterval_Validating(object sender, CancelEventArgs e)
        //{

        //}
        private void textBox_MEM_MEMorder_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                MEM_order = Convert.ToInt32(textBox_MEM_MEMorder.Text);
            }
            catch
            {
                if (textBox_MEM_MEMorder.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_MEM_MEMorder.Clear();
                    textBox_MEM_MEMorder.Text = "10";
                    MEM_order = Convert.ToInt32(textBox_MEM_MEMorder.Text);
                }
            }
        }

        //private void textBox_MEM_MEMorder_Validating(object sender, CancelEventArgs e)
        //{

        //}
        private void textBox_MEM_nosamplingfreq_Validating(object sender, CancelEventArgs e)
        {

        }
        //private void textBox_MEM_nosamplingfreq_Validating(object sender, CancelEventArgs e)
        //{

        //}

        #endregion

        #region MEMactions

        private void button_MEM_getdefault_Click(object sender, EventArgs e)
        {
            get_MEM_order();
            get_MEM_nofreqencies();
            get_MEM_samplinginterval();
        }

        public void get_MEM_order()
        {
            // m cannot exceed the total number of points in the time series
            // According to SSA-Toolkit documentation, M should not exceed half the length of the time series
            // this code makes M around 1/4 of the length of the time series
            // Larger M gives higher resolution, but spurious peaks

            int M = 10; // set default
            double[] freq_vector = new double[10];

            // get length of the time series
            double[] arraycol0;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_MEM_input, 0);
            //arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 0);

            int N = arraycol0.Length;
            float N_double = Convert.ToSingle(N);

            //M = N / 20;
            M = 10;
            if (M < 10)
            {
                M = 10;
            }
            

            textBox_MEM_MEMorder.Text = Convert.ToString(M);
            MEM_order = M;

        }

        public void get_MEM_nofreqencies()
        {
            // for now, set this to 256, same as in the SSA-Toolkit
            MEM_no_frequencies = 256;
            //textBox_MEM_nosamplingfreq.Text = Convert.ToString(MEM_no_frequencies);

            
            //double[] freq_vector = new double[10];

            //// get length of the time series
            //double[] arraycol0;

            //arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname, 0);
            ////arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 0);

            //int N = arraycol0.Length;
            //float N_double = Convert.ToSingle(N); 
            
            //for (int i = 0; i < 10; i++)
            //{
            //    if (i == 0)
            //    {
            //        freq_vector[i] = 1;
            //    }
            //    if (i == 1)
            //    {
            //        freq_vector[i] = 2;
            //    }
            //    else
            //    {
            //        freq_vector[i] = Math.Pow(freq_vector[i - 1],2);
            //    }
            //}
           
        }

        public void get_MEM_samplinginterval()
        {
            MEM_sampling_interval = 1;
            textBox_MEM_samplinginterval.Text = Convert.ToString(MEM_sampling_interval);
        }

        //private void button_MEM_getdefault_Click(object sender, EventArgs e)
        //{
        //    get_MEM_order();
        //    get_MEM_nofreqencies();
        //    get_MEM_samplinginterval();
        //}

        private void button_MEM_calculatespectrum_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                double[] arraycol1;
                double[] freq = new double[MEM_no_frequencies];
                double[] k = new double[MEM_no_frequencies];
                double[] T = new double[MEM_no_frequencies];
                double sig2;
                double f_inc;
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_MEM_input, 1);

                try
                {

                    // make a vector for the desired frequencies
                    f_inc = 1 / Convert.ToDouble(MEM_no_frequencies) / MEM_sampling_interval;
                    for (int i = 0; i < MEM_no_frequencies; i++)
                    {
                        if (i == 0)
                        {
                            //freq[i] = 0;
                            freq[i] = f_inc * .5;
                        }
                        else
                        {
                            freq[i] = freq[i - 1] + f_inc * .5;
                        }
                    }

                    // make a vector of the component numbers
                    for (int i = 0; i < MEM_no_frequencies; i++)
                    {
                        if (i == 0)
                        {
                            k[i] = 1;
                        }
                        else
                        {
                            k[i] = k[i - 1] + 1;
                        }
                    }

                    // make a vector of the periods
                    for (int i = 0; i < MEM_no_frequencies; i++)
                    {
                        T[i] = 1 / freq[i];

                    }

                    double[] a = CMEM_factory.get_Burg_AR_coeff(arraycol1, MEM_order, out sig2);
                    double[] power = CMEM_factory.get_MEM_spectrum(a, freq, sig2, MEM_sampling_interval, MEM_order, MEM_no_frequencies);

                    save_row_MEM_table(selecteddataseriesname, selecteddataseriesname_MEM_input,
                        selecteddataseriesname_MEM_output_spectrum, MEM_sampling_interval, MEM_order);

                    update_datagridview_progress();

                    // create tables in datamaster
                    get_new_datatable_in_datamaster(selecteddataseriesname_MEM_output_spectrum);
                    get_spectrum_datatable_from_fourColArray(k, T, freq, power, selecteddataseriesname_MEM_output_spectrum);
                    //get_datatable_from_twoColArray(freq, power, selecteddataseriesname_MEM_output_spectrum);

                    if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                    {
                        // Open the form for plotting data. Pass the datamaster dataset to it. 
                        Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster, selecteddataseriesname_MEM_output_spectrum, this);
                        //Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_MEM_output_spectrum, this);
                        form_spectrum_plot.Show();
                    }
                    MEM_exists = change_viewdatatable(selecteddataseriesname_MEM_output_spectrum);
                    if (MEM_exists)
                    {
                        button_MEM_plotspectrum.Enabled = true;
                        button_MEM_viewdatatable.Enabled = true;
                        update_progress_textbox("MEM complete");
                        Cursor.Current = Cursors.Default;
                    }
                    else
                    {
                        button_MEM_plotspectrum.Enabled = false;
                        button_MEM_viewdatatable.Enabled = false;
                        update_progress_textbox("Something went wrong. The MEM is not complete");
                        Cursor.Current = Cursors.Default;
                    }
                }
                catch
                {
                    MessageBox.Show("Something went wrong. Try selecting an order less than the length of the time series");
                    Cursor.Current = Cursors.Default;
                    return;
                }
            }
            catch
            {
                update_progress_textbox("Something went wrong. The MEM is not complete");
                Cursor.Current = Cursors.Default;
            }
        }

        private void button_MEM_plotspectrum_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_spectrum_plot form_spectrum_plot = new Form_spectrum_plot(datamaster, selecteddataseriesname_MEM_output_spectrum, this);
            form_spectrum_plot.Show();
        }

        private void button_MEM_viewdatatable_Click(object sender, EventArgs e)
        {
            Form_datagrid form_datagrid = new Form_datagrid(datamaster, selecteddataseriesname_MEM_output_spectrum);
            form_datagrid.Show();
        }



        #endregion MEMactions

    }
}
