﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Climate_toolkit
{
    public partial class FormToolkit
    {
        // intput/output names for ACF
        string selecteddataseriesname_projection_ACF_input;
        string selecteddataseriesname_projection_ACF_output;    
        
        // intput/output names for AR modeling
        string selecteddataseriesname_projection_AR_input;
        string selecteddataseriesname_projection_AR_output;
        string selecteddataseriesname_projection_AR_simulated_output;
        string selecteddataseriesname_projection_AR_residuals_output;
        string selecteddataseriesname_projection_AR_residuals_ACF_output;
        string selecteddataseriesname_projection_AR_coefficients_output;
        string selecteddataseriesname_projection_AR_fitstatistic_output;
        string selecteddataseriesname_projection_AR_projections_output;
        string selecteddataseriesname_projection_AR_projections_output_mean;
        string selecteddataseriesname_projection_AR_projections_output_lower;
        string selecteddataseriesname_projection_AR_projections_output_upper;
        string selecteddataseriesname_projection_AR_projections_output_rand1;
        string selecteddataseriesname_projection_AR_projections_output_rand2;
        string selecteddataseriesname_projection_AR_projections_output_rand3;

        string selecteddataseriesname_projection_AR_projections_sum;
        string selecteddataseriesname_projection_AR_projections_sum_mean;
        string selecteddataseriesname_projection_AR_projections_sum_lower;
        string selecteddataseriesname_projection_AR_projections_sum_upper;
        string selecteddataseriesname_projection_AR_projections_sum_min;
        string selecteddataseriesname_projection_AR_projections_sum_max;
        string selecteddataseriesname_projection_AR_projections_sum_residuals;

        string selecteddataseriesname_projection_AR_projections_sum_rand1;
        string selecteddataseriesname_projection_AR_projections_sum_rand2;
        string selecteddataseriesname_projection_AR_projections_sum_rand3;

        string selecteddataseriesname_projection_AR_projections_summary;

        int specifiedorder = 1;
        int minorder = 1;
        int maxorder = 10;
        int fitorder;

        //int projection_length = 0;

        bool ACF_exists = false;
 
        double[] fittingstatistic;

        // AR forecasting variables
        int AR_num_projections = 1000;
        int AR_projection_length = 0;

        bool AR_res_exists = false;
        bool AR_projection_exists = false;
        bool AR_projection_sum_exists = false;

        ArrayList projectionlist = new ArrayList();
        string originalprojectionseries = null;

        #region page_layout

        public void fill_combobox_with_datatablenames_ACF()
        {
            comboBox_projection_ACF_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_projection_ACF_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_projection_ACF_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_projection_ACF_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_projection_ACF_dataseriesname.Items.Add(table.TableName);
            //                comboBox_projection_ACF_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_projection_ACF_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        private void comboBox_projection_ACF_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_projection_ACF_input = (string)comboBox_projection_ACF_dataseriesname.SelectedItem;
            this.selecteddataseriesname_projection_ACF_output = (string)comboBox_projection_ACF_dataseriesname.SelectedItem;

            this.selecteddataseriesname_projection_ACF_output = selecteddataseriesname_projection_ACF_output + "_ACF"; // add default suffix
            this.textBox_seriesname_ACF_output.Text = this.selecteddataseriesname_projection_ACF_output;

        }
        //private void comboBox_projection_ACF_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        //{

        //} 
        //private void button_calculate_PACF_Click(object sender, EventArgs e)
        //{

        //}

        //private void button_calculate_ACF_Click(object sender, EventArgs e)
        //{
        //    double[] S;
        //    double[] x = new double[num_autocorrelation_lags];
        //    double[] y;


        //    // need to get values into a vector...
        //    //x = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_stationarity_ACF_input, 0);

        //    for (int i = 0; i < num_autocorrelation_lags; i++)
        //    {
        //        if (i == 0)
        //        {
        //            x[i] = 0;
        //        }
        //        else
        //        {
        //            x[i] = x[i - 1] + 1;
        //        }
        //    }

        //    y = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_ACF_input, 1);

        //    S = CStatsFactory.get_autocorrelation_function(y, num_autocorrelation_lags);

        //    // create a table in datamaster to hold the results
        //    get_new_datatable_in_datamaster(selecteddataseriesname_projection_ACF_output);

        //    // put results into the table in datamaster
        //    get_datatable_from_twoColArray(x, S, selecteddataseriesname_projection_ACF_output);

        //    // add datatable to comboboxes
        //    fill_combobox_with_datatablenames_preprocess_data();
        //    fill_combobox_with_datatablenames_standardize_data();
        //    fill_combobox_with_datatablenames_cumulative_departure();
        //    fill_combobox_with_datatablenames_ACF();
        //    fill_combobox_with_datatablenames_detrend();
        //    fill_combobox_with_datatablenames_spectralanalysis();
        //    fill_combobox_with_datatablenames_SSA();
        //    fill_combobox_with_datatablenames_AR();
        //}



        //private void comboBox_stationary_ACF_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        //{

        //}

        private void button_plot_ACF_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 

            Form_plot_ACF_PACF form_plot_ACF_PACF = new Form_plot_ACF_PACF(datamaster, selecteddataseriesname_projection_ACF_output, this);
            form_plot_ACF_PACF.Show();
        }

        public void fill_combobox_with_datatablenames_AR()
        {
            comboBox_identifymodel_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_identifymodel_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }


            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_identifymodel_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_identifymodel_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_identifymodel_dataseriesname.Items.Add(table.TableName);
            //                comboBox_identifymodel_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            comboBox_identifymodel_dataseriesname.SelectedItem = selecteddataseriesname;
        }

        private void checkBox_identifymodel_fitmultiple_CheckedChanged(object sender, EventArgs e)
        {
            //checkBox_identifymodel_fitmultiple.Checked = !checkBox_identifymodel_fitmultiple.Checked;
            if (checkBox_identifymodel_fitmultiple.Checked == true)
            {
                checkBox_identifymodel_fitone.Checked = false;
                textBox_identifymodel_lowestorder.Enabled = true;
                textBox_identifymodel_highestorder.Enabled = true;
                textBox_ARspecifiedorder.Enabled = false;
            }
            if (checkBox_identifymodel_fitmultiple.Checked == false)
            {
                checkBox_identifymodel_fitone.Checked = true;
                textBox_identifymodel_lowestorder.Enabled = false;
                textBox_identifymodel_highestorder.Enabled = false;
                textBox_ARspecifiedorder.Enabled = true;
            }
        }

        private void checkBox_identifymodel_fitone_CheckedChanged(object sender, EventArgs e)
        {
        //    checkBox_identifymodel_fitone.Checked = !checkBox_identifymodel_fitone.Checked;
            if (checkBox_identifymodel_fitone.Checked == true)
            {
                checkBox_identifymodel_fitmultiple.Checked = false;
                textBox_identifymodel_lowestorder.Enabled = false;
                textBox_identifymodel_highestorder.Enabled = false;
                textBox_ARspecifiedorder.Enabled = true;
            }
            if (checkBox_identifymodel_fitone.Checked == false)
            {
                checkBox_identifymodel_fitmultiple.Checked = true;
                textBox_identifymodel_lowestorder.Enabled = true;
                textBox_identifymodel_highestorder.Enabled = true;
                textBox_ARspecifiedorder.Enabled = false;
            }
        }

        private void checkBox_projection_include_residuals_CheckedChanged(object sender, EventArgs e)
        {

        }

        #endregion

        #region define inputs

        #region ACF define inputs
        //private void textBox_autocorrelation_lags_TextChanged(object sender, EventArgs e)
        //{
        //    num_autocorrelation_lags = Convert.ToInt32(textBox_autocorrelation_lags.Text);
        //}

        private void textBox_autocorrelation_lags_Validating(object sender, CancelEventArgs e)
        {
            num_autocorrelation_lags = Convert.ToInt32(textBox_autocorrelation_lags.Text);
        }

        private void get_num_autocorrelation_lags()
        {
            // get length of the time series
            double[] arraycol0;

            //arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_stationarity_ACF_input, 0);
            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname, 0);
            num_autocorrelation_lags = arraycol0.Length;

            textBox_autocorrelation_lags.Text = num_autocorrelation_lags.ToString();
        }

        //private void textBox_autocorrelation_lags_Validating(object sender, CancelEventArgs e)
        //{
        //    num_autocorrelation_lags = Convert.ToInt32(textBox_autocorrelation_lags.Text);
        //}

        #endregion ACF define inputs

        #region AR define inputs
        private void comboBox_identifymodel_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseriesname_projection_AR_input = (string)comboBox_identifymodel_dataseriesname.SelectedItem;
            this.selecteddataseriesname_projection_AR_output = (string)comboBox_identifymodel_dataseriesname.SelectedItem;

            this.selecteddataseriesname_projection_AR_simulated_output = selecteddataseriesname_projection_AR_output + "_ARsim"; // add default suffix
            this.selecteddataseriesname_projection_AR_residuals_output = selecteddataseriesname_projection_AR_output + "_ARres"; // add default suffix
            this.selecteddataseriesname_projection_AR_residuals_ACF_output = selecteddataseriesname_projection_AR_output + "_ARres_ACF"; // add default suffix
            this.selecteddataseriesname_projection_AR_coefficients_output = selecteddataseriesname_projection_AR_output + "_ARcoef"; // add default suffix
            this.selecteddataseriesname_projection_AR_fitstatistic_output = selecteddataseriesname_projection_AR_output + "_ARAIC"; // add default suffix
            this.selecteddataseriesname_projection_AR_projections_output = selecteddataseriesname_projection_AR_output + "_ARproj";
            this.selecteddataseriesname_projection_AR_projections_output_mean = selecteddataseriesname_projection_AR_projections_output + "_mean";
            this.selecteddataseriesname_projection_AR_projections_output_lower = selecteddataseriesname_projection_AR_projections_output + "_05";
            this.selecteddataseriesname_projection_AR_projections_output_upper = selecteddataseriesname_projection_AR_projections_output + "_95";
            this.selecteddataseriesname_projection_AR_projections_output_rand1 = selecteddataseriesname_projection_AR_output + "_rand1";
            this.selecteddataseriesname_projection_AR_projections_output_rand2 = selecteddataseriesname_projection_AR_output + "_rand2";
            this.selecteddataseriesname_projection_AR_projections_output_rand3 = selecteddataseriesname_projection_AR_output + "_rand3";

            this.selecteddataseriesname_projection_AR_projections_sum = selecteddataseriesname + "_proj";
            //this.selecteddataseriesname_projection_AR_projections_sum = selecteddataseriesname_projection_AR_output + "_proj";
            this.selecteddataseriesname_projection_AR_projections_sum_mean = selecteddataseriesname_projection_AR_projections_sum + "_mean";
            this.selecteddataseriesname_projection_AR_projections_sum_lower = selecteddataseriesname_projection_AR_projections_sum + "_05";
            this.selecteddataseriesname_projection_AR_projections_sum_upper = selecteddataseriesname_projection_AR_projections_sum + "_95";
            this.selecteddataseriesname_projection_AR_projections_sum_min = selecteddataseriesname_projection_AR_projections_sum + "_min";
            this.selecteddataseriesname_projection_AR_projections_sum_max = selecteddataseriesname_projection_AR_projections_sum + "_max";

            this.selecteddataseriesname_projection_AR_projections_sum_rand1 = selecteddataseriesname_projection_AR_projections_sum + "_rand1";
            this.selecteddataseriesname_projection_AR_projections_sum_rand2 = selecteddataseriesname_projection_AR_projections_sum + "_rand2";
            this.selecteddataseriesname_projection_AR_projections_sum_rand3 = selecteddataseriesname_projection_AR_projections_sum + "_rand3";

            this.selecteddataseriesname_projection_AR_projections_summary = selecteddataseriesname_projection_AR_projections_sum + "_summary";

            this.selecteddataseriesname_projection_AR_projections_sum_residuals = selecteddataseriesname_projection_AR_output + "_proj_res";

            this.textBox_seriesname_projection_bestfit_ARsim_output.Text = this.selecteddataseriesname_projection_AR_simulated_output;
            this.textBox_seriesname_projection_bestfit_residuals_output.Text = this.selecteddataseriesname_projection_AR_residuals_output;
            this.textBox_seriesname_projection_seriesname_sum.Text = this.selecteddataseriesname_projection_AR_projections_sum;

            checkBox_projection_include_residuals.Checked = true;

            comboBox_identifymodel_statistic.SelectedItem = "Corrected Akaike Information Criteria (AICc)";

            AR_res_exists = change_viewdatatable(selecteddataseriesname_projection_AR_residuals_output);
            if (AR_res_exists)
            {
                button_plot_projection_ARsim.Enabled = true;
                button_plot_ARresiduals_ACF.Enabled = true;
                button_plotARresiduals.Enabled = true;
                button_viewdatatable_projection_ARsim.Enabled = true;
                button_viewdatatable_projection_ARres.Enabled = true;
                button_viewdatatable_projection_ARresiduals_ACF.Enabled = true;
            }
            else
            {
                button_plot_projection_ARsim.Enabled = false;
                button_plot_ARresiduals_ACF.Enabled = false;
                button_plotARresiduals.Enabled = false;
                button_viewdatatable_projection_ARsim.Enabled = false;
                button_viewdatatable_projection_ARres.Enabled = false;
                button_viewdatatable_projection_ARresiduals_ACF.Enabled = false;

            }

        }

        private void textBox_identifymodel_lowestorder_Validating(object sender, CancelEventArgs e)
        {
            string str = textBox_identifymodel_lowestorder.Text.Trim();
            int num;
            bool isnum = Int32.TryParse(str, out num);
            if (isnum)
            {
                minorder = Convert.ToInt32(str);
            }
            else
            {
                MessageBox.Show("Must be an integer");
            }
        }

        private void textBox_identifymodel_highestorder_Validating(object sender, CancelEventArgs e)
        {
            string str = textBox_identifymodel_highestorder.Text.Trim();
            int num;
            bool isnum = Int32.TryParse(str, out num);
            if (isnum)
            {
                maxorder = Convert.ToInt32(str);
            }
            else
            {
                MessageBox.Show("Please enter an integer");
            }
        }

        private void textBox_ARspecifiedorder_Validating(object sender, CancelEventArgs e)
        {
            string str = textBox_ARspecifiedorder.Text.Trim();
            int num;
            bool isnum = Int32.TryParse(str, out num);
            if (isnum)
            {
                specifiedorder = Convert.ToInt32(str);
            }
            else
            {
                MessageBox.Show("Must be an integer");
            }
        }

        private void get_AR_model_test_highest_order()
        {
            // get length of the time series
            double[] arraycol0;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
            if (arraycol0.Length < maxorder)
            {
                maxorder = arraycol0.Length;
            }

            textBox_identifymodel_highestorder.Text = maxorder.ToString();
        }

        private void textBox_projection_AR_forecast_order_TextChanged(object sender, EventArgs e)
        {
    
        }

        private void textBox_projection_AR_forecast_numrealizations_Validating(object sender, CancelEventArgs e)
        {
            string str = textBox_projection_AR_forecast_numrealizations.Text.Trim();
            int num;
            bool isnum = Int32.TryParse(str, out num);
            if (isnum)
            {
                AR_num_projections = Convert.ToInt32(str);
            }
            else
            {
                MessageBox.Show("Please enter an integer");
            }
        }

        private void textBox_projection_AR_projection_length_Validating(object sender, CancelEventArgs e)
        {
            string str = textBox_projection_AR_projection_length.Text.Trim();
            int num;
            bool isnum = Int32.TryParse(str, out num);
            if (isnum)
            {
                AR_projection_length = Convert.ToInt32(str);
            }
            else
            {
                MessageBox.Show("Please enter an integer");
            }
        }

        private void get_projection_length()
        {
            // get length of the time series
            double[] arraycol0;

            arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
            //arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_periodicanalysis_SSA_input, 0);

            int N = arraycol0.Length;
            float N_double = Convert.ToSingle(N);

            float projection_length_double = N_double / 2;

            AR_projection_length = Convert.ToInt32(projection_length_double);
            this.textBox_projection_AR_projection_length.Text = AR_projection_length.ToString();
        }



        #endregion define AR inputs

        #endregion define inputs

        #region ACF define outputs

        private void textBox_seriesname_ACF_output_Validating(object sender, CancelEventArgs e)
        {
            selecteddataseriesname_projection_ACF_output = textBox_seriesname_ACF_output.Text;
        }

        #endregion ACF define outputs

        #region AR define outputs

        private void textBox_seriesname_projection_bestfit_ARsim_output_Validating(object sender, CancelEventArgs e)
        {
            selecteddataseriesname_projection_AR_projections_output = textBox_seriesname_projection_bestfit_ARsim_output.Text;
        }

        private void textBox_seriesname_projection_bestfit_residuals_output_Validating(object sender, CancelEventArgs e)
        {
            selecteddataseriesname_projection_AR_residuals_output = textBox_seriesname_projection_bestfit_residuals_output.Text;
        }

        private void textBox_projection_seriesname_sum_Validating(object sender, CancelEventArgs e)
        {
            selecteddataseriesname_projection_AR_projections_sum = textBox_seriesname_projection_seriesname_sum.Text;
        }

        #endregion AR define outputs

        #region actions

        #region ACF actions

        private void button_calculate_ACF_Click(object sender, EventArgs e)
        {
            double[] S;
            double[] x = new double[num_autocorrelation_lags];
            double[] y;


            // need to get values into a vector...
            //x = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_stationarity_ACF_input, 0);

            for (int i = 0; i < num_autocorrelation_lags; i++)
            {
                if (i == 0)
                {
                    x[i] = 0;
                }
                else
                {
                    x[i] = x[i - 1] + 1;
                }
            }

            y = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_ACF_input, 1);

            S = CStatsFactory.get_autocorrelation_function(y, num_autocorrelation_lags);

            save_row_ACF_table(selecteddataseriesname, selecteddataseriesname_projection_ACF_input, selecteddataseriesname_projection_ACF_output);


            update_datagridview_progress();

            // create a table in datamaster to hold the results
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_ACF_output);

            // put results into the table in datamaster
            get_datatable_from_twoColArray(x, S, selecteddataseriesname_projection_ACF_output);

            // add datatable to comboboxes
            fill_combobox_with_datatablenames_preprocess_data();
            fill_combobox_with_datatablenames_standardize_data();
            fill_combobox_with_datatablenames_cumulative_departure();
            fill_combobox_with_datatablenames_ACF();
            fill_combobox_with_datatablenames_detrend();
            fill_combobox_with_datatablenames_differencing();
            fill_combobox_with_datatablenames_spectralanalysis();
            fill_combobox_with_datatablenames_MEM();
            fill_combobox_with_datatablenames_SSA();
            fill_combobox_with_datatablenames_AR();

            if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
            {
                // Open the form for plotting data. Pass the datamaster dataset to it. 
                Form_plot_ACF_PACF form_plot_acf_pact = new Form_plot_ACF_PACF(datamaster, selecteddataseriesname_projection_ACF_output, this);
                form_plot_acf_pact.Show();
            }
            ACF_exists = change_viewdatatable(selecteddataseriesname_projection_ACF_output);
            if (ACF_exists)
            {
                button_plot_ACF.Enabled = true;
                button_view_ACF_datatable.Enabled = true;
                update_progress_textbox("Autocorrelation function calculation complete");
            }
            else
            {
                button_plot_ACF.Enabled = false;
                button_view_ACF_datatable.Enabled = false;
                update_progress_textbox("Something went wrong. The autocorrelation function calculation is not complete");
            }
        }

        private void button_view_ACF_datatable_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_projection_ACF_output);
            form_grid.Show();
        }

        //private void comboBox_projection_ACF_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        //{

        //}

        //private void textBox_seriesname_ACF_output_Validating(object sender, CancelEventArgs e)
        //{

        //}

        //private void textBox_seriesname_ACF_output_Validating(object sender, CancelEventArgs e)
        //{

        //}

        //private void button_calculate_ACF_Click(object sender, EventArgs e)
        //{
           


        //}

        //private void button_calculate_ACF_Click(object sender, EventArgs e)
        //{
        //    double[] S;
        //    double[] x = new double[num_autocorrelation_lags];
        //    double[] y;


        //    // need to get values into a vector...
        //    //x = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_stationarity_ACF_input, 0);

        //    for (int i = 0; i < num_autocorrelation_lags; i++)
        //    {
        //        if (i == 0)
        //        {
        //            x[i] = 0;
        //        }
        //        else
        //        {
        //            x[i] = x[i - 1] + 1;
        //        }
        //    }

        //    y = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_ACF_input, 1);

        //    S = CStatsFactory.get_autocorrelation_function(y, num_autocorrelation_lags);

        //    // create a table in datamaster to hold the results
        //    get_new_datatable_in_datamaster(selecteddataseriesname_projection_ACF_output);

        //    // put results into the table in datamaster
        //    get_datatable_from_twoColArray(x, S, selecteddataseriesname_projection_ACF_output);

        //    // add datatable to comboboxes
        //    fill_combobox_with_datatablenames_preprocess_data();
        //    fill_combobox_with_datatablenames_standardize_data();
        //    fill_combobox_with_datatablenames_cumulative_departure();
        //    fill_combobox_with_datatablenames_ACF();
        //    fill_combobox_with_datatablenames_detrend();
        //    fill_combobox_with_datatablenames_spectralanalysis();
        //    fill_combobox_with_datatablenames_SSA();
        //    fill_combobox_with_datatablenames_AR();
        //}

        //private void button_calculate_ACF_Click(object sender, EventArgs e)
        //{

        //}

        private void button_calculate_PACF_Click(object sender, EventArgs e)
        {

        }

        private void button_calc_autocorrelation_Click(object sender, EventArgs e)
        {


        }

        //private void button_plot_ACF_Click(object sender, EventArgs e)
        //{
        //    // Open the form for plotting data. Pass the datamaster dataset to it. 

        //    Form_plot_ACF_PACF form_plot_ACF_PACF = new Form_plot_ACF_PACF(datamaster, selecteddataseriesname_projection_ACF_output, this);
        //    form_plot_ACF_PACF.Show();
        //}

        #endregion ACF actions

        #region AR actions
        private void button_calulateARmodel_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                double[] arraycol0;
                double[] arraycol1;

                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 1);

                int nummodels = 0;
                if (checkBox_identifymodel_fitmultiple.Checked == true)
                {
                    nummodels = maxorder - minorder + 1;
                    if (maxorder > arraycol0.Length)
                    {
                        MessageBox.Show("The maximum order is greater than the length of the time series. Please reduce the maximum order.");
                        return;
                    }

                }
                else
                {
                    nummodels = 1;
                    if (specifiedorder > arraycol0.Length)
                    {
                        MessageBox.Show("The order is greater than the length of the time series. Please reduce the order.");
                        return;
                    }
                }
                double[] x = new double[nummodels];
                string[] order_string = new string[nummodels];




                double[,] sim = new double[nummodels, arraycol0.Length];
                double[,] residuals = new double[nummodels, arraycol0.Length];
                double[][] ar_coefficients = new double[nummodels][];

                update_progress_textbox("Getting AR model coefficients and fitting statistics...");


                if (checkBox_identifymodel_fitmultiple.Checked == true)
                {
                    CProjectionFactory.identify_AR_model(arraycol1, this.minorder, this.maxorder, out this.fittingstatistic, out this.fitorder, out sim, out residuals, out ar_coefficients);
                    // show the best fit on the form
                    label_identifymodel_bestfit.Text = "Best fit:" + Convert.ToString(fitorder);
                }
                else // fit only one model using the user-specified order
                {
                    CProjectionFactory.get_single_AR_model(arraycol1, this.specifiedorder, out this.fittingstatistic, out sim, out residuals, out ar_coefficients);
                    this.fitorder = this.specifiedorder;
                }



                // put values into tables in datamaster
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_fitstatistic_output);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_simulated_output);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_residuals_output);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_residuals_ACF_output);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_coefficients_output);

                // put simulated values and residuals for the best fit in datamaster
                double[] bestsim = new double[residuals.GetLength(1)];
                double[] bestresiduals = new double[residuals.GetLength(1)];
                if (checkBox_identifymodel_fitmultiple.Checked == true)
                {
                    for (int i = 0; i < bestresiduals.Length; i++)
                    {
                        bestsim[i] = sim[this.fitorder - 1, i];
                        bestresiduals[i] = residuals[this.fitorder - 1, i];
                    }
                }
                else
                {
                    for (int i = 0; i < bestresiduals.Length; i++)
                    {
                        bestsim[i] = sim[0, i];
                        bestresiduals[i] = residuals[0, i];
                    }
                }
                get_datatable_from_twoColArray(arraycol0, bestsim, selecteddataseriesname_projection_AR_simulated_output);
                get_datatable_from_twoColArray(arraycol0, bestresiduals, selecteddataseriesname_projection_AR_residuals_output);

                //put AR coeffients for the best fit in datamaster
                double[] AR_coeff_x = new double[fitorder];
                string[] AR_coeff_x_string = new string[fitorder];
                double[] AR_coeff = new double[fitorder];


                for (int i = 0; i < fitorder; i++)
                {
                    if (i == 0)
                    {
                        AR_coeff_x[i] = 1;

                    }
                    else
                    {
                        AR_coeff_x[i] = AR_coeff_x[i - 1] + 1;
                    }
                    if (checkBox_identifymodel_fitmultiple.Checked == true)
                    {
                        AR_coeff[i] = ar_coefficients[fitorder - 1][i];
                    }
                    else
                    {
                        AR_coeff[i] = ar_coefficients[0][i];
                    }
                    AR_coeff_x_string[i] = AR_coeff_x[i].ToString();
                }
                //get_datatable_from_twoColArray(AR_coeff_x, AR_coeff, selecteddataseriesname_projection_AR_coefficients_output);

                get_datatable_from_string_and_double(AR_coeff_x_string, "coefficient number", AR_coeff, "coefficient", selecteddataseriesname_projection_AR_coefficients_output);

                // put the fit statistics in datamaster

                if (checkBox_identifymodel_fitmultiple.Checked == true)
                {
                    for (int i = 0; i < maxorder; i++)
                    {
                        if (i == 0)
                        {
                            x[i] = 1;
                        }
                        else
                        {
                            x[i] = x[i - 1] + 1;
                        }
                        order_string[i] = x[i].ToString();
                    }
                }
                else
                {
                    x[0] = 1;
                    order_string[0] = x[0].ToString();
                }
                //get_datatable_from_twoColArray(x, fittingstatistic, selecteddataseriesname_projection_AR_fitstatistic_output);
                get_datatable_from_string_and_double(order_string, "order", fittingstatistic, "fit statistic", selecteddataseriesname_projection_AR_fitstatistic_output);


                //get the acf of the residuals of the best fitted model
                double[] ACF_residuals = CStatsFactory.get_autocorrelation_function(bestresiduals, bestresiduals.Length);
                double[] lag_number = new double[bestresiduals.Length + 1];
                for (int i = 0; i < bestresiduals.Length + 1; i++)
                {
                    if (i == 0)
                    {
                        lag_number[i] = 0;
                    }
                    else
                    {
                        lag_number[i] = lag_number[i - 1] + 1;
                    }
                }
                get_datatable_from_twoColArray(lag_number, ACF_residuals, selecteddataseriesname_projection_AR_residuals_ACF_output);

                save_row_AR_table(selecteddataseriesname, selecteddataseriesname_projection_AR_input, selecteddataseriesname_projection_AR_simulated_output,
                    selecteddataseriesname_projection_AR_residuals_output, selecteddataseriesname_projection_AR_residuals_ACF_output,
                    selecteddataseriesname_projection_AR_fitstatistic_output, selecteddataseriesname_projection_AR_coefficients_output, fitorder);

                update_datagridview_progress();

                if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                {
                    // Open the form for plotting data. Pass the datamaster dataset to it. 
                    Form_multi_plot form_multi_plot = new Form_multi_plot(datamaster, selecteddataseriesname_projection_AR_input, selecteddataseriesname_projection_AR_simulated_output, this);
                    form_multi_plot.Show();
                }

                AR_res_exists = change_viewdatatable(selecteddataseriesname_projection_AR_residuals_output);
                if (AR_res_exists)
                {
                    button_plot_projection_ARsim.Enabled = true;
                    button_plot_ARresiduals_ACF.Enabled = true;
                    button_plotARresiduals.Enabled = true;
                    button_viewdatatable_projection_ARsim.Enabled = true;
                    button_viewdatatable_projection_ARres.Enabled = true;
                    button_viewdatatable_projection_ARresiduals_ACF.Enabled = true;
                    button_calculate_AR_projection.Enabled = true;
                    button_projection_viewtable_multiplestatistics.Enabled = true;
                    button_viewdatatable_projection_AR_coeff.Enabled = true;
                    update_progress_textbox("AR fitting is complete.");
                    Cursor.Current = Cursors.Default;
                }
                else
                {
                    button_plot_projection_ARsim.Enabled = false;
                    button_plot_ARresiduals_ACF.Enabled = false;
                    button_plotARresiduals.Enabled = false;
                    button_viewdatatable_projection_ARsim.Enabled = false;
                    button_viewdatatable_projection_ARres.Enabled = false;
                    button_viewdatatable_projection_ARresiduals_ACF.Enabled = false;
                    button_calculate_AR_projection.Enabled = false;
                    button_projection_viewtable_multiplestatistics.Enabled = false;
                    button_viewdatatable_projection_AR_coeff.Enabled = false;
                    update_progress_textbox("Something went wrong. The AR fitting is not complete.");
                    Cursor.Current = Cursors.Default;
                }
            }
            catch
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private void button_viewdatatable_projection_AR_coeff_Click(object sender, EventArgs e)
        {
            Form_datagrid form_datagrid = new Form_datagrid(datamaster, selecteddataseriesname_projection_AR_coefficients_output);
            form_datagrid.Show();
        }

        private void button_plot_projection_ARsim_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_multi_plot form_multi_plot = new Form_multi_plot(datamaster, selecteddataseriesname_projection_AR_input, selecteddataseriesname_projection_AR_simulated_output, this);
            form_multi_plot.Show();
        }

        //private void button_plot_projection_ARsim_Click(object sender, EventArgs e)
        //{
        //    // Open the form for plotting data. Pass the datamaster dataset to it. 
        //    Form_multi_plot form_multi_plot = new Form_multi_plot(datamaster, selecteddataseriesname_projection_AR_input, selecteddataseriesname_projection_AR_simulated_output, this);
        //    form_multi_plot.Show();
        //}

        private void button_plotARresiduals_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_series_plot form_plot = new Form_series_plot(datamaster, selecteddataseriesname_projection_AR_residuals_output, this);
            form_plot.Show();
        }

        private void button_viewdatatable_projection_ARsim_Click(object sender, EventArgs e)
        {
            Form_datagrid form_datagrid = new Form_datagrid(datamaster, selecteddataseriesname_projection_AR_simulated_output);
            form_datagrid.Show();
        }

        private void button_viewdatatable_projection_ARres_Click(object sender, EventArgs e)
        {
            Form_datagrid form_datagrid = new Form_datagrid(datamaster, selecteddataseriesname_projection_AR_residuals_output);
            form_datagrid.Show();
        }

        private void button_viewdatatable_projection_ARresiduals_ACF_Click(object sender, EventArgs e)
        {
            Form_datagrid form_datagrid = new Form_datagrid(datamaster, selecteddataseriesname_projection_AR_residuals_ACF_output);
            form_datagrid.Show();
        }

        private void button_plot_ARresiduals_ACF_Click(object sender, EventArgs e)
        {
            Form_plot_ACF_PACF form_acf_residuals = new Form_plot_ACF_PACF(datamaster, selecteddataseriesname_projection_AR_residuals_ACF_output, this);
            form_acf_residuals.Show();
        }

        private void button_viewtable_multiplestatistics_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_projection_AR_fitstatistic_output);
            form_grid.Show();
        }

        private void button_calculate_AR_projection_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                double[] arraycol0;
                double[] arraycol1;
                double[] AR_coeff;
                double[] residuals;
                double[] proj;

                int totallength;

                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 1);

                double[,] projection = new double[arraycol0.Length + this.AR_projection_length, this.AR_num_projections];

                AR_coeff = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_coefficients_output, 1);

                residuals = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_residuals_output, 1);

                totallength = arraycol0.Length + this.AR_projection_length;

                update_progress_textbox("Projecting the AR model...");

                for (int i = 0; i < AR_num_projections; i++)
                {
                    proj = CProjectionFactory.get_ARforecast(arraycol1, AR_coeff, AR_coeff.Length, this.AR_projection_length, residuals);

                    for (int j = 0; j < totallength; j++)
                    {
                        // check to see if the projection values are valid
                        if (proj[j] > Math.Pow(10, 9))
                        {
                            MessageBox.Show("The AR model is producing unreasonable projection values. The results are not being saved");
                            Cursor.Current = Cursors.Default;
                            return;
                        }
                        projection[j, i] = proj[j];
                    }
                }

                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output);
                try
                {
                    copy2DArrayIntoDataTable(projection, selecteddataseriesname_projection_AR_projections_output);
                }
                catch
                {
                    MessageBox.Show("Opps. Something went wrong");
                    Cursor.Current = Cursors.Default;
                    return;
                }

                save_row_projection_table(selecteddataseriesname, selecteddataseriesname_projection_AR_input, selecteddataseriesname_projection_AR_projections_output,
                     arraycol0.Length, totallength, AR_num_projections);
                update_datagridview_progress();
                fill_projection_datagridview_with_datatablenames();

                AR_projection_exists = change_viewdatatable(selecteddataseriesname_projection_AR_projections_output);
                if (AR_projection_exists)
                {
                    button_plot_AR_projection.Enabled = true;
                    button_projection_plot_envelope.Enabled = true;
                    dataGridView_projections.Enabled = true;
                    button_projections_sum_projections.Enabled = true;

                    update_progress_textbox("AR projection is complete.");
                    Cursor.Current = Cursors.Default;

                }
                else
                {
                    button_plot_AR_projection.Enabled = false;
                    button_projection_plot_envelope.Enabled = false;
                    dataGridView_projections.Enabled = false;
                    button_projections_sum_projections.Enabled = false;
                    update_progress_textbox("Something went wrong. The AR projection is not complete.");
                    Cursor.Current = Cursors.Default;
                }
            }
            catch
            {
                Cursor.Current = Cursors.Default;
            }
        }

        public void fill_projection_datagridview_with_datatablenames()
        {
            int nrow;
            int numrealizations;
            int n = 0;
            string projectionname;
            dataGridView_projections.Rows.Clear();
            foreach (DataRow row in datamaster.Tables["Projection"].Rows)
            {
                if (row["ID"].ToString() == selecteddataseriesname)
                {
                    dataGridView_projections.Enabled = true;

                    dataGridView_projections.Rows.Add();
                    projectionname = row["Seriesnameout"].ToString(); 
                    nrow = Convert.ToInt32(row["Length"]);
                    numrealizations = Convert.ToInt32(row["NumRealizations"]);

                    dataGridView_projections.Rows[n].Cells[1].Value = projectionname;
                    dataGridView_projections.Rows[n].Cells[2].Value = nrow;
                    dataGridView_projections.Rows[n].Cells[3].Value = numrealizations;
                    n++;
                }
            }
        }

        private void button_plot_AR_projection_Click(object sender, EventArgs e)
        {
            // plot a random projection
            // get a random number from 0 to the number of projections-1
            int random = CProjectionFactory.AutoSeedRandoms_int(1, AR_num_projections);

            Form_plot_matrix form_plot_matrix = new Form_plot_matrix(datamaster, selecteddataseriesname_projection_AR_projections_output, random, this);
            try
            {
                form_plot_matrix.Show();
            }
            catch
            {
                MessageBox.Show("Plot failed to show. The values may be unreasonable");
            }
        }

        private void button_projection_plot_envelope_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                // plot the upper and lower bounds of a envelope of projections, including the mean of the projections
                // first get the projections into an array

                // get the length of the time series
                // get length of the time series
                double[] arraycol0;
                double[] arraycol1;

                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 1);

                int N = arraycol0.Length;
                // get the total length of the time series plus the projection length
                int total_length = N + AR_projection_length;

                double[,] a = get_2Darray_from_datatable(selecteddataseriesname_projection_AR_projections_output, total_length, AR_num_projections);

                double[] projection_mean_at_each_time = new double[AR_projection_length];
                double[] projection_variance_at_each_time = new double[AR_projection_length];

                double[] y_05 = new double[AR_projection_length];
                double[] y_95 = new double[AR_projection_length];

                double[] y_rand1 = new double[AR_projection_length];
                double[] y_rand2 = new double[AR_projection_length];
                double[] y_rand3 = new double[AR_projection_length];

                // get a Gaussian model for each time step of the projections.
                double[] projection_at_each_time = new double[AR_num_projections];

                // get some random numbers for selecting the 3 random series to plot
                int rand1 = CProjectionFactory.get_random_int(0, AR_num_projections - 1);
                int rand2 = CProjectionFactory.get_random_int(0, AR_num_projections - 1);
                int rand3 = CProjectionFactory.get_random_int(0, AR_num_projections - 1);

                for (int i = 0; i < AR_projection_length; i++) // loop over each projected time
                {
                    for (int j = 0; j < AR_num_projections; j++)
                    {
                        projection_at_each_time[j] = a[i + N, j];
                    }
                    projection_mean_at_each_time[i] = CStatsFactory.get_mean(projection_at_each_time);
                    projection_variance_at_each_time[i] = CStatsFactory.get_variance(projection_at_each_time, projection_mean_at_each_time[i]);

                    double z_05 = alglib.normaldistr.invnormaldistribution(.05);
                    double z_95 = alglib.normaldistr.invnormaldistribution(.95);

                    y_05[i] = CStatsFactory.CStandardizeFactory.get_inverse_z(z_05, projection_mean_at_each_time[i], Math.Sqrt(projection_variance_at_each_time[i]));
                    y_95[i] = CStatsFactory.CStandardizeFactory.get_inverse_z(z_95, projection_mean_at_each_time[i], Math.Sqrt(projection_variance_at_each_time[i]));

                    y_rand1[i] = a[i + N, rand1];
                    y_rand2[i] = a[i + N, rand2];
                    y_rand3[i] = a[i + N, rand3];
                }

                // get the time x axis for the projections
                // get the difference between time values and project these
                double[] del_t = new double[N - 1];
                // get the average delta time between values in the time column
                for (int i = 0; i < N - 1; i++)
                {
                    del_t[i] = arraycol0[i + 1] - arraycol0[i];
                }

                double avg_del_t = CStatsFactory.get_mean(del_t);

                // combine the original time series and the projection for the mean, upper and lower bounds

                double[] new_x = new double[N + AR_projection_length];
                double[] new_y_mean = new double[N + AR_projection_length];
                double[] new_y_05 = new double[N + AR_projection_length];
                double[] new_y_95 = new double[N + AR_projection_length];
                double[] new_y_rand1 = new double[N + AR_projection_length];
                double[] new_y_rand2 = new double[N + AR_projection_length];
                double[] new_y_rand3 = new double[N + AR_projection_length];

                for (int i = 0; i < N + AR_projection_length; i++)
                {
                    if (i < N)
                    {
                        new_x[i] = arraycol0[i];
                        new_y_mean[i] = arraycol1[i];
                        new_y_05[i] = arraycol1[i];
                        new_y_95[i] = arraycol1[i];
                        new_y_rand1[i] = arraycol1[i];
                        new_y_rand2[i] = arraycol1[i];
                        new_y_rand3[i] = arraycol1[i];
                    }
                    else
                    {
                        new_x[i] = new_x[i - 1] + avg_del_t;
                        new_y_mean[i] = projection_mean_at_each_time[i - N];
                        new_y_05[i] = y_05[i - N];
                        new_y_95[i] = y_95[i - N];
                        new_y_rand1[i] = y_rand1[i - N];
                        new_y_rand2[i] = y_rand2[i - N];
                        new_y_rand3[i] = y_rand3[i - N];
                    }
                }



                //selecteddataseriesname_projection_AR_projections_sum_rand1

                // add the mean, lower and upper bounds to datamaster
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output_mean);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output_lower);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output_upper);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output_rand1);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output_rand2);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_output_rand3);

                // put results into the table in datamaster
                get_datatable_from_twoColArray(new_x, new_y_mean, selecteddataseriesname_projection_AR_projections_output_mean);
                get_datatable_from_twoColArray(new_x, new_y_05, selecteddataseriesname_projection_AR_projections_output_lower);
                get_datatable_from_twoColArray(new_x, new_y_95, selecteddataseriesname_projection_AR_projections_output_upper);
                get_datatable_from_twoColArray(new_x, new_y_rand1, selecteddataseriesname_projection_AR_projections_output_rand1);
                get_datatable_from_twoColArray(new_x, new_y_rand2, selecteddataseriesname_projection_AR_projections_output_rand2);
                get_datatable_from_twoColArray(new_x, new_y_rand3, selecteddataseriesname_projection_AR_projections_output_rand3);

                Form_multi_plot form_multi_plot = new Form_multi_plot(datamaster, selecteddataseriesname_projection_AR_projections_output_mean,
                    selecteddataseriesname_projection_AR_projections_output_lower, selecteddataseriesname_projection_AR_projections_output_upper,
                    selecteddataseriesname_projection_AR_projections_output_rand1, selecteddataseriesname_projection_AR_projections_output_rand2,
                    selecteddataseriesname_projection_AR_projections_output_rand3, this);

                form_multi_plot.Show();
            }
            catch
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private void button_projection_save_projection_Click(object sender, EventArgs e)
        {
            try
            {
                // first get the projections into an array

                // get the length of the time series
                // get length of the time series
                double[] arraycol0;
                double[] arraycol1;

                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 1);

                int N = arraycol0.Length;
                // get the total length of the time series plus the projection length
                int total_length = N + AR_projection_length;
                try
                {
                    double[,] a = get_2Darray_from_datatable(selecteddataseriesname_projection_AR_projections_output, total_length, AR_num_projections);
                }
                catch
                {
                    MessageBox.Show("Something went wrong");
                    Cursor.Current = Cursors.Default;
                    return;
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                Cursor.Current = Cursors.Default;
            }
        }

        private void button_projections_sum_projections_Click(object sender, EventArgs e)
        {
            // get the selected projection names
            string selected_projection = null;
            int selected_projection_length;
            int selected_projection_numrealizations;

            //ArrayList projectionlist = new ArrayList();
            ArrayList projectionlengthlist = new ArrayList();
            ArrayList projection_numrealizations_list = new ArrayList();

            //reload the projectionlist based on the items in the datagridview
            projectionlist.Clear();

            foreach (DataGridViewRow dgrow in dataGridView_projections.Rows)
            {
                if (dgrow.Cells[0].Value != null && (bool)dgrow.Cells[0].Value == true)
                {
                    selected_projection = dgrow.Cells[1].Value.ToString();
                    selected_projection_length = Convert.ToInt32(dgrow.Cells[2].Value);
                    selected_projection_numrealizations = Convert.ToInt32(dgrow.Cells[3].Value);
                    projectionlist.Add(selected_projection);
                    projectionlengthlist.Add(selected_projection_length);
                    projection_numrealizations_list.Add(selected_projection_numrealizations);
                }
            }

            if (projectionlist.Count < 1)
            {
                MessageBox.Show("Please select a projection");
            }
            else
            {
                update_progress_textbox("Summing the AR projections...");
                sum_projections(projectionlist, projectionlengthlist, projection_numrealizations_list);

            }
        }

        public void sum_projections(ArrayList projectionlist, ArrayList projectionlengthlist, ArrayList projection_numrealizations_list)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                // get the projection data from the projections contained in the arraylist
                int numprojections = projectionlist.Count;
                int[] numrealizations = new int[numprojections];
                int[] length = new int[numprojections];

                string AR_originalseries = null;

                // check that each projection has the same length and number of realizations
                int count = 0;

                foreach (int i in projectionlengthlist)
                {
                    length[count] = i;
                    if (count > 1)
                    {
                        if (length[count] != length[count - 1])
                        {
                            MessageBox.Show("Each projection must be the same length");
                            Cursor.Current = Cursors.Default;
                            return;
                        }
                    }
                    count++;
                }

                count = 0;
                foreach (int i in projection_numrealizations_list)
                {
                    numrealizations[count] = i;
                    if (count > 1)
                    {
                        if (numrealizations[count] != numrealizations[count - 1])
                        {
                            MessageBox.Show("Each projection must have the same number of realizations");
                            Cursor.Current = Cursors.Default;
                            return;
                        }
                    }
                    count++;
                }

                //variables for getting the sum of the projections
                double[,] x_series_plus_projection = new double[length[0], numrealizations[0]];
                double[,] sum = new double[length[0], numrealizations[0]];
                double[] x;



                // get the length of the length of the original time series
                int original_length = 0;
                foreach (string projection in projectionlist)
                {
                    foreach (DataRow dr in datamaster.Tables["Projection"].Rows)
                    {
                        if (projection == dr["Seriesnameout"].ToString())
                        {
                            original_length = Convert.ToInt32(dr["SeriesnameinLength"]);
                            break;
                        }
                    }
                }
                double[] y = new double[original_length];
                double[] y_sum = new double[original_length];
                double[] x_originalseries = new double[original_length];
                double[] y_originalseries = new double[original_length];
                //double[,] residuals = new double[original_length,2];

                double[] residuals = new double[original_length]; // the residuals between the summed projections and the original series
                double[] residualsmixed = new double[original_length]; // this is a mixed up set of residuals with random starting location
                double[,] residualstoadd = new double[AR_projection_length, numrealizations[0]];

                originalprojectionseries = null;

                // get the name of the original time series that the AR model is based on. Keep in mind that the
                // AR model could be based on an RC of a time series or some other derived time series.
                foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
                {
                    if (dr["RCnameoutVector"].ToString() == selecteddataseriesname_projection_AR_input || 
                        dr["ID"].ToString() == selecteddataseriesname_projection_AR_input) // are we modeling an RC?
                    {
                        originalprojectionseries = dr["Seriesnamein"].ToString();
                    }
                }

                foreach (string projection in projectionlist)
                {
                    try
                    {
                        x_series_plus_projection = get_2Darray_from_datatable(projection, length[0], numrealizations[0]);
                    }
                    catch
                    {
                        MessageBox.Show("Something went wrong");
                        Cursor.Current = Cursors.Default;
                        return;
                    }

                    foreach (DataRow dr in datamaster.Tables["Projection"].Rows)
                    {
                        if (projection == dr["Seriesnameout"].ToString())
                        {
                            x = get_oneColArray_from_datatable(datamaster, dr["Seriesnamein"].ToString(), 0);
                            y = get_oneColArray_from_datatable(datamaster, dr["Seriesnamein"].ToString(), 1);
                            for (int i = 0; i < y.Length; i++)
                            {
                                y_sum[i] = y[i] + y_sum[i];
                            }


                        }
                    }

                    // get the values of the original series
                    if (originalprojectionseries != null)
                    {
                        x_originalseries = get_oneColArray_from_datatable(datamaster, originalprojectionseries, 0);
                        y_originalseries = get_oneColArray_from_datatable(datamaster, originalprojectionseries, 1);
                        // get the residuals from the sum of the projected series from the original series
                        for (int i = 0; i < original_length; i++)
                        {
                            //residuals[i, 0] = x_originalseries[i];
                            //residuals[i, 1] = y_originalseries[i] - y_sum[i]; // subtract the sum of RCs from the original series
                            residuals[i] = y_originalseries[i] - y_sum[i];
                        }
                    }

                    int randomstart = 0;
                    // to put the random start back into the SSA residuals, comment the next line and uncomment randomstart below
                    randomstart = CProjectionFactory.AutoSeedRandoms_int(0, original_length - 1);
                    if (checkBox_projection_include_residuals.Checked == true)
                    {
                        update_progress_textbox("Adding residuals from the original series");
                        for (int j = 0; j < numrealizations[0]; j++)
                        {
                            //residuals = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_projections_sum_residuals, 1);

                            // get a random start for the residuals series to add to the projection sum
                            //randomstart = CProjectionFactory.AutoSeedRandoms_int(0, original_length - 1);
                            // get two chunks of residuals
                            if (randomstart > 0)
                            {
                                // first chunk
                                double[] firstchunk = new double[original_length - 1 - randomstart];
                                for (int i = randomstart; i < original_length; i++)
                                {
                                    residualsmixed[i - randomstart] = residuals[i];
                                }
                                // second chunk
                                double[] secondchunk = new double[randomstart + 1];
                                for (int i = 0; i < randomstart; i++)
                                {
                                    residualsmixed[i + original_length - randomstart] = residuals[i];
                                }

                            }
                            else
                            {
                                // just use the orginal residual series
                                for (int i = 0; i < original_length; i++)
                                {
                                    residualsmixed[i] = residuals[i];
                                }
                            }
                            if (AR_projection_length > original_length) // do we need to repeat the sequence of residuals?
                            {
                                count = 0;
                                for (int i = 0; i < AR_projection_length; i++)
                                {
                                    if (count >= original_length)
                                    {
                                        count = 0;
                                    }
                                    residualstoadd[i, j] = residualsmixed[count];

                                    count++;
                                }
                            }
                            else
                            {
                                for (int i = 0; i < AR_projection_length; i++)
                                {
                                    residualstoadd[i, j] = residualsmixed[i];
                                }
                            }
                        }
                    }


                    //get the sum of the projections
                    for (int i = 0; i < length[0]; i++) // loop along each time
                    {
                        if (i >= original_length)
                        {
                            for (int j = 0; j < numrealizations[0]; j++)
                            {
                                sum[i, j] = sum[i, j] + x_series_plus_projection[i, j] + residualstoadd[i - original_length, j];
                            }
                        }

                        else
                        {
                            for (int j = 0; j < numrealizations[0]; j++)
                            {
                                sum[i, j] = sum[i, j] + x_series_plus_projection[i, j];
                            }
                        }
                    }

                }

                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum);
                get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_residuals);
                //copy2DArrayIntoDataTable(residuals, selecteddataseriesname_projection_AR_projections_sum_residuals);
                try
                {
                    copy2DArrayIntoDataTable(sum, selecteddataseriesname_projection_AR_projections_sum);


                }
                catch
                {
                    MessageBox.Show("Something went wrong");
                    return;
                }

                AR_projection_sum_exists = change_viewdatatable(selecteddataseriesname_projection_AR_projections_sum);
                if (AR_projection_sum_exists)
                {
                    button_plot_AR_projection.Enabled = true;
                    button_projection_plot_envelope.Enabled = true;
                    dataGridView_projections.Enabled = true;
                    button_projection_plot_sum_projections.Enabled = true;
                    button_projection_summed_viewdatatable.Enabled = true;
                    update_progress_textbox("AR projection is complete.");

                }
                else
                {
                    button_plot_AR_projection.Enabled = false;
                    button_projection_plot_envelope.Enabled = false;
                    dataGridView_projections.Enabled = false;
                    button_projection_plot_sum_projections.Enabled = false;
                    button_projection_summed_viewdatatable.Enabled = false;
                    update_progress_textbox("Something went wrong. The AR projection is not complete.");
                }

                get_projection_sum_plot(projectionlist, originalprojectionseries);

            }
            catch
            {
                Cursor.Current = Cursors.Default;
            }
        } // end sum_projections

        private void button_projection_plot_sum_projections_Click(object sender, EventArgs e)
        {
            
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                //get_projection_sum_plot(projectionlist, originalprojectionseries);
                string mean;
                string lower;
                string upper;
                string rand1;
                string rand2;
                string rand3;

                foreach (DataRow dr in datamaster.Tables["ProjectionSum"].Rows)
                {
                    string stringtemp = dr["Seriesnameout"].ToString();
                    if (dr["Seriesnameout"].ToString() == selecteddataseriesname_projection_AR_projections_sum)
                    {
                        mean = dr["Seriesnameoutmean"].ToString();
                        lower = dr["Seriesnameoutlower"].ToString();
                        upper = dr["Seriesnameoutupper"].ToString();
                        rand1 = dr["Seriesnameoutrand1"].ToString();
                        rand2 = dr["Seriesnameoutrand2"].ToString();
                        rand3 = dr["Seriesnameoutrand3"].ToString();
                        Form_multi_plot form_multi_plot = new Form_multi_plot(datamaster, mean, lower, upper, rand1, rand2, rand3, this);

                        form_multi_plot.Show();
                        break;
                    }
                }
                

            
            
            
            }
            catch
            {
                update_progress_textbox("Something went wrong. The projection sum didn't plot");
                Cursor.Current = Cursors.Default;
            }
        } 

        public void get_projection_sum_plot(ArrayList projectionlist, string originalseries)
        {
            // plot the upper and lower bounds of a envelope of projections, including the mean of the projections
            // first get the projections into an array

            // get the length of the time series
            // get length of the time series
            double[] arraycol0;
            double[] arraycol1;



            if (originalseries != null) //pretty much, is the AR model based on an RC? If so, grab the original time series before SSA
            {
                arraycol0 = get_oneColArray_from_datatable(datamaster, originalseries, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, originalseries, 1);
            }
            else // if not an RC, then use the time series that was used to make the AR model
            {
                arraycol0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 0);
                arraycol1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_projection_AR_input, 1);
            }

            int N = arraycol0.Length;


            // get the total length of the time series plus the projection length
            int total_length = N + AR_projection_length;
            //try
            //{
                double[,] a = get_2Darray_from_datatable(selecteddataseriesname_projection_AR_projections_sum, total_length, AR_num_projections);
            //}
            //catch { }

            double[] projection_mean_at_each_time = new double[AR_projection_length];
            double[] projection_variance_at_each_time = new double[AR_projection_length];

            double[] y_min = new double[AR_projection_length];
            double[] y_max = new double[AR_projection_length];
            
            double[] y_05 = new double[AR_projection_length];
            double[] y_95 = new double[AR_projection_length];

            double[] y_rand1 = new double[AR_projection_length];
            double[] y_rand2 = new double[AR_projection_length];
            double[] y_rand3 = new double[AR_projection_length];

            // get a Gaussian model for each time step of the projections.
            double[] projection_at_each_time = new double[AR_num_projections];

            // get some random numbers for selecting the 3 random series to plot
            int rand1 = CProjectionFactory.get_random_int(0, AR_num_projections - 1);
            int rand2 = CProjectionFactory.get_random_int(0, AR_num_projections - 1);
            int rand3 = CProjectionFactory.get_random_int(0, AR_num_projections - 1);

            for (int i = 0; i < AR_projection_length; i++) // loop over each projected time
            {
                for (int j = 0; j < AR_num_projections; j++)
                {
                    projection_at_each_time[j] = a[i + N, j];
                }
                projection_mean_at_each_time[i] = CStatsFactory.get_mean(projection_at_each_time);
                projection_variance_at_each_time[i] = CStatsFactory.get_variance(projection_at_each_time, projection_mean_at_each_time[i]);

                double z_05 = alglib.normaldistr.invnormaldistribution(.05);
                double z_95 = alglib.normaldistr.invnormaldistribution(.95);

                y_min[i] = projection_at_each_time.Min();
                y_max[i] = projection_at_each_time.Max();

                y_05[i] = CStatsFactory.CStandardizeFactory.get_inverse_z(z_05, projection_mean_at_each_time[i], Math.Sqrt(projection_variance_at_each_time[i]));
                y_95[i] = CStatsFactory.CStandardizeFactory.get_inverse_z(z_95, projection_mean_at_each_time[i], Math.Sqrt(projection_variance_at_each_time[i]));

                y_rand1[i] = a[i + N, rand1];
                y_rand2[i] = a[i + N, rand2];
                y_rand3[i] = a[i + N, rand3];


            }

            // get the time x axis for the projections
            // get the difference between time values and project these
            double[] del_t = new double[N - 1];
            // get the average delta time between values in the time column
            for (int i = 0; i < N - 1; i++)
            {
                del_t[i] = arraycol0[i + 1] - arraycol0[i];
            }

            double avg_del_t = CStatsFactory.get_mean(del_t);

            // combine the original time series and the projection for the mean, upper and lower bounds

            double[] new_x = new double[N + AR_projection_length];
            double[] new_y_mean = new double[N + AR_projection_length];
            double[] new_y_05 = new double[N + AR_projection_length];
            double[] new_y_95 = new double[N + AR_projection_length];
            double[] new_y_min = new double[N + AR_projection_length];
            double[] new_y_max = new double[N + AR_projection_length];
            double[] new_y_rand1 = new double[N + AR_projection_length];
            double[] new_y_rand2 = new double[N + AR_projection_length];
            double[] new_y_rand3 = new double[N + AR_projection_length];

            for (int i = 0; i < N + AR_projection_length; i++)
            {
                if (i < N)
                {
                    new_x[i] = arraycol0[i];
                    new_y_mean[i] = arraycol1[i];
                    new_y_05[i] = arraycol1[i];
                    new_y_95[i] = arraycol1[i];
                    new_y_min[i] = arraycol1[i];
                    new_y_max[i] = arraycol1[i];
                    new_y_rand1[i] = arraycol1[i];
                    new_y_rand2[i] = arraycol1[i];
                    new_y_rand3[i] = arraycol1[i];
                }
                else
                {
                    new_x[i] = new_x[i - 1] + avg_del_t;
                    new_y_mean[i] = projection_mean_at_each_time[i - N];
                    new_y_05[i] = y_05[i - N];
                    new_y_95[i] = y_95[i - N];
                    new_y_min[i] = y_min[i - N];
                    new_y_max[i] = y_max[i - N];
                    new_y_rand1[i] = y_rand1[i - N];
                    new_y_rand2[i] = y_rand2[i - N];
                    new_y_rand3[i] = y_rand3[i - N];
                }
            }

            // add the mean, lower and upper bounds to datamaster
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_mean);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_lower);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_upper);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_min);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_max);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_rand1);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_rand2);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_sum_rand3);
            get_new_datatable_in_datamaster(selecteddataseriesname_projection_AR_projections_summary);

            // put results into the table in datamaster
            get_datatable_from_twoColArray(new_x, new_y_mean, selecteddataseriesname_projection_AR_projections_sum_mean);
            get_datatable_from_twoColArray(new_x, new_y_05, selecteddataseriesname_projection_AR_projections_sum_lower);
            get_datatable_from_twoColArray(new_x, new_y_95, selecteddataseriesname_projection_AR_projections_sum_upper);
            get_datatable_from_twoColArray(new_x, new_y_min, selecteddataseriesname_projection_AR_projections_sum_min);
            get_datatable_from_twoColArray(new_x, new_y_max, selecteddataseriesname_projection_AR_projections_sum_max);
            get_datatable_from_twoColArray(new_x, new_y_rand1, selecteddataseriesname_projection_AR_projections_sum_rand1);
            get_datatable_from_twoColArray(new_x, new_y_rand2, selecteddataseriesname_projection_AR_projections_sum_rand2);
            get_datatable_from_twoColArray(new_x, new_y_rand3, selecteddataseriesname_projection_AR_projections_sum_rand3);

            get_spectrum_datatable_from_sevenColArray(new_x, new_y_mean, new_y_05, new_y_95, new_y_rand1, new_y_rand2,
                new_y_rand3, selecteddataseriesname_projection_AR_projections_summary);

            save_row_projectionsum_table(selecteddataseriesname, selecteddataseriesname,
                selecteddataseriesname_projection_AR_projections_sum, selecteddataseriesname_projection_AR_projections_sum_mean,
                selecteddataseriesname_projection_AR_projections_sum_lower, selecteddataseriesname_projection_AR_projections_sum_upper,
                selecteddataseriesname_projection_AR_projections_sum_min, selecteddataseriesname_projection_AR_projections_sum_max,
                selecteddataseriesname_projection_AR_projections_sum_rand1, selecteddataseriesname_projection_AR_projections_sum_rand2,
                selecteddataseriesname_projection_AR_projections_sum_rand3, N, total_length, AR_num_projections);

            if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
            {
                Form_multi_plot form_multi_plot = new Form_multi_plot(datamaster, selecteddataseriesname_projection_AR_projections_sum_mean,
                    selecteddataseriesname_projection_AR_projections_sum_lower, selecteddataseriesname_projection_AR_projections_sum_upper,
                    selecteddataseriesname_projection_AR_projections_sum_rand1, selecteddataseriesname_projection_AR_projections_sum_rand2,
                    selecteddataseriesname_projection_AR_projections_sum_rand3, this);
                form_multi_plot.Show();
            }

        }

        private void button_projection_summed_viewdatatable_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_projection_AR_projections_summary);
            form_grid.Show();
        }

        #endregion AR actions
        #endregion actions
    }
}
