﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class FormToolkit
    {
        // variables for regression modeling
        string selecteddataseriesname_regression_predictor_input;
        string selecteddataseriesname_regression_predictand_input;
        string selecteddataseriesname_regression_table_output;
        string selecteddataseriesname_regression_line_output;
        string selecteddataseriesname_regression_ccf_output;

        // variables for fitted line
        double xmax;
        double xmin;
        double y_xmax;
        double y_xmin;

        double r_lag_max_positive; // maximum positive correlation
        int best_lag_max_positive; // lag at maximum positive correlation, x leading y
        double r_lag_max_negative; // maximum negative correlation
        int best_lag_max_negative; // lat at maximum negative correlation, y leading x

        int max_forward_lag;
        int max_backward_lag;

        int max_forward_lagToUse;
        int max_backward_lagToUse;

        bool regression_exists;
        bool ccf_exists;

        #region page_layout


        public void fill_combobox_with_datatablenames_regression_predictor()
        {
            comboBox_regression_predictor_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname)
                {
                    comboBox_regression_predictor_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }
            //if (selectedseries_mostrecent == null)
            //{
                comboBox_regression_predictor_dataseriesname.SelectedItem = selecteddataseriesname;
            //}
            //else
            //{
            //    comboBox_regression_predictor_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}

            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname.Length) == this.selecteddataseriesname)
            //            {
            //                comboBox_regression_predictor_dataseriesname.Items.Add(table.TableName);
            //                comboBox_regression_predictor_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            //comboBox_regression_predictor_dataseriesname.SelectedItem = selecteddataseriesname;
        }


        public void fill_combobox_with_datatablenames_predictand_selecteddataseries()
        {
            comboBox_regression_predictand_selecteddataseries.Items.Clear();

            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                {
                    comboBox_regression_predictand_selecteddataseries.Items.Add(dr["SiteID"].ToString());
                }
            }
        }


        public void fill_combobox_with_datatablenames_regression_predicand()
        {
            comboBox_regression_predictand_dataseriesname.Items.Clear();


            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["EOF_SPC_vectors"].Rows)
            {
                if (dr["ID"].ToString() == selecteddataseriesname_predictand)
                {
                    comboBox_regression_predictand_dataseriesname.Items.Add(dr["SPCnameoutVector"].ToString());
                }
            }

            //if (selectedseries_mostrecent == null)
            //{
            //    comboBox_regression_predictand_dataseriesname.SelectedItem = selecteddataseriesname_predictand;
            //}
            //else
            //{
            //    comboBox_regression_predictand_dataseriesname.SelectedItem = selectedseries_mostrecent;
            //}


            //foreach (DataTable table in datamaster.Tables)
            //{
            //    if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
            //        & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
            //        & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection")
            //    {
            //        //if (table.TableName.Substring(4, table.TableName.Length - 4) == this.selecteddataseriesname)
            //        if (table.TableName.Length >= selecteddataseriesname_predictand.Length)
            //        {
            //            if (table.TableName.Substring(0, selecteddataseriesname_predictand.Length) == this.selecteddataseriesname_predictand)
            //            {
            //                comboBox_regression_predictand_dataseriesname.Items.Add(table.TableName);
            //                comboBox_regression_predictand_dataseriesname.Items.IndexOf(table.TableName);
            //            }
            //        }
            //    }
            //}
            comboBox_regression_predictand_dataseriesname.SelectedItem = selecteddataseriesname_predictand;
        }

        public void get_predictor_dataseries_label()
        {
            label_regression_predictor_dataseriesname.Text = "Data series for predictor is: " + Convert.ToString(selecteddataseriesname);
        }

        private void textBox_CCF_max_lag_TextChanged(object sender, EventArgs e)
        {

                
        }

        private void textBox_CCF_min_lag_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox_CCF_max_forward_lag_Validating(object sender, CancelEventArgs e)
        {
            int max_forward_lag_temp = this.max_forward_lag;
            try
            {
                max_forward_lag_temp = Convert.ToInt32(textBox_CCF_max_forward_lag.Text);

                if (max_forward_lag_temp > max_forward_lag)
                {
                    MessageBox.Show("The max lag must be less than or equal to the half of the time series length.");
                    textBox_CCF_max_forward_lag.Text = max_forward_lag.ToString();
                }
                else
                {
                    if (max_forward_lag_temp < 0)
                    {
                        MessageBox.Show("The max forward lag must be positive. Using the absolute value.");
                        max_forward_lag_temp = Math.Abs(max_forward_lag_temp);
                        textBox_CCF_max_forward_lag.Text = max_forward_lag_temp.ToString();
                    }
                    this.max_forward_lagToUse = max_forward_lag_temp;
                }
            }
            catch
            {
                if (textBox_CCF_max_forward_lag.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_CCF_max_forward_lag.Text = Convert.ToString(this.max_forward_lag);
                }
            }

        }

        private void textBox_CCF_max_backward_lag_Validating(object sender, CancelEventArgs e)
        {
            int max_backward_lag_temp = this.max_backward_lag;
            try
            {
                max_backward_lag_temp = Convert.ToInt32(textBox_CCF_max_backward_lag.Text);

                if (Math.Abs(max_backward_lag_temp) > max_backward_lag)
                {
                    MessageBox.Show("The max lag must be less than or equal to the half of the time series length.");
                    textBox_CCF_max_backward_lag.Text = max_backward_lag.ToString();
                }
                else
                {
                    if (max_backward_lag_temp < 0)
                    {
                        MessageBox.Show("The max backward lag must be positive. Using the absolute value.");
                        max_backward_lag_temp = Math.Abs(max_backward_lag_temp);
                        textBox_CCF_max_backward_lag.Text = max_backward_lag_temp.ToString();
                    }
                    this.max_backward_lagToUse = Math.Abs(max_backward_lag_temp);
                }

            }
            catch
            {
                if (textBox_CCF_max_backward_lag.Text != "")
                {
                    MessageBox.Show("Please enter an integer");
                    textBox_CCF_max_backward_lag.Text = Convert.ToString(this.max_backward_lag);
                }
            }


        }

        private void button_CCF_getdefault_Click(object sender, EventArgs e)
        {
            textBox_CCF_max_forward_lag.Text = max_forward_lag.ToString();
            textBox_CCF_max_backward_lag.Text = max_backward_lag.ToString();

            this.max_forward_lagToUse = Convert.ToInt32(textBox_CCF_max_forward_lag.Text);
            this.max_backward_lagToUse = Convert.ToInt32(textBox_CCF_max_backward_lag.Text);
        }

        private void set_max_forward_backward_lags()
        {
            double[] predictor_col0;
            double[] predictand_col0;

            predictor_col0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictor_input, 0);
            predictand_col0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictand_input, 0);

            // check to see if the predictor and predictand have the same length
            //if (predictor_col0.Length != predictand_col0.Length)
            //{
            //    MessageBox.Show("The predictor and predictand have different number of data points. These must be equal");
            //    update_progress_textbox("The predictor and predictand have different number of data points. These must be equal");
            //    return;
            //}

            // get max lags
            this.max_forward_lag = predictor_col0.Length / 2;
            this.max_backward_lag = predictand_col0.Length / 2;

            textBox_CCF_max_forward_lag.Text = this.max_forward_lag.ToString();
            textBox_CCF_max_backward_lag.Text = this.max_backward_lag.ToString();
        }

        #endregion

        #region define inputs

        private void comboBox_regression_predictor_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            selecteddataseriesname_regression_predictor_input = (string)comboBox_regression_predictor_dataseriesname.SelectedItem;
        }

        private void comboBox_regression_predictand_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            selecteddataseriesname_regression_predictand_input = (string)comboBox_regression_predictand_dataseriesname.SelectedItem;
            this.selecteddataseriesname_regression_table_output = (string)comboBox_regression_predictand_dataseriesname.SelectedItem;
            this.selecteddataseriesname_regression_line_output = (string)comboBox_regression_predictand_dataseriesname.SelectedItem;

            this.selecteddataseriesname_regression_table_output = this.selecteddataseriesname_regression_table_output + "_reg_table";
            this.selecteddataseriesname_regression_line_output = this.selecteddataseriesname_regression_line_output + "_reg_line";
            this.selecteddataseriesname_regression_ccf_output = this.selecteddataseriesname_regression_predictand_input + "_ccf";

            this.textBox_seriesname_regression_output.Text = this.selecteddataseriesname_regression_line_output;
            this.textBox_seriesname_CCF_output.Text = this.selecteddataseriesname_regression_ccf_output;

            regression_exists = change_viewdatatable(selecteddataseriesname_regression_table_output);
            ccf_exists = change_viewdatatable(selecteddataseriesname_regression_ccf_output);

            set_max_forward_backward_lags();

            if (regression_exists)
            {
                button_plot_regression.Enabled = true;
                button_regression_viewdatatable.Enabled = true;

            }
            else
            {
                button_plot_regression.Enabled = false;
                button_regression_viewdatatable.Enabled = false;
            }

            if (ccf_exists)
            {
                button_plot_regression_ccf.Enabled = true;
                button_view_CCF_datatable.Enabled = true;

            }
            else
            {
                button_plot_regression_ccf.Enabled = false;
                button_view_CCF_datatable.Enabled = false;
            }
        }

        private void radioButton_regression_onetailed_CheckedChanged(object sender, EventArgs e)
        {

        }

        #endregion define inputs
        
        
        
        #region actions

        private void button_regression_calculate_Click(object sender, EventArgs e)
        {
            Cursor.Current = Cursors.WaitCursor;
            try
            {
                double[] predictor_col0;
                double[] predictor_col1;

                double[] predictand_col0;
                double[] predictand_col1;

                double[] regression_output = new double[8];
                string[] regression_labels = new string[8];


                double a1;
                double a0;
                double r;
                double rsquared;

                double tstatistic = 0;
                double tmax;
                double tmin;
                int tailtest;

                double predictor_mean;
                double predictand_mean;

                double xmax;
                double xmin;
                double y_xmin;
                double y_xmax;

                double tcrit_one_90 = 0;  // one-tailed @ 90%
                double tcrit_one_95 = 0;  // one tailed @ 95% 
                double tcrit_one_99 = 0;  // one-tailed @ 99%

                double tcrit_two_90 = 0;  // two-tailed @ 90%
                double tcrit_two_95 = 0; // two-tailed @ 95%
                double tcrit_two_99 = 0; // two-tailed @ 99%
                double tcrit_lower = 0;
                double tcrit_upper = 0;
                try
                {

                    predictor_col0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictor_input, 0);
                    predictor_col1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictor_input, 1);

                    predictand_col0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictand_input, 0);
                    predictand_col1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictand_input, 1);

                    // check to see if the predictor and predictand have the same length
                    if (predictor_col0.Length != predictand_col0.Length)
                    {
                        MessageBox.Show("The predictor and predictand have different number of data points. These must be equal");
                        update_progress_textbox("Regression did not complete");
                        Cursor.Current = Cursors.Default;
                        return;
                    }

                    predictor_mean = CStatsFactory.get_mean(predictor_col1);
                    predictand_mean = CStatsFactory.get_mean(predictand_col1);

                    a1 = CRegressionFactory.get_a1_onepredictor(predictor_col1, predictand_col1);
                    a0 = CRegressionFactory.get_a0_onepredictor(predictor_mean, predictand_mean, a1);

                    r = CRegressionFactory.get_corr_coeff(predictor_col1, predictand_col1);
                    rsquared = Math.Pow(r, 2);
                    CRegressionFactory.get_regression_line_onepredictor(predictor_col1, a0, a1, out this.xmin, out this.xmax, out this.y_xmin, out this.y_xmax);


                    // use t test to identify significance

                    double N = Convert.ToDouble(predictor_col1.Length);

                    //int dof = predictor_col1.Length - 2;

                    int dof = CRegressionFactory.get_correlation_coefficient_sample_size(predictor_col1, predictand_col1);
                    if (dof <= 2)
                    {
                        update_progress_textbox("D.O.F. is less than or equal to 2");
                        MessageBox.Show("The series have high autocorrelation and the degrees of freedom is less than or equal to 2. Significance test are not performed");
                        // put 0 values for these in stats table
                        regression_output[5] = 0;//tstatistic;
                        regression_output[6] = 0; //tcrit_lower;
                        regression_output[7] = 0; //tcrit_upper;                    
                    }

                    else
                    {
                        tstatistic = CStatsFactory.get_corr_coeff_tstatistic(r, dof);

                        tcrit_one_90 = alglib.invstudenttdistribution(dof - 2, .90);  // one-tailed @ 90%
                        tcrit_one_95 = alglib.invstudenttdistribution(dof - 2, .95);  // one tailed @ 95% 
                        tcrit_one_99 = alglib.invstudenttdistribution(dof - 2, .99);  // one-tailed @ 99%

                        tcrit_two_90 = alglib.invstudenttdistribution(dof - 2, .95);  // two-tailed @ 90%
                        tcrit_two_95 = alglib.invstudenttdistribution(dof - 2, .975); // two-tailed @ 95%
                        tcrit_two_99 = alglib.invstudenttdistribution(dof - 2, .995); // two-tailed @ 99%
                        tcrit_lower = 0;
                        tcrit_upper = 0;

                        if (radioButton_regression_onetailed.Checked == true)
                        {
                            if (comboBox_regression_significance_level.SelectedItem == "90")
                            {
                                tcrit_lower = alglib.invstudenttdistribution(dof, .90);  // one-tailed @ 90%
                                tcrit_upper = 0;
                            }
                            if (comboBox_regression_significance_level.SelectedItem == "95")
                            {
                                tcrit_lower = alglib.invstudenttdistribution(dof, .95);  // one tailed @ 95% 
                                tcrit_upper = 0;
                            }
                            if (comboBox_regression_significance_level.SelectedItem == "99")
                            {
                                tcrit_lower = alglib.invstudenttdistribution(dof, .99);  // one-tailed @ 99%
                                tcrit_upper = 0;
                            }
                        }
                        if (radioButton_regression_twotailed.Checked == true)
                        {
                            if (comboBox_regression_significance_level.SelectedItem == "90")
                            {
                                tcrit_lower = -alglib.invstudenttdistribution(dof, .95);  // two-tailed @ 90%
                                tcrit_upper = alglib.invstudenttdistribution(dof, .95);  // two-tailed @ 90%
                            }
                            if (comboBox_regression_significance_level.SelectedItem == "95")
                            {
                                tcrit_lower = -alglib.invstudenttdistribution(dof, .975); // two-tailed @ 95%
                                tcrit_upper = alglib.invstudenttdistribution(dof, .975); // two-tailed @ 95%
                            }
                            if (comboBox_regression_significance_level.SelectedItem == "99")
                            {
                                tcrit_lower = -alglib.invstudenttdistribution(dof, .995); // two-tailed @ 99%
                                tcrit_upper = alglib.invstudenttdistribution(dof, .995); // two-tailed @ 99%
                            }
                        }
                    }

                    regression_labels[0] = "slope";
                    regression_labels[1] = "intercept";
                    regression_labels[2] = "corr. coeff.";
                    regression_labels[3] = "rsquared";
                    regression_labels[4] = "effective sample size";
                    regression_labels[5] = "tstatistic";
                    regression_labels[6] = "t critical lower";
                    regression_labels[7] = "t critical upper";

                    regression_output[0] = a1;
                    regression_output[1] = a0;
                    regression_output[2] = r;
                    regression_output[3] = rsquared;
                    regression_output[4] = dof;

                    if (dof > 2)
                    {
                        regression_output[5] = tstatistic;
                        regression_output[6] = tcrit_lower;
                        regression_output[7] = tcrit_upper;
                    }

                    save_row_regression_table(selecteddataseriesname, selecteddataseriesname_regression_predictor_input, selecteddataseriesname_regression_predictand_input,
                        selecteddataseriesname_regression_line_output, selecteddataseriesname_regression_table_output);
                    update_datagridview_progress();

                    // create tables in datamaster
                    get_new_datatable_in_datamaster(this.selecteddataseriesname_regression_table_output);
                    get_new_datatable_in_datamaster(this.selecteddataseriesname_regression_line_output);
                    //DataView viewdatagrid = new DataView(datamaster.Tables[this.selecteddataseriesname_regression_table_output]);

                    // put results into datamaster
                    get_datatable_from_string_and_double(regression_labels, "statistic", regression_output, "value", selecteddataseriesname_regression_table_output);

                    if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
                    {
                        // Open the form for plotting data. Pass the datamaster dataset to it.
                        Form_plot_regression form_plot_regression = new Form_plot_regression(datamaster, selecteddataseriesname_regression_predictor_input, selecteddataseriesname_regression_predictand_input, selecteddataseriesname_regression_table_output, this);
                        form_plot_regression.Show();
                    }

                    regression_exists = change_viewdatatable(selecteddataseriesname_regression_table_output);

                    if (regression_exists)
                    {
                        button_plot_regression.Enabled = true;
                        button_regression_viewdatatable.Enabled = true;
                        update_progress_textbox("The regression and correlation analysis is complete.");
                        Cursor.Current = Cursors.Default;

                    }
                    else
                    {
                        button_plot_regression.Enabled = false;
                        button_regression_viewdatatable.Enabled = false;
                        update_progress_textbox("Something went wrong. The regression and correlation analysis is not complete.");
                        Cursor.Current = Cursors.Default;
                    }
                }
                catch
                {
                    Cursor.Current = Cursors.Default;
                }
            }
            catch
            {
                Cursor.Current = Cursors.Default;
            }
        }

        private void button_regression_viewdatatable_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, this.selecteddataseriesname_regression_table_output);
            form_grid.Show();
        }

        private void button_plot_regression_Click(object sender, EventArgs e)
        {
            
            Form_plot_regression form_plot_regression = new Form_plot_regression(datamaster, selecteddataseriesname_regression_predictor_input, selecteddataseriesname_regression_predictand_input, selecteddataseriesname_regression_table_output, this);
            form_plot_regression.Show();
        }

        private void button_calculatelag_Click(object sender, EventArgs e)
        {
            double[] predictor_col0;
            double[] predictor_col1;

            double[] predictand_col0;
            double[] predictand_col1;

            predictor_col0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictor_input, 0);
            predictor_col1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictor_input, 1);

            predictand_col0 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictand_input, 0);
            predictand_col1 = get_oneColArray_from_datatable(datamaster, selecteddataseriesname_regression_predictand_input, 1);

            Cursor.Current = Cursors.WaitCursor;
            // check to see if the predictor and predictand have the same length
            if (predictor_col0.Length != predictand_col0.Length)
            {
                MessageBox.Show("The predictor and predictand have different number of data points. These must be equal");
                update_progress_textbox("Regression did not complete");
                Cursor.Current = Cursors.Default;
                return;
            }
            
            //double r_lag_max_positive; // maximum positive correlation
            //int best_lag_max_positive; // lag at maximum positive correlation, x leading y
            //double r_lag_max_negative; // maximum negative correlation
            // best_lag_max_negative; // lat at maximum negative correlation, y leading x

            double[] rvalues;
            int[] lags;

            this.max_forward_lagToUse = Convert.ToInt32(textBox_CCF_max_forward_lag.Text);
            this.max_backward_lagToUse = Convert.ToInt32(textBox_CCF_max_backward_lag.Text);

            this.max_forward_lagToUse = Math.Abs(this.max_forward_lagToUse);
            this.max_backward_lagToUse = Math.Abs(this.max_backward_lagToUse);

            CRegressionFactory.get_best_lag(predictor_col1, predictand_col1, this.max_forward_lagToUse, this.max_backward_lagToUse, out r_lag_max_positive, out best_lag_max_positive, out r_lag_max_negative, out best_lag_max_negative, out rvalues, out lags);
            
            double[] lags_double = new double[lags.Length];

            for (int i = 0; i < lags.Length; i++)
            {
                lags_double[i] = Convert.ToDouble(lags[i]);
            }
            
            textBox_max_positive_correlation.Text = r_lag_max_positive.ToString();
            textBox_max_positive_correlation_lag.Text = best_lag_max_positive.ToString();

            textBox_max_negative_correlation.Text = r_lag_max_negative.ToString();
            textBox_max_negative_correlation_lag.Text = best_lag_max_negative.ToString();

            save_row_CCF_table(selecteddataseriesname, selecteddataseriesname_regression_predictor_input, selecteddataseriesname_regression_ccf_output);
            update_datagridview_progress();

            // create a table in datamaster to hold the results
            get_new_datatable_in_datamaster(selecteddataseriesname_regression_ccf_output);
            
            // put results into the table in datamaster
            get_datatable_from_twoColArray(lags_double, rvalues, selecteddataseriesname_regression_ccf_output);

            if (automaticallyGeneratePlotsToolStripMenuItem.Checked == true)
            {
                // Open the form for plotting data. Pass the datamaster dataset to it.
                Form_plot_ACF_PACF form_CCF_plot = new Form_plot_ACF_PACF(datamaster, selecteddataseriesname_regression_ccf_output, this);
                form_CCF_plot.Show();
            }

            ccf_exists = change_viewdatatable(selecteddataseriesname_regression_ccf_output);

            if (ccf_exists)
            {
                button_plot_regression_ccf.Enabled = true;
                button_view_CCF_datatable.Enabled = true;
                update_progress_textbox("Cross correlation function calculation is complete");

            }
            else
            {
                button_plot_regression_ccf.Enabled = false;
                button_view_CCF_datatable.Enabled = false;
                update_progress_textbox("Something went wrong. The cross correlation function calculation is not complete");
            }
            Cursor.Current = Cursors.Default;

        }

        private void button_plot_regression_ccf_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_plot_ACF_PACF form_CCF_plot = new Form_plot_ACF_PACF(datamaster, selecteddataseriesname_regression_ccf_output, this);
            form_CCF_plot.Show();
        }

        private void button_view_CCF_datatable_Click(object sender, EventArgs e)
        {
            // Open the form for plotting data. Pass the datamaster dataset to it. 
            Form_datagrid form_grid = new Form_datagrid(datamaster, selecteddataseriesname_regression_ccf_output);
            form_grid.Show();
        }

        private void button_plot_regression_max_positive_correlation_Click(object sender, EventArgs e)
        {
            Form_plot_lagged_series form_plot_lagged_series = new Form_plot_lagged_series(datamaster, selecteddataseriesname_regression_predictor_input, selecteddataseriesname_regression_predictand_input, best_lag_max_positive, this);
            form_plot_lagged_series.Show();
        }

        private void button_plot_regression_max_negative_correlation_Click(object sender, EventArgs e)
        {
            Form_plot_lagged_series form_plot_lagged_series = new Form_plot_lagged_series(datamaster, selecteddataseriesname_regression_predictor_input, selecteddataseriesname_regression_predictand_input, best_lag_max_negative, this);
            form_plot_lagged_series.Show();
        }

        #endregion actions
    }
}