﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Form_export_csv_grid : Form
    {
        private Cdatamaster datamaster;
        private FormToolkit formtoolkit;
        private string dataseriesname;
        private string selectedseries;

        public Form_export_csv_grid(Cdatamaster datamasterToUse, string dataseriesnameToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.dataseriesname = dataseriesnameToUse;
            this.formtoolkit = formtoolkitToUse;

            // fill in values for the comboboxes
            fill_combobox_with_datatablenames_export_csv_grid();
            comboBox_export_csv_grid_dataseriesname.Text = dataseriesname;
            comboBox_export_csv_grid_dataseriesname.SelectedText = dataseriesname.ToString();
            fill_combobox_with_datatablenames_export_csv_grid_seriesnames();
            comboBox_export_csv_grid_select_series.SelectedText = dataseriesname.ToString();

           

            // fill the select series combobox with series associated with the dataseriesname


        }

        //private void groupBox1_Enter(object sender, EventArgs e)
        //{

        //}

        public void fill_combobox_with_datatablenames_export_csv_grid()
        {
            comboBox_export_csv_grid_dataseriesname.Items.Clear();
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                {
                    comboBox_export_csv_grid_dataseriesname.Items.Add(dr["SiteID"].ToString());
                }
            }
        }

        public void fill_combobox_with_datatablenames_export_csv_grid_seriesnames()
        {
            comboBox_export_csv_grid_select_series.Items.Clear();
            foreach (DataTable table in datamaster.Tables)
            {
                if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
                    & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
                    & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection"
                    & table.TableName != "ProjectionSum")
                {
                    if (table.TableName.Length >= dataseriesname.Length)
                    {
                        if (table.TableName.Substring(0, dataseriesname.Length) == this.dataseriesname)
                        {
                            comboBox_export_csv_grid_select_series.Items.Add(table.TableName);
                            comboBox_export_csv_grid_select_series.Items.IndexOf(table.TableName);
                        }
                    }
                }
            }
         }

        private void comboBox_export_csv_grid_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            fill_combobox_with_datatablenames_export_csv_grid_seriesnames();
        }

        private void button_export_csv_grid_select_save_file_Click(object sender, EventArgs e)
        {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.DefaultExt = "csv";
            saveFileDialog1.Filter = "Save File (*.csv)| *.csv";
            saveFileDialog1.Title = "Save File";
            saveFileDialog1.ShowDialog();

            // If the file name is not an empty string open it for saving.
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                double[] A = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedseries,0);
                this.formtoolkit.write_1D_results_double(A, saveFileDialog1.FileName);
            }
        }

        private void comboBox_export_csv_grid_select_series_SelectedIndexChanged(object sender, EventArgs e)
        {
            selectedseries = comboBox_export_csv_grid_select_series.Text.ToString();
        }

        private void button_export_csv_grid_close_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
