﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Form_export_csv_vector : Form
    {
        private Cdatamaster datamaster;
        private FormToolkit formtoolkit;
        private string dataseriesname;
        private string selectedseries;

        public Form_export_csv_vector(Cdatamaster datamasterToUse, string dataseriesnameToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.dataseriesname = dataseriesnameToUse;
            this.formtoolkit = formtoolkitToUse;

            // fill in values for the comboboxes
            fill_combobox_with_datatablenames_export_csv_vector();
            comboBox_export_csv_vector_dataseriesname.Text = dataseriesname;
            comboBox_export_csv_vector_dataseriesname.SelectedText = dataseriesname.ToString();
            fill_combobox_with_datatablenames_export_csv_vector_seriesnames();
            comboBox_export_csv_vector_selectseries.SelectedText = dataseriesname.ToString();

            if (comboBox_export_csv_vector_dataseriesname.Text == "")
            {
                comboBox_export_csv_vector_selectseries.Enabled = false;
            }
            else
            {
                comboBox_export_csv_vector_selectseries.Enabled = true;
            }
        }
        public void fill_combobox_with_datatablenames_export_csv_vector()
        {
            comboBox_export_csv_vector_dataseriesname.Items.Clear();
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                {
                    comboBox_export_csv_vector_dataseriesname.Items.Add(dr["SiteID"].ToString());
                }
            }
        }

        public void fill_combobox_with_datatablenames_export_csv_vector_seriesnames()
        {
            comboBox_export_csv_vector_selectseries.Items.Clear();
            foreach (DataTable table in datamaster.Tables)
            {
                if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
                    & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
                    & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection"
                    & table.TableName != "ProjectionSum")
                {
                    if (table.TableName.Length >= dataseriesname.Length)
                    {
                        if (table.TableName.Substring(0, dataseriesname.Length) == this.dataseriesname)
                        {
                            comboBox_export_csv_vector_selectseries.Items.Add(table.TableName);
                            comboBox_export_csv_vector_selectseries.Items.IndexOf(table.TableName);
                        }
                    }
                }
            }
        }

        private void comboBox_export_csv_vector_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            fill_combobox_with_datatablenames_export_csv_vector_seriesnames();
        }

        //private void button_export_csv_vector_selectfile_Click(object sender, EventArgs e)
        //{
        //    int nrow;
        //    int ncol;

        //    List<string> x_vec;
        //    List<string> y_vec;

        //    get_selected_output_dimensions(out nrow, out ncol);

        //    SaveFileDialog saveFileDialog1 = new SaveFileDialog();
        //    saveFileDialog1.DefaultExt = "csv";
        //    saveFileDialog1.Filter = "Save File (*.csv)| *.csv";
        //    saveFileDialog1.Title = "Save File";
        //    saveFileDialog1.ShowDialog();

        //    // If the file name is not an empty string open it for saving.
        //    if (saveFileDialog1.ShowDialog() == DialogResult.OK)
        //        try
        //        {
        //            {

        //                x_vec = this.formtoolkit.get_oneColListString_from_datatable(datamaster, selectedseries, 0);
        //                y_vec = this.formtoolkit.get_oneColListString_from_datatable(datamaster, selectedseries, 1);

        //                this.formtoolkit.write_2D_array_stringList_csv(x_vec, y_vec, saveFileDialog1.FileName);
        //            }
        //        }
        //        catch
        //        {
        //            MessageBox.Show("File didn't export correctly");
        //        }
        //}

        private void button_export_csv_vector_selectfile_Click(object sender, EventArgs e)
        {
            int firstloop;
            int secondloop;

            List<string> x_vec;
            List<string> y_vec;

            string[,] X;

            get_selected_output_dimensions(out firstloop, out secondloop);

            SaveFileDialog saveFileDialog1 = new SaveFileDialog();
            saveFileDialog1.DefaultExt = "txt";
            saveFileDialog1.Filter = "TXT file (*.txt)|*.txt| CSV file (*.csv)|*.csv"; //"Save File (*.csv)| *.csv"; 
            saveFileDialog1.Title = "Save File";
            saveFileDialog1.ShowDialog();

            // If the file name is not an empty string open it for saving.
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                try
                {
                    X = this.formtoolkit.get_stringArray_from_datatable(this.datamaster, selectedseries);
                    this.formtoolkit.write_2D_array_string_csv(X, saveFileDialog1.FileName);
                    //{

                    //    x_vec = this.formtoolkit.get_oneColListString_from_datatable(datamaster, selectedseries, 0);
                    //    y_vec = this.formtoolkit.get_oneColListString_from_datatable(datamaster, selectedseries, 1);

                    //    this.formtoolkit.write_2D_array_stringList_csv(x_vec, y_vec, saveFileDialog1.FileName);
                    //}
                }
                catch
                {
                    MessageBox.Show("File didn't export correctly");
                }
        }

        private void comboBox_export_csv_vector_selectseries_SelectedIndexChanged(object sender, EventArgs e)
        {
            selectedseries = comboBox_export_csv_vector_selectseries.Text.ToString();
        }

        private void button_export_csv_vector_close_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void get_selected_output_dimensions(out int nrow, out int ncol)
        {
            // get the size of the selected output from the 


            nrow = 0;
            ncol = 0;


            foreach (DataTable table in datamaster.Tables)
            {
                if(table.TableName == this.selectedseries)
                {
                    nrow = table.Rows.Count;
                    ncol = table.Columns.Count;
                }
            }
        }
    }

}
