﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Form_interpolation_details : Form
    {
        private Cdatamaster datamaster;
        private FormToolkit formtoolkit;

        private string selecteddataseries;
        private string interpmethod;
        private double interp_startdate;
        private double interp_enddate;
        private int interp_numpoints;

        // variables for defining default start and end dates
        double[] x;
        double start;
        double end;

        // variables for clamped cubic spline
        double fp0;
        double fpn;

        public Form_interpolation_details(Cdatamaster datamasterToUse, FormToolkit formtoolkitToUse, string selecteddataseriesToUse, string interpmethod) //, double interp_startdateToUse, double interp_enddateToUse, int interp_numpointsToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.formtoolkit = formtoolkitToUse;
            this.selecteddataseries = selecteddataseriesToUse;
            //this.interp_startdate = interp_startdateToUse;
            //this.interp_enddate = interp_enddateToUse;
            //this.interp_numpoints = interp_numpointsToUse;
            //label_dataseriesname.Text = "Data Series Name:" + this.selecteddataseries;

            this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is time

            // default values for interpolation ranges
            this.start = x.Min();
            this.end = x.Max();

            textBox_define_points_start_date.Text = this.start.ToString();
            textBox_define_points_end_date.Text = this.end.ToString();


            //if (interpmethod == "Clamped Cubic Spline")
            //{
            //    textBox_interpdetails_fp0.Enabled = true;
            //    textBox_interpdetails_fpn.Enabled = true;
            //}
            //else
            //{
            //    textBox_interpdetails_fp0.Enabled = false;
            //    textBox_interpdetails_fpn.Enabled = false;
            //}


        }

       
        private void dataseriesname_Click(object sender, EventArgs e)
        {

        }


        private void radioButton_load_points_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton_load_points.Checked == true)
            {
                textBox_define_points_start_date.Enabled = false;
                textBox_define_points_end_date.Enabled = false;
                textBox_define_points_number_points.Enabled = false;
            }
            if (radioButton_load_points.Checked == false)
            {
                textBox_define_points_start_date.Enabled = true;
                textBox_define_points_end_date.Enabled = true;
                textBox_define_points_number_points.Enabled = true;

                textBox_define_points_start_date.Text = this.start.ToString();
                textBox_define_points_end_date.Text = this.end.ToString();

            }
        }

        private void radioButton_define_points_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void textBox_define_points_start_date_TextChanged(object sender, EventArgs e)
        {
            string myStr = textBox_define_points_start_date.Text.ToString();

            //try
            //{
            this.interp_startdate = Convert.ToDouble(myStr);
            //}
            //catch
            //{
            //    throw;
            //}
        }

        private void textBox_define_points_end_date_TextChanged(object sender, EventArgs e)
        {
            string myStr = textBox_define_points_end_date.Text.ToString();
        //    try
        //    {
            this.interp_enddate = Convert.ToDouble(myStr);
        //    }
        //    catch
        //    {
        //        throw;
        //    }
        }

        private void textBox_define_points_number_points_TextChanged(object sender, EventArgs e)
        {
            string myStr = textBox_define_points_number_points.Text.ToString();
            try
            {
                this.interp_numpoints = Convert.ToInt32(myStr);
            }
            catch
            {
            //    throw;
            }

        }

        public double startdate
        {
            get { return this.interp_startdate; }
        }

        public double enddate
        {
            get { return this.interp_enddate; }
        }

        public int numpoints
        {
            get { return this.interp_numpoints; }
        }

        public double fp0_method
        {
            get { return this.fp0; }
        }

        public double fpn_method
        {
            get { return this.fpn; }
        }
        
        
        private void button_interp_details_ok_Click(object sender, EventArgs e)
        {

            formtoolkit.get_interp_startdate = startdate;
            formtoolkit.get_interp_enddate = enddate;
            formtoolkit.get_interp_numpoints = numpoints;

            formtoolkit.get_fp0 = fp0_method;
            formtoolkit.get_fpn = fpn_method;
            if (numpoints > 0)
            {
                formtoolkit.change_interp_button();
            }
            Close();
        }

        private void textBox_interpdetails_fp0_TextChanged(object sender, EventArgs e)
        {
            //string myStr = textBox_interpdetails_fp0.Text.ToString();
            //    try
            //    {
            //this.fp0 = Convert.ToDouble(myStr);

        }

        private void textBox_interpdetails_fpn_TextChanged(object sender, EventArgs e)
        {
            //string myStr = textBox_interpdetails_fpn.Text.ToString();
            ////    try
            ////    {
            //this.fpn = Convert.ToDouble(myStr);
        }

        private void button_browse_Click(object sender, EventArgs e)
        {

        }

        private void button_viewinterpolationpoints_Click(object sender, EventArgs e)
        {
            double[] x;
            if (radioButton_define_points.Checked == true)
            {
                try
                {
                    x = CPreprocessDataFactory.CInterpolationFactory.get_intervals_for_interpolation(interp_startdate, interp_enddate, interp_numpoints);
                    int n = x.Length;
                    dataGridView_inpolationpoints.Rows.Clear();

                    for (int i = 0; i < n; i++)
                    {
                        dataGridView_inpolationpoints.Rows.Add();
                        dataGridView_inpolationpoints.Rows[i].Cells[0].Value = x[i];
                    }
                }


                catch
                {
                    MessageBox.Show("Something went wrong. The points can't be shown");
                }
            }
        }

        
    }
}
