﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace Climate_toolkit
{
    public partial class Form_multi_plot : Form
    {
        private Cdatamaster datamaster;
        private string[] selecteddataseries = new string[10];

        private FormToolkit formtoolkit;

        private double[] x; // array for holding x axis values
        private double[] y; // array for holding x axis values

        private double[] xtemp;
        private double[] ytemp; //placeholders for 1d vectors
        private int [] templength;

        private double xmin;
        private double xmax;

        private double ymin = 999999999;
        private double ymax = -999999999;

        private double ymin_temp;
        private double ymax_temp;

        bool plot_points = false;
        bool plot_line = false;
        bool plot_points_line = true;

        private int nseries;

        Series series = new Series();

        public Form_multi_plot(Cdatamaster datamasterToUse, string selecteddataseriesToUse1, string selecteddataseriesToUse2, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();

            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries[0] = selecteddataseriesToUse1;
            this.selecteddataseries[1] = selecteddataseriesToUse2;
            this.formtoolkit = formtoolkitToUse;

            this.Text = this.selecteddataseries[0];
            
            this.series = chart1.Series.Add(this.selecteddataseries[0]);
            this.series = chart1.Series.Add(this.selecteddataseries[1]);

            // assign axes titles
            string col0name = Convert.ToString(datamaster.Tables[this.selecteddataseries[0]].Columns[0].ColumnName);
            string col1name = Convert.ToString(datamaster.Tables[this.selecteddataseries[0]].Columns[1].ColumnName);

            nseries = 2; //for initial plot

            double xmintemp;
            double xmaxtemp;
            double ymintemp;
            double ymaxtemp;

            for (int i = 0; i < nseries; i++)
            {
                // assign data to initial two series
                x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 0);
                y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 1);

                if (i == 0)
                {
                    xmin = this.x.Min();
                    xmax = this.x.Max();
                }

                xmintemp = this.x.Min();
                xmintemp = Math.Round(xmintemp);

                xmaxtemp = this.x.Max();
                xmaxtemp = Math.Round(xmaxtemp, 0, MidpointRounding.AwayFromZero);

                if (xmintemp < xmin) { xmin = xmintemp; }
                if (xmaxtemp > xmax) { xmax = xmaxtemp; }

                ymintemp = this.y.Min();
                ymintemp = Math.Round(ymintemp);

                ymaxtemp = this.y.Max();
                ymaxtemp = Math.Round(ymaxtemp, 0, MidpointRounding.AwayFromZero);

                if (ymintemp < ymin) { ymin = ymintemp; }
                if (ymaxtemp > ymax) { ymax = ymaxtemp; }  

                this.xmin = this.x.Min();
                this.xmin = Math.Round(this.xmin);
                this.xmax = this.x.Max();
                this.xmax = Math.Round(this.xmax, 0, MidpointRounding.AwayFromZero);

                ymin_temp = this.y.Min();
                ymax_temp = this.y.Max();

                if (ymin_temp < this.ymin)
                {
                    this.ymin = ymin_temp;
                }
                if (ymax_temp > this.ymax)
                {
                    this.ymax = ymax_temp;
                }
            }


            chart1.ChartAreas[0].AxisX.IntervalAutoMode = IntervalAutoMode.VariableCount;
            chart1.ChartAreas[0].AxisY.IntervalAutoMode = IntervalAutoMode.VariableCount;

            chart1.ChartAreas[0].AxisX.LabelStyle.Format = "###.##";
            chart1.ChartAreas[0].AxisY.LabelStyle.Format = "###.##";

            chart1.ChartAreas[0].AxisX.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisY.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisX.TitleFont = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisY.TitleFont = new Font("Microsoft Sans Serif", 12);

            chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

            UpdateChartSettings();
            
            //for (int i = 0; i < nseries; i++)
            //{
            //    xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[0], 0);
            //    ytemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[0], 1);
            //    templength[i] = xtemp.Length;
            //    for (int j = 0; j < templength[i]; j++)
            //    {
            //        this.x[i, j] = xtemp[j];
            //        this.y[i, j] = ytemp[j];
            //    }
            //}

            // set up default plotting options    

            // Enable range selection and zooming end user interface
            chart1.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart1.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart1.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart1.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart1.ChartAreas[0].BackColor = Color.Transparent;

            chart1.ChartAreas[0].AxisX.Title = Convert.ToString(col0name);
            chart1.ChartAreas[0].AxisY.Title = Convert.ToString(col1name);

            chart1.ChartAreas[0].AxisX.RoundAxisValues();

            chart1.Legends[0].Docking = Docking.Top;
            chart1.Legends[0].Alignment = StringAlignment.Center;
            chart1.Legends[0].Font = new Font("Microsoft Sans Serif", 12);

            // Set ToolTips for Data Point Series
            chart1.Series[0].ToolTip = "#VALX, #VALY";
            chart1.Series[1].ToolTip = "#VALX, #VALY";
        }

        public Form_multi_plot(Cdatamaster datamasterToUse, string selecteddataseriesToUse1, string selecteddataseriesToUse2, string selecteddataseriesToUse3, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();

            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries[0] = selecteddataseriesToUse1;
            this.selecteddataseries[1] = selecteddataseriesToUse2;
            this.selecteddataseries[2] = selecteddataseriesToUse3;
            this.formtoolkit = formtoolkitToUse;

            this.Text = this.selecteddataseries[0];

            this.series = chart1.Series.Add(this.selecteddataseries[0]);
            this.series = chart1.Series.Add(this.selecteddataseries[1]);
            this.series = chart1.Series.Add(this.selecteddataseries[2]);

            // assign axes titles
            string col0name = Convert.ToString(datamaster.Tables[this.selecteddataseries[0]].Columns[0].ColumnName);
            string col1name = Convert.ToString(datamaster.Tables[this.selecteddataseries[0]].Columns[1].ColumnName);

            nseries = 3; //for initial plot

            double xmintemp;
            double xmaxtemp;
            double ymintemp;
            double ymaxtemp;

            for (int i = 0; i < nseries; i++)
            {
                // assign data to initial two series
                x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 0);
                y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 1);

                if (i == 0)
                {
                    xmin = this.x.Min();
                    xmax = this.x.Max();
                }

                xmintemp = this.x.Min();
                xmintemp = Math.Round(xmintemp);

                xmaxtemp = this.x.Max();
                xmaxtemp = Math.Round(xmaxtemp, 0, MidpointRounding.AwayFromZero);

                if (xmintemp < xmin) { xmin = xmintemp; }
                if (xmaxtemp > xmax) { xmax = xmaxtemp; }

                ymintemp = this.y.Min();
                ymintemp = Math.Round(ymintemp);

                ymaxtemp = this.y.Max();
                ymaxtemp = Math.Round(ymaxtemp, 0, MidpointRounding.AwayFromZero);

                if (ymintemp < ymin) { ymin = ymintemp; }
                if (ymaxtemp > ymax) { ymax = ymaxtemp; }

                chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
                chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

                chart1.ChartAreas[0].AxisX.Minimum = this.xmin;
                chart1.ChartAreas[0].AxisX.Maximum = this.xmax;

                chart1.ChartAreas[0].AxisY.Minimum = this.ymin;
                chart1.ChartAreas[0].AxisY.Maximum = this.ymax;

                //this.xmin = this.x.Min();
                //this.xmax = this.x.Max();
                //ymin_temp = this.y.Min();
                //ymax_temp = this.y.Max();

                //if (ymin_temp < this.ymin)
                //{
                //    this.ymin = ymin_temp;
                //}
                //if (ymax_temp > this.ymax)
                //{
                //    this.ymax = ymax_temp;
                //}
            }



            //for (int i = 0; i < nseries; i++)
            //{
            //    // assign data to initial two series
            //    x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 0);
            //    y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 1);

            //    this.xmin = this.x.Min();
            //    this.xmax = this.x.Max();


            //}

            UpdateChartSettings();

            //for (int i = 0; i < nseries; i++)
            //{
            //    xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[0], 0);
            //    ytemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[0], 1);
            //    templength[i] = xtemp.Length;
            //    for (int j = 0; j < templength[i]; j++)
            //    {
            //        this.x[i, j] = xtemp[j];
            //        this.y[i, j] = ytemp[j];
            //    }
            //}

            // set up default plotting options    

            // Enable range selection and zooming end user interface
            chart1.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart1.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart1.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart1.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart1.ChartAreas[0].BackColor = Color.Transparent;

            chart1.ChartAreas[0].AxisX.Title = Convert.ToString(col0name);
            chart1.ChartAreas[0].AxisY.Title = Convert.ToString(col1name);

            chart1.ChartAreas[0].AxisX.RoundAxisValues();

            chart1.Legends[0].Docking = Docking.Top;
            chart1.Legends[0].Alignment = StringAlignment.Center;

            chart1.ChartAreas[0].AxisX.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisY.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisX.TitleFont = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisY.TitleFont = new Font("Microsoft Sans Serif", 12);

            chart1.Legends[0].Font = new Font("Microsoft Sans Serif", 12);

            chart1.Series[0].ToolTip = "#VALX, #VALY";
            chart1.Series[1].ToolTip = "#VALX, #VALY";
            chart1.Series[2].ToolTip = "#VALX, #VALY";
        }

        public Form_multi_plot(Cdatamaster datamasterToUse, string selecteddataseriesToUse1, string selecteddataseriesToUse2, string selecteddataseriesToUse3, string selecteddataseriesToUse4, string selecteddataseriesToUse5, string selecteddataseriesToUse6, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();

            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries[0] = selecteddataseriesToUse1;
            this.selecteddataseries[1] = selecteddataseriesToUse2;
            this.selecteddataseries[2] = selecteddataseriesToUse3;
            this.selecteddataseries[3] = selecteddataseriesToUse4;
            this.selecteddataseries[4] = selecteddataseriesToUse5;
            this.selecteddataseries[5] = selecteddataseriesToUse6;
            this.formtoolkit = formtoolkitToUse;

            this.Text = this.selecteddataseries[0];

            this.series = chart1.Series.Add(this.selecteddataseries[0]);
            this.series = chart1.Series.Add(this.selecteddataseries[1]);
            this.series = chart1.Series.Add(this.selecteddataseries[2]);
            this.series = chart1.Series.Add(this.selecteddataseries[3]);
            this.series = chart1.Series.Add(this.selecteddataseries[4]);
            this.series = chart1.Series.Add(this.selecteddataseries[5]);

            // assign axes titles
            string col0name = Convert.ToString(datamaster.Tables[this.selecteddataseries[0]].Columns[0].ColumnName);
            string col1name = Convert.ToString(datamaster.Tables[this.selecteddataseries[0]].Columns[1].ColumnName);

            double xmintemp;
            double xmaxtemp;
            double ymintemp;
            double ymaxtemp;

            nseries = 6; //for initial plot

            for (int i = 0; i < nseries; i++)
            {
                // assign data to initial two series
                x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 0);
                y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 1);

                if (i == 0)
                {
                    xmin = this.x.Min();
                    xmax = this.x.Max();
                }


                xmintemp = this.x.Min();
                xmintemp = Math.Round(xmintemp);

                xmaxtemp = this.x.Max();
                xmaxtemp = Math.Round(xmaxtemp, 0, MidpointRounding.AwayFromZero);

                if (xmintemp < xmin) { xmin = xmintemp; }
                if (xmaxtemp > xmax) { xmax = xmaxtemp; }

                ymintemp = this.y.Min();
                ymintemp = Math.Round(ymintemp);

                ymaxtemp = this.y.Max();
                ymaxtemp = Math.Round(ymaxtemp, 0, MidpointRounding.AwayFromZero);

                if (ymintemp < ymin) { ymin = ymintemp; }
                if (ymaxtemp > ymax) { ymax = ymaxtemp; }

                chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
                chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

                chart1.ChartAreas[0].AxisX.Minimum = this.xmin;
                chart1.ChartAreas[0].AxisX.Maximum = this.xmax;

                chart1.ChartAreas[0].AxisY.Minimum = this.ymin;
                chart1.ChartAreas[0].AxisY.Maximum = this.ymax;

  

                //this.xmin = this.x.Min();
                //this.xmax = this.x.Max();
                //ymin_temp = this.y.Min();
                //ymax_temp = this.y.Max();

                //if (ymin_temp < this.ymin)
                //{
                //    this.ymin = ymin_temp;
                //}
                //if (ymax_temp > this.ymax)
                //{
                //    this.ymax = ymax_temp;
                //}
            }


            UpdateChartSettings();

            // set up default plotting options    

            // Enable range selection and zooming end user interface
            chart1.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart1.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart1.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart1.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart1.ChartAreas[0].BackColor = Color.Transparent;

            chart1.ChartAreas[0].AxisX.Title = Convert.ToString(col0name);
            chart1.ChartAreas[0].AxisY.Title = Convert.ToString(col1name);

            chart1.ChartAreas[0].AxisX.RoundAxisValues();

            chart1.Legends[0].Docking = Docking.Top;
            chart1.Legends[0].Alignment = StringAlignment.Center;
            chart1.Legends[0].Font = new Font("Microsoft Sans Serif", 12);

            chart1.Series[0].ToolTip = "#VALX, #VALY";
            chart1.Series[1].ToolTip = "#VALX, #VALY";
            chart1.Series[2].ToolTip = "#VALX, #VALY";
            chart1.Series[3].ToolTip = "#VALX, #VALY";
            chart1.Series[4].ToolTip = "#VALX, #VALY";
            chart1.Series[5].ToolTip = "#VALX, #VALY";

            chart1.ChartAreas[0].AxisX.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisY.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisX.TitleFont = new Font("Microsoft Sans Serif", 12);
            chart1.ChartAreas[0].AxisY.TitleFont = new Font("Microsoft Sans Serif", 12);


            chart1.ChartAreas[0].AxisX.LabelStyle.Format = "###.##";
            chart1.ChartAreas[0].AxisY.LabelStyle.Format = "###.##";

        }

        public void UpdateChartSettings()
        {
            double xmintemp;
            double xmaxtemp;
            double ymintemp;
            double ymaxtemp;

            for (int i = 0; i < nseries; i++)
            {
                // assign data to initial two series
                x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 0);
                y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries[i], 1);

                //xmintemp = this.x.Min();
                //xmintemp = Math.Round(xmintemp);

                //xmaxtemp = this.x.Max();
                //xmaxtemp = Math.Round(xmaxtemp, 0, MidpointRounding.AwayFromZero);

                //if (xmintemp < xmin) { xmin = xmintemp; }
                //if (xmaxtemp > xmax) { xmax = xmaxtemp; }

                //ymintemp = this.y.Min();
                //ymintemp = Math.Round(ymintemp);

                //ymaxtemp = this.y.Max();
                //ymaxtemp = Math.Round(ymaxtemp, 0, MidpointRounding.AwayFromZero);

                //if (ymintemp < ymin) { ymin = ymintemp; }
                //if (ymaxtemp > ymax) { ymax = ymaxtemp; }               

                //chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
                //chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

                chart1.ChartAreas[0].AxisX.Minimum = this.xmin;
                chart1.ChartAreas[0].AxisX.Maximum = this.xmax;

                chart1.ChartAreas[0].AxisY.Minimum = this.ymin;
                chart1.ChartAreas[0].AxisY.Maximum = this.ymax;

                chart1.Series[i].Points.DataBindXY(this.x, this.y);
                if (i == 0)
                {
                    if (plot_points_line)
                    {
                        chart1.Series[i].ChartType = SeriesChartType.Line;
                        chart1.Series[i]["PixelPointWidth"] = "1";
                        chart1.Series[i].Color = Color.Black;
                        chart1.Series[i].MarkerStyle = MarkerStyle.Circle;
                        chart1.Series[i].MarkerSize = 5;
                        chart1.Series[i].MarkerColor = Color.White;
                        chart1.Series[i].MarkerBorderColor = Color.Black;
                        chart1.Series[i].MarkerBorderWidth = 1;
                    }
                    if (plot_points)
                    {
                        chart1.Series[i].ChartType = SeriesChartType.Point;
                        chart1.Series[i]["PixelPointWidth"] = "1";
                        chart1.Series[i].Color = Color.Black;
                        chart1.Series[i].MarkerStyle = MarkerStyle.Circle;
                        chart1.Series[i].MarkerSize = 5;
                        chart1.Series[i].MarkerColor = Color.White;
                        chart1.Series[i].MarkerBorderColor = Color.Black;
                        chart1.Series[i].MarkerBorderWidth = 1;
                    }
                    if (plot_line)
                    {
                        chart1.Series[i].ChartType = SeriesChartType.Line;
                        chart1.Series[i]["PixelPointWidth"] = "1";
                        chart1.Series[i].Color = Color.Black;
                        chart1.Series[i].MarkerStyle = MarkerStyle.Circle;
                        chart1.Series[i].MarkerSize = 0;
                        chart1.Series[i].MarkerColor = Color.White;
                        chart1.Series[i].MarkerBorderColor = Color.Black;
                        chart1.Series[i].MarkerBorderWidth = 0;
                    }

                }
                if (i == 1)
                {
                    chart1.Series[i].ChartType = SeriesChartType.Line;
                    chart1.Series[i].Color = Color.Black;
                    chart1.Series[i].BorderDashStyle = ChartDashStyle.Dash;

                }
                if (i == 2)
                {
                    chart1.Series[i].ChartType = SeriesChartType.Line;
                    chart1.Series[i].Color = Color.Black;
                    chart1.Series[i].BorderDashStyle = ChartDashStyle.Dot;
                }
                if (i == 3)
                {
                    chart1.Series[i].ChartType = SeriesChartType.Line;
                    chart1.Series[i].Color = Color.Aqua;
                }
                if (i == 4)
                {
                    chart1.Series[i].ChartType = SeriesChartType.Line;
                    chart1.Series[i].Color = Color.Blue;
                }
                if (i == 5)
                {
                    chart1.Series[i].ChartType = SeriesChartType.Line;
                    chart1.Series[i].Color = Color.Red;
                }


                chart1.Series[i].Enabled = true;

            }
            
 

        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Create a new save file dialog
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            // Sets the current file name filter string, which determines 
            // the choices that appear in the "Save as file type" or 
            // "Files of type" box in the dialog box.
            saveFileDialog1.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|SVG (*.svg)|*.svg|GIF (*.gif)|*.gif|TIFF (*.tif)|*.tif";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            // Set image file format
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                ChartImageFormat format = ChartImageFormat.Bmp;

                if (saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ChartImageFormat.Bmp;
                }
                else if (saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ChartImageFormat.Jpeg;
                }
                else if (saveFileDialog1.FileName.EndsWith("emf"))
                {
                    format = ChartImageFormat.Emf;
                }
                else if (saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ChartImageFormat.Gif;
                }
                else if (saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ChartImageFormat.Png;
                }
                else if (saveFileDialog1.FileName.EndsWith("tif"))
                {
                    format = ChartImageFormat.Tiff;
                }
                //else if (saveFileDialog1.FileName.EndsWith("svg"))
                //{
                //    format = ChartImageFormat.Svg;
                //}

                // Save image
                chart1.SaveImage(saveFileDialog1.FileName, format);
            }
        }

        private void viewpointsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (viewpointsToolStripMenuItem.Checked == false)
            {
                viewpointsToolStripMenuItem.Checked = true;
            }
            plot_points = true;

            viewPointsAndLineToolStripMenuItem.Checked = false;
            viewlineToolStripMenuItem.Checked = false;

            plot_points_line = false;
            plot_line = false;

            UpdateChartSettings();

        }

        private void viewlineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (viewlineToolStripMenuItem.Checked == false)
            {
                viewlineToolStripMenuItem.Checked = true;
            }
            plot_line = true;

            viewPointsAndLineToolStripMenuItem.Checked = false;
            viewpointsToolStripMenuItem.Checked = false;

            plot_points_line = false;
            plot_points = false;


            UpdateChartSettings();

        }

        private void viewPointsAndLineToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (viewPointsAndLineToolStripMenuItem.Checked == false)
            {
                viewPointsAndLineToolStripMenuItem.Checked = true;
            }
            plot_points_line = true;

            viewpointsToolStripMenuItem.Checked = false;
            viewlineToolStripMenuItem.Checked = false;

            plot_points = false;
            plot_line = false;


            UpdateChartSettings();

        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // create a memory stream to save the chart image    
            System.IO.MemoryStream stream = new System.IO.MemoryStream();

            // save the chart image to the stream    
            chart1.SaveImage(stream, System.Drawing.Imaging.ImageFormat.Bmp);

            // create a bitmap using the stream    
            Bitmap bmp = new Bitmap(stream);

            // save the bitmap to the clipboard    
            Clipboard.SetDataObject(bmp); 
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart1.Printing.Print(true);
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart1.Printing.PrintPreview();
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Application.Exit();
            this.Close();
        }

        private void axisPropertiesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form_plot_axis_properties form_plot_axis_properties = new Form_plot_axis_properties(this.xmin, this.xmax, this.ymin, this.ymax, this);
            form_plot_axis_properties.Show();
        }

        public double get_xmin
        {
            set { this.xmin = value; }
        }

        public double get_xmax
        {
            set { this.xmax = value; }
        }

        public double get_ymin
        {
            set { this.ymin = value; }
        }

        public double get_ymax
        {
            set { this.ymax = value; }
        }
    }
}
