﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

namespace Climate_toolkit
{
    public partial class Form_openExcel : Form
    {

        private Cdatamaster datamaster;
        private FormToolkit formtoolkit;
        private string Rawtablename;

        string col0name = "time";
        string col1name = "value"; //default values of column names

        int numberOfRows = 100;

        public Form_openExcel(Cdatamaster datamasterToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            dataGridView_openexcel.AutoGenerateColumns = true;
            data = new DataTable();

            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.formtoolkit = formtoolkitToUse;
        }

        private string excelfilename;		//full file name
        private string dirExcel;		//directory of file to import
        private string fileNevExcel;	//name (with extension) of file to import - field
        private string FileNevExcel;	//name (with extension) of file to import - property 

        private DataTable data;

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void label3_Click(object sender, EventArgs e)
        {

        }

        /// <summary>
        /// Returns the connection string needed for connecting to the specified file and type
        /// </summary>
        private string GetConnectionString()
        {
            // Name of the Excel worksheet to open
            string filename = textBoxFilename.Text;

            // Note: the Types array exactly matches the entries in openFileDialog1.Filter
            string[] Types = {
                    "Excel 12.0 Xml", // For Excel 2007 XML (*.xlsx)
                    "Excel 12.0", // For Excel 2007 Binary (*.xlsb)
                    "Excel 12.0 Macro", // For Excel 2007 Macro-enabled (*.xlsm)
                    "Excel 8.0", // For Excel 97/2000/2003 (*.xls)
                    "Excel 5.0" }; // For Excel 5.0/95 (*.xls)
            // Note: openFileDialog1.FilterIndex was saved into textBoxFilename.Tag
            string Type = Types[(int)textBoxFilename.Tag - 1];

            // True if the first row in the Excel data is a header (used for column names, not data)
            bool Header = checkBoxHeader.Checked;

            //// True if columns containing different data types are treated as text
            ////  (note that columns containing only integer types are still treated as integer, etc)
            //bool TreatIntermixedAsText = checkBoxIntermixed.Checked;

            // Build the actual connection string
            OleDbConnectionStringBuilder builder = new OleDbConnectionStringBuilder();
            builder.DataSource = filename;
            if (Type == "Excel 5.0" || Type == "Excel 8.0")
                builder.Provider = "Microsoft.Jet.OLEDB.4.0";
            else
                builder.Provider = "Microsoft.ACE.OLEDB.12.0";
            builder["Extended Properties"] = Type +
                ";HDR=" + (Header ? "Yes" : "No"); // +
                //";IMEX=" + (TreatIntermixedAsText ? "1" : "0");

            // The "ACE" provider requires either Office 2007 or the following redistributable:
            //  Office 2007 Data Connectivity Components:
            //    http://www.microsoft.com/downloads/details.aspx?familyid=7554F536-8C28-4598-9B72-EF94E038C891&displaylang=en

            // The "ACE" provider can be used for older types (e.g., Excel 8.0) as well.

            // The connection strings used for Excel files are not clearly documented; see the following links for more information:
            //  Excel 2007 on ConnectionStrings.com:
            //    http://www.connectionstrings.com/excel-2007
            //  Excel on ConnectionStrings.com:
            //    http://www.connectionstrings.com/excel
            //  Microsoft OLE DB Provider for Microsoft Jet on MSDN:
            //    http://msdn.microsoft.com/en-us/library/ms810660.aspx
            //  KB247412 Methods for transferring data to Excel from Visual Basic:
            //    http://support.microsoft.com/kb/247412
            //  KB278973 ExcelADO demonstrates how to use ADO to read and write data in Excel workbooks:
            //    http://support.microsoft.com/kb/278973
            //  KB306023 How to transfer data to an Excel workbook by using Visual C# 2005 or Visual C# .NET:
            //    http://support.microsoft.com/kb/306023
            //  KB306572 How to query and display excel data by using ASP.NET, ADO.NET, and Visual C# .NET:
            //    http://support.microsoft.com/kb/306572
            //  KB316934 How to use ADO.NET to retrieve and modify records in an Excel workbook with Visual Basic .NET:
            //    http://support.microsoft.com/kb/316934

            return builder.ConnectionString;
        }

        private void buttonOpen_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.InitialDirectory = Application.ExecutablePath.ToString();
            openFileDialog.Filter = "XLS files (*.xls)|*.xls|  XLSX files (*.xlsx)|*.xlsx|   All files (*.*)|*.*";
            if (openFileDialog.ShowDialog(this) == DialogResult.OK)
            {
                // In case there's an error, make sure this button becomes disabled
                buttonRead.Enabled = false;
                dataGridView_openexcel.DataSource = null;
                
                //textBoxConnectionString.Text = "";

                // Save the filename and type (which is needed later)
                textBoxFilename.Text = openFileDialog.FileName;
                textBoxFilename.Tag = openFileDialog.FilterIndex;
                textBox_dataseriesname.Text = textBoxFilename.Text;

                get_dataseriesname();

                //// Establish a connection to the file and read the sheets and named ranges
                comboBoxSheet.Items.Clear();
                try
                {
                    using (OleDbConnection connection = new OleDbConnection(GetConnectionString()))
                    {
                        connection.Open();

                        // See MSDN's "OLE DB Schema Collections (ADO.NET)" for the Microsoft Jet OLE DB Provider
                        //  http://msdn.microsoft.com/en-us/library/cc668764.aspx
                        using (DataTable tables = connection.GetSchema("Tables"))
                        {
                            foreach (DataRow row in tables.Rows)
                                comboBoxSheet.Items.Add((string)row["TABLE_NAME"]);
                        }
                    }

                    // This shouldn't ever happen, but we check for it anyway
                    if (comboBoxSheet.Items.Count == 0)
                        throw new Exception("Excel file has no sheets!");
                    comboBoxSheet.SelectedIndex = 0;
                }
                catch (Exception ex)
                {
                    // Display any errors
                    MessageBox.Show("[" + ex.GetType().Name + "] " + ex.Message + ex.StackTrace);
                }

                //// If everything went OK, then enable the Execute button and give it the focus
                buttonRead.Enabled = true;
                buttonRead.Focus();

                this.textBox_col0name.Enabled = true;
                this.textBox_col1name.Enabled = true;
                this.textBox_numrows_preview.Text = "100";

                load_excel(numberOfRows);

            }
        }


        private void get_dataseriesname()
        {
            // full file name
            this.excelfilename = this.textBox_dataseriesname.Text;

            // creates a System.IO.FileInfo object to retrive information from selected file.
            System.IO.FileInfo fi = new System.IO.FileInfo(this.excelfilename);
            // retrives directory
            this.dirExcel = fi.DirectoryName.ToString();
            // retrives file name with extension
            this.FileNevExcel = fi.Name.ToString();

            // database table name
            this.textBox_dataseriesname.Text = fi.Name.Substring(0, fi.Name.Length - fi.Extension.Length).Replace(" ", "_");
        }

        private void checkBoxHeader_CheckedChanged(object sender, EventArgs e)
        {

        }

        private void buttonRead_Click(object sender, EventArgs e)
        {
            load_excel(numberOfRows);
        }

        private void load_excel(int numberOfRows)
        {
            try
            {
                // Clear the DataGridView and the connection string TextBox
                data.Dispose();
                data = new DataTable();
                dataGridView_openexcel.DataSource = data;
                //textBoxConnectionString.Text = "";
                string connectionstring = "";
                string selectcolumnstring = "";

                // Fill the DataGridView and connection string TextBox
                using (OleDbConnection connection = new OleDbConnection(GetConnectionString()))
                {
                    connection.Open();
                    //textBoxConnectionString.Text = GetConnectionString();
                    //string sheetSelect = "SELECT TOP 20 * FROM [" + (string)comboBoxSheet.SelectedItem + "]";
                    connectionstring = GetConnectionString();



                    //Creates the select command text
                    if (checkBoxHeader.Checked == true)
                    {
                        if (numberOfRows == -1)
                        {
                            selectcolumnstring = "select * from [" + (string)comboBoxSheet.SelectedItem + "]";
                        }
                        else
                        {
                            selectcolumnstring = "select top " + numberOfRows + " * from [" + (string)comboBoxSheet.SelectedItem + "]";
                        }
                    }
                    else
                    {
                        if (numberOfRows == -1)
                        {
                            selectcolumnstring = "select * from [" + (string)comboBoxSheet.SelectedItem + "]";
                        }
                        else
                        {
                            selectcolumnstring = "select top " + numberOfRows + " * from [" + (string)comboBoxSheet.SelectedItem + "]";
                        }
                    }




                    /////selectcolumnstring = "SELECT * FROM [" + (string)comboBoxSheet.SelectedItem + "]";
                    using (OleDbDataAdapter adapter = new OleDbDataAdapter(selectcolumnstring, connection))
                    //using (OleDbDataAdapter adapter = new OleDbDataAdapter(textBoxSelect.Text, connection))
                    {
                        adapter.Fill(data);
                    }

                    //closes the connection
                    connection.Close();

                    //If the first row does not have column names, then rename them based on user input
                    if (checkBoxHeader.Checked == false)
                    {
                        data.Columns[0].ColumnName = Convert.ToString(col0name);
                        data.Columns[1].ColumnName = Convert.ToString(col1name);
                    }
                }

            }
            catch (Exception ex)
            {
                // Display any errors
                MessageBox.Show("[" + ex.GetType().Name + "] " + ex.Message + ex.StackTrace);
            }
        }
        //private void SetSelectString()
        //{
        //    // Overwrites the select TextBox with the sheet selection along with the (optional) range
        //    textBoxSelect.Text = "SELECT * FROM [" + (string)comboBoxSheet.SelectedItem + "]";
        //    //textBoxSelect.Text = "SELECT * FROM [" + (string)comboBoxSheet.SelectedItem + textBoxRange.Text + "]";
        //}

        private void comboBoxSheet_SelectedIndexChanged(object sender, EventArgs e)
        {
            // Ensure that only sheets (not named ranges) can have ranges appended to them
            //if (!((string)comboBoxSheet.SelectedItem).EndsWith("$"))
            //{
            //    textBoxRange.Text = "";
            //    textBoxRange.ReadOnly = true;
            //}
            //else
            //    textBoxRange.ReadOnly = false;

            //SetSelectString();
        }

        //private void textBoxRange_TextChanged(object sender, EventArgs e)
        //{
        //    SetSelectString();
        //}

        private void label4_Click(object sender, EventArgs e)
        {

        }

        private void dataGridView1_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void bindingSource1_CurrentChanged(object sender, EventArgs e)
        {

        }

        private void textBoxFilename_TextChanged(object sender, EventArgs e)
        {

        }

        private void label4_Click_1(object sender, EventArgs e)
        {

        }

        private void button3_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Form_openExcel_Load(object sender, EventArgs e)
        {

        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            load_excel(-1);
            DataTable dt;
            //DataRow dr;

            dt = data;
            //dt.TableName = "dat_"+this.txt_siteID.Text;
            dt.TableName = this.textBox_dataseriesname.Text;
            // add the datatable to datamaster
            if (this.datamaster.Tables.Contains(dt.TableName) == false)
            {
                this.datamaster.Tables.Add(dt);
                this.Rawtablename = dt.TableName;

                // add the ID and name of datatable to "sites" table in datamaster               
                this.formtoolkit.fill_row_sites_table(textBox_dataseriesname.Text, Rawtablename, "vector", dt.Rows.Count, 0, 0);
                // add the data to a raw data table
                formtoolkit.get_rawdatatable = this.Rawtablename;

                formtoolkit.get_ID = this.textBox_dataseriesname.Text;
                formtoolkit.get_selecteddataseriesname = this.textBox_dataseriesname.Text;
                formtoolkit.get_rawdatatable = this.Rawtablename;
                this.formtoolkit.setcombobox_dataseriesname(textBox_dataseriesname.Text);

                //add the siteID to the dataseries combobox



                this.formtoolkit.fill_combobox_with_datatablenames_selecteddataseries();
                this.formtoolkit.fill_combobox_with_datatablenames_predictand_selecteddataseries();
                this.formtoolkit.fill_combobox_with_datatablenames_Describe_data();
                this.formtoolkit.fill_combobox_with_datatablenames_preprocess_data();
                this.formtoolkit.fill_combobox_with_datatablenames_interpolate_data();
                this.formtoolkit.fill_combobox_with_datatablenames_standardize_data();
                this.formtoolkit.fill_combobox_with_datatablenames_cumulative_departure();
                this.formtoolkit.fill_combobox_with_datatablenames_spectralanalysis();
                this.formtoolkit.fill_combobox_with_datatablenames_MEM();
                this.formtoolkit.fill_combobox_with_datatablenames_SSA();
                this.formtoolkit.fill_combobox_with_datatablenames_ACF();
                this.formtoolkit.fill_combobox_with_datatablenames_detrend();
                this.formtoolkit.fill_combobox_with_datatablenames_differencing();
                this.formtoolkit.fill_combobox_with_datatablenames_SSA();
                this.formtoolkit.fill_combobox_with_datatablenames_AR();
                this.formtoolkit.fill_combobox_with_datatablenames_regression_predictor();

                //this.formtoolkit.fill_comboboxwith_datatablenames();

                // set the selecteddataseries combobox to the imported series name
                this.formtoolkit.set_comboboxes_to_new_series();

                this.formtoolkit.update_defaults();
            }

            Close();
        }
        private void textBox_numrows_TextChanged(object sender, EventArgs e)
        {

        }

        private void buttonRead_Validating(object sender, CancelEventArgs e)
        
        {

        }

        private void textBox_numrows_Preview(object sender, CancelEventArgs e)
        {
            string str = textBox_numrows_preview.Text.Trim();
            int num;
            bool isnum = Int32.TryParse(str, out num);
            if (isnum)
            {
                this.numberOfRows = Convert.ToInt32(str);
            }
            else
            {
                MessageBox.Show("Must be an integer");
            }
        }

        private void Column_1_name_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                col0name = Convert.ToString(textBox_col0name.Text);
            }
            catch
            {
            }
        }

        private void Column_2_name_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                col1name = Convert.ToString(textBox_col1name.Text);
            }
            catch
            {
            }
        }
    }
}
