﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace Climate_toolkit
{
    public partial class Form_plot_ACF_PACF : Form
    {
        private Cdatamaster datamaster;
        private string selecteddataseries;

        private FormToolkit formtoolkit;

        private double[] x; // array for holding x axis values
        private double[] y; // array for holding x axis values
        private double[] temp_y; //array for holding temporary y values

        private double[] upper_bound;
        private double[] lower_bound;

        Series series = new Series();

        public Form_plot_ACF_PACF(Cdatamaster datamasterToUse, string selecteddataseriesToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();

            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries = selecteddataseriesToUse;
            this.formtoolkit = formtoolkitToUse;

            // create series
            this.series = chart_ACF_PACF_plot.Series.Add(this.selecteddataseries);
            this.series = chart_ACF_PACF_plot.Series.Add("upper_bound");
            this.series = chart_ACF_PACF_plot.Series.Add("lower_bound");

            //foreach (DataTable dt in datamaster.Tables)
            //{
            //    MessageBox.Show(dt.TableName.ToString());
            //}

            //this.series = chart_spectrum_plot.Series.Add(this.selecteddataseries);
            //this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber, col 1 is period, col 2 is frequency
            //this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            // assign data to series
            this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); 
            this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 1);


            upper_bound = get_upper_95_conf_bound();
            lower_bound = get_lower_95_conf_bound();
         

            //string col0name = Convert.ToString(datamaster.Tables[this.selecteddataseries].Columns[0].ColumnName);
            //string col1name = Convert.ToString(datamaster.Tables[this.selecteddataseries].Columns[1].ColumnName);



            //DataView firstView = new DataView(datamaster.Tables[this.selecteddataseries]);


            // set up default plotting options    

            // Enable range selection and zooming end user interface
            chart_ACF_PACF_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart_ACF_PACF_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart_ACF_PACF_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart_ACF_PACF_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart_ACF_PACF_plot.ChartAreas[0].BackColor = Color.Transparent;

            //chart_ACF_PACF_plot.ChartAreas[0].AxisY.Title = Convert.ToString("ACF");
            chart_ACF_PACF_plot.ChartAreas[0].AxisX.Title = Convert.ToString("Lag");
            chart_ACF_PACF_plot.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart_ACF_PACF_plot.ChartAreas[0].AxisY.MajorGrid.Enabled = true;
            chart_ACF_PACF_plot.ChartAreas[0].AxisY.MajorGrid.Interval = 1;
            if (this.x.Min() == 0)
            {
                chart_ACF_PACF_plot.ChartAreas[0].AxisX.Minimum = 0;
            }
            chart_ACF_PACF_plot.ChartAreas[0].AxisY.Maximum = 1;
            chart_ACF_PACF_plot.ChartAreas[0].AxisY.Minimum = -1;

            //chart_ACF_PACF_plot.Legends[0].Docking = Docking.Top;
            //chart_ACF_PACF_plot.Legends[0].Alignment = StringAlignment.Center; 

            // Set ToolTips for Data Point Series
            chart_ACF_PACF_plot.Series[0].ToolTip = "#VALX, #VALY";

            UpdateChartSettings();
        }


        private void UpdateChartSettings()
        {

            //// Enable range selection and zooming end user interface
            //chart_ACF_PACF_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
            //chart_ACF_PACF_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            //chart_ACF_PACF_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            //chart_ACF_PACF_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            //chart_ACF_PACF_plot.ChartAreas[0].BackColor = Color.Transparent;

            chart_ACF_PACF_plot.Series[this.selecteddataseries].Points.DataBindXY(this.x, this.y);
            chart_ACF_PACF_plot.Series[this.selecteddataseries].ChartType = SeriesChartType.Column;
            chart_ACF_PACF_plot.Series[this.selecteddataseries]["PixelPointWidth"] = "1";
            //chart_ACF_PACF_plot.Series[this.selecteddataseries].ChartType = SeriesChartType.Line;
            chart_ACF_PACF_plot.Series[this.selecteddataseries].Color = Color.Black;

            chart_ACF_PACF_plot.Series["upper_bound"].Points.DataBindXY(this.x, this.upper_bound);
            chart_ACF_PACF_plot.Series["upper_bound"].ChartType = SeriesChartType.Line;
            chart_ACF_PACF_plot.Series["upper_bound"].Color = Color.Red;

            chart_ACF_PACF_plot.Series["lower_bound"].Points.DataBindXY(this.x, this.lower_bound);
            chart_ACF_PACF_plot.Series["lower_bound"].ChartType = SeriesChartType.Line;
            chart_ACF_PACF_plot.Series["lower_bound"].Color = Color.Red;

            chart_ACF_PACF_plot.Series[this.selecteddataseries].Enabled = true;
            chart_ACF_PACF_plot.Series["upper_bound"].Enabled = true;
            chart_ACF_PACF_plot.Series["lower_bound"].Enabled = true;



            //chart_spectrum_plot.Series[this.selecteddataseries].Points.DataBindXY(this.x, this.y);
            //chart_spectrum_plot.Series[this.selecteddataseries].ChartType = SeriesChartType.Line;
            //chart_spectrum_plot.Series[this.selecteddataseries].Color = Color.Black;

            //chart_spectrum_plot.Series[this.selectedrednoise].Points.DataBindXY(this.x_rednoise, this.y_rednoise);
            //chart_spectrum_plot.Series[this.selectedrednoise].ChartType = SeriesChartType.Line;
            //chart_spectrum_plot.Series[this.selectedrednoise].Color = Color.Red;

        }

        private double[] get_upper_95_conf_bound()
        {
            double[] bound = new double[x.Length];
            double x_double = Convert.ToDouble(this.x.Length);
            
            for (int i = 0; i < this.x.Length; i++)
            {
                bound[i] = -1 / x_double + 2 * Math.Sqrt(1 / x_double);
            }
            return bound;
        }

        private double[] get_lower_95_conf_bound()
        {
            double[] bound = new double[x.Length];
            double x_double = Convert.ToDouble(this.x.Length);

            for (int i = 0; i < this.x.Length; i++)
            {
                bound[i] = -1 / x_double - 2 * Math.Sqrt(1 / x_double);
            }
            return bound;
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Create a new save file dialog
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            // Sets the current file name filter string, which determines 
            // the choices that appear in the "Save as file type" or 
            // "Files of type" box in the dialog box.
            saveFileDialog1.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|SVG (*.svg)|*.svg|GIF (*.gif)|*.gif|TIFF (*.tif)|*.tif";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            // Set image file format
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                ChartImageFormat format = ChartImageFormat.Bmp;

                if (saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ChartImageFormat.Bmp;
                }
                else if (saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ChartImageFormat.Jpeg;
                }
                else if (saveFileDialog1.FileName.EndsWith("emf"))
                {
                    format = ChartImageFormat.Emf;
                }
                else if (saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ChartImageFormat.Gif;
                }
                else if (saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ChartImageFormat.Png;
                }
                else if (saveFileDialog1.FileName.EndsWith("tif"))
                {
                    format = ChartImageFormat.Tiff;
                }
                //else if (saveFileDialog1.FileName.EndsWith("svg"))
                //{
                //    format = ChartImageFormat.Svg;
                //}

                // Save image
                chart_ACF_PACF_plot.SaveImage(saveFileDialog1.FileName, format);
            }
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // create a memory stream to save the chart image    
            System.IO.MemoryStream stream = new System.IO.MemoryStream();

            // save the chart image to the stream    
            chart_ACF_PACF_plot.SaveImage(stream, System.Drawing.Imaging.ImageFormat.Bmp);

            // create a bitmap using the stream    
            Bitmap bmp = new Bitmap(stream);

            // save the bitmap to the clipboard    
            Clipboard.SetDataObject(bmp); 
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart_ACF_PACF_plot.Printing.PrintPreview();
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart_ACF_PACF_plot.Printing.Print(true);
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Application.Exit();
            this.Close();
        }
    }
}
