﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Form_plot_axis_properties : Form
    {
        private Form_multi_plot form_multi_plot;
        private Form_RCs_plot form_RCs_plot;
        private Form_series_plot form_series_plot;
        private Form_plot_lagged_series form_plot_lagged_series;

        private string selecteddataseries;

        private double xaxis_min;
        private double xaxis_max;

        private double yaxis_min;
        private double yaxis_max;

        private double xmin;
        private double xmax;
        private double ymin;
        private double ymax;

        bool form_RCs_plot_bool = false;
        bool form_multi_plot_bool = false;
        bool form_series_plot_bool = false;
        bool form_plot_lagged_series_bool = false;

        public Form_plot_axis_properties(double xminToUse, double xmaxToUse, double yminToUse, double ymaxToUse, Form_multi_plot form_multi_plotToUse)
        {
            InitializeComponent();
            form_multi_plot_bool = true;

            this.form_multi_plot = form_multi_plotToUse;

            this.xmin = xminToUse;
            this.xmax = xmaxToUse;
            this.ymin = yminToUse;
            this.ymax = ymaxToUse;

            textBox_xaxis_min.Text = xmin.ToString();
            textBox_xaxis_max.Text = xmax.ToString();

            textBox_yaxis_min.Text = ymin.ToString();
            textBox_yaxis_max.Text = ymax.ToString();
        }

        public Form_plot_axis_properties(double xminToUse, double xmaxToUse, double yminToUse, double ymaxToUse, Form_RCs_plot form_RC_plotToUse)
        {
            InitializeComponent();
            form_RCs_plot_bool = true;

            this.form_RCs_plot = form_RC_plotToUse;

            this.xmin = xminToUse;
            this.xmax = xmaxToUse;
            this.ymin = yminToUse;
            this.ymax = ymaxToUse;

            textBox_xaxis_min.Text = xmin.ToString();
            textBox_xaxis_max.Text = xmax.ToString();

            textBox_yaxis_min.Text = ymin.ToString();
            textBox_yaxis_max.Text = ymax.ToString();
        }

        public Form_plot_axis_properties(double xminToUse, double xmaxToUse, double yminToUse, double ymaxToUse, Form_series_plot form_series_plotToUse)
        {
            InitializeComponent();
            form_series_plot_bool = true;

            this.form_series_plot = form_series_plotToUse;

            this.xmin = xminToUse;
            this.xmax = xmaxToUse;
            this.ymin = yminToUse;
            this.ymax = ymaxToUse;

            textBox_xaxis_min.Text = xmin.ToString();
            textBox_xaxis_max.Text = xmax.ToString();

            textBox_yaxis_min.Text = ymin.ToString();
            textBox_yaxis_max.Text = ymax.ToString();
        }

        public Form_plot_axis_properties(double xminToUse, double xmaxToUse, double yminToUse, double ymaxToUse, Form_plot_lagged_series form_plot_lagged_seriesToUse)
        {
            InitializeComponent();
            form_plot_lagged_series_bool = true;

            this.form_plot_lagged_series = form_plot_lagged_seriesToUse;

            this.xmin = xminToUse;
            this.xmax = xmaxToUse;
            this.ymin = yminToUse;
            this.ymax = ymaxToUse;

            textBox_xaxis_min.Text = xmin.ToString();
            textBox_xaxis_max.Text = xmax.ToString();

            textBox_yaxis_min.Text = ymin.ToString();
            textBox_yaxis_max.Text = ymax.ToString();
        }

        private void textBox_xaxis_min_Validating(object sender, CancelEventArgs e)
        {

            try
            {
                string str = textBox_xaxis_min.Text.ToString();
                this.xmin = Convert.ToDouble(str);
            }
            catch
            {
                MessageBox.Show("Please enter a number");
                textBox_xaxis_min.Text = this.xmin.ToString();
            }
        }

        private void textBox_xaxis_max_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                string str = textBox_xaxis_max.Text.ToString();
                this.xmax = Convert.ToDouble(str);
            }
            catch
            {
                MessageBox.Show("Please enter a number");
                textBox_xaxis_max.Text = this.xmax.ToString();
            }
        }

        private void textBox_yaxis_min_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                string str = textBox_yaxis_min.Text.ToString();
                this.ymin = Convert.ToDouble(str);
            }
            catch
            {
                MessageBox.Show("Please enter a number");
                textBox_yaxis_min.Text = this.ymin.ToString();
            }
        }

        private void textBox_yaxis_max_Validating(object sender, CancelEventArgs e)
        {
            try
            {
                string str = textBox_yaxis_max.Text.ToString();
                this.ymax = Convert.ToDouble(str);
            }
            catch
            {
                MessageBox.Show("Please enter a number");
               textBox_yaxis_max.Text = this.ymax.ToString();
            }
        }

        private void button_ok_Click(object sender, EventArgs e)
        {
            if (form_multi_plot_bool)
            {
                form_multi_plot.get_xmin = xmin;
                form_multi_plot.get_xmax = xmax;
                form_multi_plot.get_ymin = ymin;
                form_multi_plot.get_ymax = ymax;

                form_multi_plot.UpdateChartSettings();
            }
            if (form_series_plot_bool)
            {
                form_series_plot.get_xmin = xmin;
                form_series_plot.get_xmax = xmax;
                form_series_plot.get_ymin = ymin;
                form_series_plot.get_ymax = ymax;

                form_series_plot.UpdateChartSettings();
            }

            if (form_RCs_plot_bool)
            {
                form_RCs_plot.get_xmin = xmin;
                form_RCs_plot.get_xmax = xmax;
                form_RCs_plot.get_ymin = ymin;
                form_RCs_plot.get_ymax = ymax;

                form_RCs_plot.UpdateChartSettings();
            }

            if (form_plot_lagged_series_bool)
            {
                form_plot_lagged_series.get_xmin = xmin;
                form_plot_lagged_series.get_xmax = xmax;
                form_plot_lagged_series.get_ymin = ymin;
                form_plot_lagged_series.get_ymax = ymax;

                form_plot_lagged_series.UpdateChartSettings();
            }

            Close();
        }


    }
}
