﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace Climate_toolkit
{
    public partial class Form_plot_matrix : Form
    {
        private Cdatamaster datamaster;
        private string selecteddataseries;
        private string seriestoplot;

        private FormToolkit formtoolkit;

        private double[] x; // array for holding x axis values
        private double[] y; // array for holding x axis values

        private double xmin;
        private double xmax;

        Series series = new Series();

        public Form_plot_matrix(Cdatamaster datamasterToUse, string selecteddataseriesToUse, int colnum, FormToolkit formtoolkitToUse) // y is the column for the ordinate
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries = selecteddataseriesToUse;
            this.formtoolkit = formtoolkitToUse;

            try
            {
                // create series
                //this.series = chart_plot_matrix.Series.Add(this.selecteddataseries);
                string col1name = Convert.ToString(datamaster.Tables[this.selecteddataseries].Columns[colnum - 1].ColumnName);
                this.seriestoplot = datamaster.Tables[this.selecteddataseries].Columns[colnum - 1].ColumnName;
                this.series = chart_plot_matrix.Series.Add(this.seriestoplot);

//                this.series = chart_plot_matrix.Series.Add(datamaster.Tables[this.selecteddataseries].Columns[colnum - 1].ColumnName);


                //DataView firstView = new DataView(datamaster.Tables[this.selecteddataseries]);

                //this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0);

                this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, colnum-1);
                // assign values along x axis
                this.x = new double[this.y.Length];
                for (int i = 0; i < this.y.Length; i++)
                {
                    this.x[i] = i;
                }

                this.xmin = this.x.Min();
                this.xmax = this.x.Max();

                // Enable range selection and zooming end user interface
                chart_plot_matrix.ChartAreas[0].CursorX.IsUserEnabled = true;
                chart_plot_matrix.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
                chart_plot_matrix.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
                chart_plot_matrix.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
                chart_plot_matrix.ChartAreas[0].BackColor = Color.Transparent;

                chart_plot_matrix.ChartAreas[0].AxisY.Title = Convert.ToString(col1name);

                chart_plot_matrix.ChartAreas[0].AxisX.RoundAxisValues();

                chart_plot_matrix.ChartAreas[0].AxisX.Minimum = this.xmin;
                chart_plot_matrix.ChartAreas[0].AxisX.Maximum = this.xmax;

                chart_plot_matrix.Legends[0].Docking = Docking.Top;
                chart_plot_matrix.Legends[0].Alignment = StringAlignment.Center;

                //chart_plot_matrix.Series[0].Points.DataBindY(firstView, col1name);
                //chart_plot_matrix.Series[0].ChartType = SeriesChartType.Line;



                //Series series1 = new Series(); // line series
                //series1.ChartArea = "ChartArea1";
                //series1.Name = "Series2";
                //this.chart_plot_matrix.Series.Add(series1);
                //chart_plot_matrix.Series[1].ChartArea = "";
                //chart_plot_matrix.Series[1].ChartType = SeriesChartType.Line;
                //chart_plot_matrix.Series[1].Points.DataBindY(firstView, col1name);

                chart_plot_matrix.ChartAreas[0].AxisX.IntervalAutoMode = IntervalAutoMode.VariableCount;
                chart_plot_matrix.ChartAreas[0].AxisY.IntervalAutoMode = IntervalAutoMode.VariableCount;

                chart_plot_matrix.ChartAreas[0].AxisX.LabelStyle.Format = "###.##";
                chart_plot_matrix.ChartAreas[0].AxisY.LabelStyle.Format = "###.##";


                UpdateChartSettings();

                chart_plot_matrix.Series[0].ToolTip = "#VALX, #VALY";

            }
            catch
            {
                MessageBox.Show("This dataseries is empty. Please generate the values first");
            }


        }

        private void UpdateChartSettings()
        {
            chart_plot_matrix.Series[this.seriestoplot].Points.DataBindXY(this.x, this.y);
            chart_plot_matrix.Series[this.seriestoplot].ChartType = SeriesChartType.Line;
            chart_plot_matrix.Series[this.seriestoplot]["PixelPointWidth"] = "1";
            chart_plot_matrix.Series[this.seriestoplot].Color = Color.Black;
            chart_plot_matrix.Series[this.seriestoplot].MarkerStyle = MarkerStyle.Circle;
            chart_plot_matrix.Series[this.seriestoplot].MarkerSize = 0;
            chart_plot_matrix.Series[this.seriestoplot].MarkerColor = Color.White;
            chart_plot_matrix.Series[this.seriestoplot].MarkerBorderColor = Color.Black;
            chart_plot_matrix.Series[this.seriestoplot].MarkerBorderWidth = 1;

            chart_plot_matrix.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart_plot_matrix.ChartAreas[0].AxisY.MajorGrid.Enabled = false;
        }

        private void chart1_Click(object sender, EventArgs e)
        {

        }

        private void Form_plot_Load(object sender, EventArgs e)
        {

        }

        private void comboBox_chart_type_SelectedIndexChanged(object sender, EventArgs e)
        {
            //string plottype;
            //plottype = (string)comboBox_chart_type.SelectedItem;
            ////chart1.Series[0].ChartType = SeriesChartType.Spline;            
            ////MessageBox.Show(plottype.ToString());

            //change_chart_type(plottype);
        }

        private void change_chart_type(string plottype)
        {

            // Set series chart type
            //if (plottype == "Point")
            //{
            //    chart1.Series[0].ChartType = SeriesChartType.Point;
            //    MessageBox.Show(plottype);
            ////}

            //if (plottype == "Line")
            //{
            //    chart1.Series[0].ChartType = SeriesChartType.Line;
            //}

            //if (plottype == "Spline")
            //{
            //    chart1.Series[0].ChartType = SeriesChartType.Spline;
            //}
        }

        private void checkBox_showpoints_CheckedChanged(object sender, EventArgs e)
        {
        //    if (checkBox_showpoints.Checked == true)
        //    {
        //        chart1.Series[0].Enabled = true;
        //        chart1.Series[0].ChartType = SeriesChartType.Point;
        //    }
        //    if (checkBox_showpoints.Checked == false)
        //    {
        //        chart1.Series[0].Enabled = false;
        //    }
        }

        //private void checkBox_showpoints_CheckedChanged_1(object sender, EventArgs e)
        //{

        //}

        //private void checkBox_showline_CheckedChanged(object sender, EventArgs e)
        //{

        //}

        private void ToolStripMenuItem_close_Click(object sender, EventArgs e)
        {
            //Application.Exit();
            this.Close();
        }

        private void ToolStripMenuItem_save_Click(object sender, EventArgs e)
        {
            // Create a new save file dialog
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            // Sets the current file name filter string, which determines 
            // the choices that appear in the "Save as file type" or 
            // "Files of type" box in the dialog box.
            saveFileDialog1.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|SVG (*.svg)|*.svg|GIF (*.gif)|*.gif|TIFF (*.tif)|*.tif";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            // Set image file format
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                ChartImageFormat format = ChartImageFormat.Bmp;

                if (saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ChartImageFormat.Bmp;
                }
                else if (saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ChartImageFormat.Jpeg;
                }
                else if (saveFileDialog1.FileName.EndsWith("emf"))
                {
                    format = ChartImageFormat.Emf;
                }
                else if (saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ChartImageFormat.Gif;
                }
                else if (saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ChartImageFormat.Png;
                }
                else if (saveFileDialog1.FileName.EndsWith("tif"))
                {
                    format = ChartImageFormat.Tiff;
                }
                //else if (saveFileDialog1.FileName.EndsWith("svg"))
                //{
                //    format = ChartImageFormat.Svg;
                //}

                // Save image
                chart_plot_matrix.SaveImage(saveFileDialog1.FileName, format);
            }
        }

        private void ToolStripMenuItem_copy_Click(object sender, EventArgs e)
        {
            // create a memory stream to save the chart image    
            System.IO.MemoryStream stream = new System.IO.MemoryStream();

            // save the chart image to the stream    
            chart_plot_matrix.SaveImage(stream, System.Drawing.Imaging.ImageFormat.Bmp);

            // create a bitmap using the stream    
            Bitmap bmp = new Bitmap(stream);

            // save the bitmap to the clipboard    
            Clipboard.SetDataObject(bmp); 
        }

        private void ToolStripMenuItem_print_Click(object sender, EventArgs e)
        {
            chart_plot_matrix.Printing.Print(true);
        }

        private void ToolStripMenuItem_print_preview_Click(object sender, EventArgs e)
        {
            chart_plot_matrix.Printing.PrintPreview();
        }

        private void viewToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Create a new save file dialog
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            // Sets the current file name filter string, which determines 
            // the choices that appear in the "Save as file type" or 
            // "Files of type" box in the dialog box.
            saveFileDialog1.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|SVG (*.svg)|*.svg|GIF (*.gif)|*.gif|TIFF (*.tif)|*.tif";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            // Set image file format
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                ChartImageFormat format = ChartImageFormat.Bmp;

                if (saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ChartImageFormat.Bmp;
                }
                else if (saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ChartImageFormat.Jpeg;
                }
                else if (saveFileDialog1.FileName.EndsWith("emf"))
                {
                    format = ChartImageFormat.Emf;
                }
                else if (saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ChartImageFormat.Gif;
                }
                else if (saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ChartImageFormat.Png;
                }
                else if (saveFileDialog1.FileName.EndsWith("tif"))
                {
                    format = ChartImageFormat.Tiff;
                }
                //else if (saveFileDialog1.FileName.EndsWith("svg"))
                //{
                //    format = ChartImageFormat.Svg;
                //}

                // Save image
                chart_plot_matrix.SaveImage(saveFileDialog1.FileName, format);
            }
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // create a memory stream to save the chart image    
            System.IO.MemoryStream stream = new System.IO.MemoryStream();

            // save the chart image to the stream    
            chart_plot_matrix.SaveImage(stream, System.Drawing.Imaging.ImageFormat.Bmp);

            // create a bitmap using the stream    
            Bitmap bmp = new Bitmap(stream);

            // save the bitmap to the clipboard    
            Clipboard.SetDataObject(bmp); 
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart_plot_matrix.Printing.PrintPreview();
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart_plot_matrix.Printing.Print(true);
        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //Application.Exit();
            this.Close();
        }

        //private void viewPointsToolStripMenuItem_Click(object sender, EventArgs e)
        //{
        //    viewPointsToolStripMenuItem.Checked = !viewPointsToolStripMenuItem.Checked;
        //    if (viewPointsToolStripMenuItem.Checked == true)
        //    {
        //        chart_plot_matrix.Series[0].ChartArea = "ChartArea1";
        //    }
        //    if (viewPointsToolStripMenuItem.Checked == false)
        //    {
        //        chart_plot_matrix.Series[0].ChartArea = "";
        //    }
        //}

        //private void viewLineToolStripMenuItem_Click(object sender, EventArgs e)
        //{
        //    viewLineToolStripMenuItem.Checked = !viewLineToolStripMenuItem.Checked;
        //    if (viewLineToolStripMenuItem.Checked == true)
        //    {
        //        chart_plot_matrix.Series[1].ChartArea = "ChartArea1";

        //    }
        //    if (viewLineToolStripMenuItem.Checked == false)
        //    {
        //        chart_plot_matrix.Series[1].ChartArea = "";
        //    }
        //}

    }
}
