﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Form_select_series : Form
    {
        private Cdatamaster datamaster;
        private FormToolkit formtoolkit;
        private Form_series_plot form_series_plot;
        private string dataseriesname;
        private string selectedseries;

        public Form_select_series(Cdatamaster datamasterToUse, string dataseriesnameToUse, Form_series_plot form_series_plot_ToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.dataseriesname = dataseriesnameToUse;
            this.formtoolkit = formtoolkitToUse;
            this.form_series_plot = form_series_plot_ToUse;

            // fill in values for the comboboxes
            fill_combobox_with_datatablenames_dataseriesname();
            comboBox_dataseriesname.Text = dataseriesname;
            comboBox_dataseriesname.SelectedText = dataseriesname.ToString();
            fill_combobox_with_datatablenames_seriesnames();
            comboBox_selectseries.Text = dataseriesname;
            comboBox_selectseries.SelectedText = dataseriesname.ToString();

        }

        private void fill_combobox_with_datatablenames_dataseriesname()
        {
            comboBox_dataseriesname.Items.Clear();
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                {
                    comboBox_dataseriesname.Items.Add(dr["SiteID"].ToString());
                }
            }
        }

        private void fill_combobox_with_datatablenames_seriesnames()
        {
            comboBox_selectseries.Items.Clear();

            foreach (DataRow dr in datamaster.Tables["Sites"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["ID"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Interpolation"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Standardize"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CumulativeDeparture"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["Differencing"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["Seriesnameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["CurveFitting"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["Residualsnameout"].ToString());
                    comboBox_selectseries.Items.Add(dr["Curvenameout"].ToString());
                }
            }
            foreach (DataRow dr in datamaster.Tables["SSA_vectors"].Rows)
            {
                if (dr["ID"].ToString() == dataseriesname)
                {
                    comboBox_selectseries.Items.Add(dr["RCnameoutVector"].ToString());
                }
            }

        }

        private void comboBox_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            fill_combobox_with_datatablenames_dataseriesname();
        }

        private void comboBox_selectseries_SelectedIndexChanged(object sender, EventArgs e)
        {
            selectedseries = comboBox_selectseries.Text.ToString();
        }

        public string seriestoadd
        {
            get { return this.selectedseries; }
        }

        private void button_add_series_Click(object sender, EventArgs e)
        {
            form_series_plot.get_addseries_string = seriestoadd;
            
            Close();

        }
    }
}
