﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;

namespace Climate_toolkit
{
    public partial class Form_spectrum_plot : Form
    {
        private Cdatamaster datamaster;
        private string selecteddataseries;
        private string selectedrednoise;
        private string selectedsig90;
        private string selectedsig95;
        private string selectedsig99; 
        private FormToolkit formtoolkit;

        private string selectederror; //for SSA
        private double[,] xdata_error; // for SSA
        private double[] xtemp_error;
        private double[] temp_y_error;
        private double[] error;
        private double[] error_upper;
        private double[] error_lower;


        private int n;// length of the spectrum

        private double[] x; // array for holding x axis values
        private double[] y; // array for holding x axis values
        private double[] temp_y; //array for holding temporary y values

        private double[] x_wavenumber;
        private double[] x_frequency;
        private double[] x_period;

        private double[] x_rednoise_wavenumber;
        private double[] x_rednoise_frequency;
        private double[] x_rednoise_period;

        private double[] x_wavenumber_sig90;
        private double[] x_frequency_sig90;
        private double[] x_period_sig90;

        private double[] x_wavenumber_sig95;
        private double[] x_frequency_sig95;
        private double[] x_period_sig95;

        private double[] x_wavenumber_sig99;
        private double[] x_frequency_sig99;
        private double[] x_period_sig99;

        private double[] y_wavenumber;
        private double[] y_frequency;
        private double[] y_period;

        private double[] y_rednoise_wavenumber;
        private double[] y_rednoise_frequency;
        private double[] y_rednoise_period;

        private double[] y_wavenumber_sig90;
        private double[] y_frequency_sig90;
        private double[] y_period_sig90;

        private double[] y_wavenumber_sig95;
        private double[] y_frequency_sig95;
        private double[] y_period_sig95;

        private double[] y_wavenumber_sig99;
        private double[] y_frequency_sig99;
        private double[] y_period_sig99;

        private double[] error_wavenumber;
        private double[] error_frequency;
        private double[] error_period;

        private double[] error_lower_period;
        private double[] error_upper_period;
        private double[] error_lower_frequency;
        private double[] error_upper_frequency;
        private double[] error_lower_wavenumber;
        private double[] error_upper_wavenumber;


        private double[,] xdata; //array for holding wavenumber, period, and frequency data
        private double[,] xdata_rednoise; // array for holding red noise wavenumber, period, and frequency data
        private double[] xtemp;
        private double[] xtemp_rednoise;

        private double[] x_rednoise;
        private double[] y_rednoise;
        private double[] temp_y_rednoise;

        private double[] x_sig90;
        private double[] y_sig90;
        private double[] temp_y_sig90;

        private double[] x_sig95;
        private double[] y_sig95;
        private double[] temp_y_sig95;

        private double[] x_sig99;
        private double[] y_sig99;
        private double[] temp_y_sig99;

        private double xmin;
        private double xmax;

        private bool fourier;
        private bool SSA;
        private bool MEM;

        private bool wavenumber = true;
        private bool frequency = false;
        private bool period = false;

        Series series = new Series();
        Series errorBarSeries = new Series("ErrorBar");

        Series errorBarSeries_wavenumber = new Series("ErrorBar_wavenumber");
        Series errorBarSeries_frequency = new Series("ErrorBar_frequency");
        Series errorBarSeries_period = new Series("ErrorBar_period");

        Series series_wavenumber = new Series("wavenumber");
        Series series_period = new Series("period");
        Series series_frequency = new Series("frequency");

        Series series_rednoise_wavenumber = new Series("rednoise_wavenumber");
        Series series_rednoise_period = new Series("rednoise_period");
        Series series_rednoise_frequency = new Series("rednoise_frequency");

        Series series_sig90_wavenumber = new Series("sig90_wavenumber");
        Series series_sig90_period = new Series("sig90_period");
        Series series_sig90_frequency = new Series("sig90_frequency");

        Series series_sig95_wavenumber = new Series("sig95_wavenumber");
        Series series_sig95_period = new Series("sig95_period");
        Series series_sig95_frequency = new Series("sig95_frequency");

        Series series_sig99_wavenumber = new Series("sig99_wavenumber");
        Series series_sig99_period = new Series("sig99_period");
        Series series_sig99_frequency = new Series("sig99_frequency");


        public Form_spectrum_plot(Cdatamaster datamasterToUse, string selecteddataseriesToUse, string selectederrorToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries = selecteddataseriesToUse;
            this.selectederror = selectederrorToUse;
            this.formtoolkit = formtoolkitToUse;

            this.fourier = false;
            this.SSA = true;
            this.MEM = false;

            Text = selecteddataseries;

            showSigTestToolStripMenuItem.Enabled = false;

            // assign wavenumber, period, and frequency data into an array

            this.xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
            this.n = xtemp.Length;

            this.x_wavenumber = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
            this.x_period = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 1); // col 1 is period
            this.x_frequency = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 2); // col 2 is frequency

            this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power
            this.y_wavenumber = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            double[] ytemp_frequency = new double[x_frequency.Length];
            double[] ytemp_period = new double[x_period.Length];

            this.y_frequency = new double[x_frequency.Length];
            this.y_period = new double[x_period.Length];

            ytemp_frequency = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power
            ytemp_period = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            this.error_wavenumber = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectederror, 3);
            
            
            this.error_period = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectederror, 3);
            this.error_frequency = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectederror, 3);

            this.error_lower_wavenumber = new double[x_wavenumber.Length];
            this.error_upper_wavenumber = new double[x_wavenumber.Length];

            this.error_lower_period = new double[x_wavenumber.Length];
            this.error_upper_period = new double[x_wavenumber.Length];

            this.error_lower_frequency = new double[x_wavenumber.Length];
            this.error_upper_frequency = new double[x_wavenumber.Length]; 


            if (SSA == true)
            {
                for (int i = 0; i < x_wavenumber.Length; i++)
                {
                    error_lower_wavenumber[i] = y_wavenumber[i] - error_wavenumber[i];
                    error_upper_wavenumber[i] = y_wavenumber[i] + error_wavenumber[i];
                }
            }

            double[] xtemp_frequency = new double[x_frequency.Length];
            double[] xtemp_period = new double[x_period.Length];

            for (int i = 0; i < x_wavenumber.Length; i++)
            {
                xtemp_frequency[i] = x_frequency[i];
                xtemp_period[i] = x_period[i];
            }
            int[] xindex = new int[x_wavenumber.Length];
            for (int i = 0; i < x_wavenumber.Length; i++)
            {
                if (i == 0)
                {
                    xindex[i] = 0;
                }
                else
                {
                    xindex[i] = xindex[i - 1] + 1;
                }
            }
            Array.Sort(xtemp_frequency, xindex);
            Array.Sort(xtemp_period);
            Array.Reverse(xtemp_period);

            x_frequency = xtemp_frequency;
            x_period = xtemp_period;

            for (int i = 0; i < this.x_wavenumber.Length; i++)
            {
                this.y_frequency[i] = ytemp_frequency[xindex[i]];
                this.y_period[i] = ytemp_period[xindex[i]];

                this.error_lower_period[i] = this.error_lower_wavenumber[xindex[i]];
                this.error_upper_period[i] = error_upper_wavenumber[xindex[i]];
                this.error_lower_frequency[i] = error_lower_wavenumber[xindex[i]];
                this.error_upper_frequency[i] = error_upper_wavenumber[xindex[i]];
            }

            series_wavenumber.Points.DataBindXY(this.x_wavenumber, this.y_wavenumber);
            series_period.Points.DataBindXY(this.x_period, this.y_period);
            series_frequency.Points.DataBindXY(this.x_frequency, this.y_frequency);

            errorBarSeries_wavenumber.ChartType = SeriesChartType.ErrorBar;
            errorBarSeries_wavenumber.MarkerSize = 6;
            errorBarSeries_wavenumber.YValuesPerPoint = 3;
            errorBarSeries_wavenumber.Color = Color.Black;
            errorBarSeries_wavenumber.MarkerStyle = MarkerStyle.None;
            errorBarSeries_wavenumber["PointWidth"] = ".7";

            errorBarSeries_period.ChartType = SeriesChartType.ErrorBar;
            errorBarSeries_period.MarkerSize = 6;
            errorBarSeries_period.YValuesPerPoint = 3;
            errorBarSeries_period.Color = Color.Black;
            errorBarSeries_period.MarkerStyle = MarkerStyle.None;
            errorBarSeries_period["PointWidth"] = ".7";

            errorBarSeries_frequency.ChartType = SeriesChartType.ErrorBar;
            errorBarSeries_frequency.MarkerSize = 6;
            errorBarSeries_frequency.YValuesPerPoint = 3;
            errorBarSeries_frequency.Color = Color.Black;
            errorBarSeries_frequency.MarkerStyle = MarkerStyle.None;
            errorBarSeries_frequency["PointWidth"] = ".7";

            for (int i = 0; i < x_wavenumber.Length; i++)
            {
                error_frequency[i] = error_wavenumber[xindex[i]];
                error_period[i] = error_wavenumber[xindex[i]];

                error_frequency[i] = error_wavenumber[xindex[i]];
                error_period[i] = error_wavenumber[xindex[i]];

                errorBarSeries_wavenumber.Points.AddXY(this.x_wavenumber[i], this.y_wavenumber[i], this.error_lower_wavenumber[i], this.error_upper_wavenumber[i]);
                errorBarSeries_period.Points.AddXY(this.x_period[i], this.y_period[i], this.error_lower_period[i], this.error_upper_period[i]);
                errorBarSeries_frequency.Points.AddXY(this.x_frequency[i],this.y_frequency[i], this.error_lower_frequency[i], this.error_upper_frequency[i]);

            }



            chart_spectrum_plot.Series.Add(series_wavenumber);
            chart_spectrum_plot.Series.Add(series_period);
            chart_spectrum_plot.Series.Add(series_frequency);

            chart_spectrum_plot.Series.Add(errorBarSeries_wavenumber);
            chart_spectrum_plot.Series.Add(errorBarSeries_period);
            chart_spectrum_plot.Series.Add(errorBarSeries_frequency);

            errorBarSeries_wavenumber.ChartType = SeriesChartType.ErrorBar;
            errorBarSeries_wavenumber.MarkerSize = 6;
            errorBarSeries_wavenumber.YValuesPerPoint = 3;
            errorBarSeries_wavenumber.Color = Color.Black;
            errorBarSeries_wavenumber.MarkerStyle = MarkerStyle.None;
            errorBarSeries_wavenumber["PointWidth"] = ".7";

            errorBarSeries_period.ChartType = SeriesChartType.ErrorBar;
            errorBarSeries_period.MarkerSize = 6;
            errorBarSeries_period.YValuesPerPoint = 3;
            errorBarSeries_period.Color = Color.Black;
            errorBarSeries_period.MarkerStyle = MarkerStyle.None;
            errorBarSeries_period["PointWidth"] = ".7";

            errorBarSeries_frequency.ChartType = SeriesChartType.ErrorBar;
            errorBarSeries_frequency.MarkerSize = 6;
            errorBarSeries_frequency.YValuesPerPoint = 3;
            errorBarSeries_frequency.Color = Color.Black;
            errorBarSeries_frequency.MarkerStyle = MarkerStyle.None;
            errorBarSeries_frequency["PointWidth"] = ".7";

            //chart_spectrum_plot.Series[this.series_wavenumber].Points.DataBindXY(this.x, this.y);
            series_wavenumber.ChartType = SeriesChartType.Line;
            series_wavenumber["PixelPointWidth"] = "1";
            series_wavenumber.Color = Color.Black;
            series_wavenumber.MarkerStyle = MarkerStyle.Circle;
            series_wavenumber.MarkerSize = 5;
            series_wavenumber.MarkerColor = Color.White;
            series_wavenumber.MarkerBorderColor = Color.Black;
            series_wavenumber.MarkerBorderWidth = 1;

            series_period.ChartType = SeriesChartType.Line;
            series_period["PixelPointWidth"] = "1";
            series_period.Color = Color.Black;
            series_period.MarkerStyle = MarkerStyle.Circle;
            series_period.MarkerSize = 5;
            series_period.MarkerColor = Color.White;
            series_period.MarkerBorderColor = Color.Black;
            series_period.MarkerBorderWidth = 1;

            series_frequency.ChartType = SeriesChartType.Line;
            series_frequency["PixelPointWidth"] = "1";
            series_frequency.Color = Color.Black;
            series_frequency.MarkerStyle = MarkerStyle.Circle;
            series_frequency.MarkerSize = 5;
            series_frequency.MarkerColor = Color.White;
            series_frequency.MarkerBorderColor = Color.Black;
            series_frequency.MarkerBorderWidth = 1;

            this.xmin = this.x_wavenumber.Min();
            this.xmax = this.x_wavenumber.Max();

            // set up default plotting options           
            waveNumberToolStripMenuItem.Checked = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Component Number";

            // set up default series to enable
            redNoiseNullHypothesisToolStripMenuItem.Enabled = false;
            significance90ToolStripMenuItem.Enabled = false;
            significance95ToolStripMenuItem.Enabled = false;
            significance99ToolStripMenuItem.Enabled = false;

            xaxisLinearToolStripMenuItem.Checked = true;
            yaxisLinearToolStripMenuItem.Checked = true;

            chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();

            chart_spectrum_plot.Legends[0].Docking = Docking.Top;
            chart_spectrum_plot.Legends[0].Alignment = StringAlignment.Center;
            chart_spectrum_plot.Legends[0].Font = new Font("Microsoft Sans Serif", 12);

            chart_spectrum_plot.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart_spectrum_plot.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

            chart_spectrum_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart_spectrum_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart_spectrum_plot.ChartAreas[0].BackColor = Color.Transparent;

            chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0;// this.xmin;
            chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = this.xmax;

            chart_spectrum_plot.ChartAreas[0].AxisX.LabelStyle.Format = "###.##";
            chart_spectrum_plot.ChartAreas[0].AxisY.LabelStyle.Format = "###.###";

            UpdateChartSettings();

            chart_spectrum_plot.Series[0].ToolTip = "#VALX, #VALY";
            chart_spectrum_plot.Series[1].ToolTip = "#VALX, #VALY";

        }


        public Form_spectrum_plot(Cdatamaster datamasterToUse, string selecteddataseriesToUse, string selectedrednoiseToUse, string selectedsig90ToUse, string selectedsig95ToUse, string selectedsig99ToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries = selecteddataseriesToUse;
            this.selectedrednoise = selectedrednoiseToUse;
            this.selectedsig90 = selectedsig90ToUse;
            this.selectedsig95 = selectedsig95ToUse;
            this.selectedsig99 = selectedsig99ToUse; 
            this.formtoolkit = formtoolkitToUse;

            this.SSA = false;
            this.fourier = true;
            this.MEM = false;

            Text = selecteddataseries;

            showSigTestToolStripMenuItem.Enabled = true;
            // assign wavenumber, period, and frequency data into an array

            //this.xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
            this.x_wavenumber = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
            this.x_period = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 1); // col 1 is period
            this.x_frequency = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 2); // col 2 is frequency
            this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            this.x_rednoise_wavenumber = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 0);
            this.x_rednoise_period = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 1);
            this.x_rednoise_frequency = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 2);
            this.y_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 3);

            this.x_wavenumber_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 0);
            this.x_period_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 1);
            this.x_frequency_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 2);
            this.y_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 3);

            this.x_wavenumber_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 0);
            this.x_period_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 1);
            this.x_frequency_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 2);
            this.y_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 3);

            this.x_wavenumber_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 0);
            this.x_period_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 1);
            this.x_frequency_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 2);
            this.y_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 3);
            //series_wavenumber.Points.DataBindXY(this.x_wavenumber, this.y);
            //series_period.Points.DataBindXY(this.x_period, this.y);
            //series_frequency.Points.DataBindXY(this.x_frequency, this.y);


            //this.n = xtemp.Length;

            //xdata = new double[3, n]; // hold wavenumber, period, and frequency data
            //xdata_rednoise = new double[3, n];
            //this.x = new double[n];
            
            //// assign data to series
            //for (int j = 0; j < 3; j++)
            //{
            //    this.xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, j); // col 0 is wavenumber
            //    this.xtemp_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, j); // col 0 is wavenumber

            //    for (int i = 0; i < xtemp.Length; i++)
            //    {
            //        xdata[j, i] = xtemp[i];
            //        xdata_rednoise[j, i] = xtemp_rednoise[i];
            //    }
            //}

            //this.series = chart_spectrum_plot.Series.Add(this.selecteddataseries);
            ////this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber, col 1 is period, col 2 is frequency
            //for (int i = 0; i < n; i++)
            //{
            //    this.x[i] = xdata[0, i];
            //}
            //this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            ////this.series = chart_spectrum_plot.Series.Add(this.selectedrednoise);
            //this.x_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoiseToUse, 0);
            //this.y_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoiseToUse, 3);

            ////this.series = chart_spectrum_plot.Series.Add(this.selectedsig90);
            //this.x_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90ToUse, 0);
            //this.y_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90ToUse, 3);

            ////this.series = chart_spectrum_plot.Series.Add(this.selectedsig95);
            //this.x_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95ToUse, 0);
            //this.y_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95ToUse, 3);

            ////this.series = chart_spectrum_plot.Series.Add(this.selectedsig99);
            //this.x_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99ToUse, 0);
            //this.y_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99ToUse, 3);
            
            // spectrum
            series_wavenumber.Points.DataBindXY(this.x_wavenumber, this.y);
            series_period.Points.DataBindXY(this.x_period, this.y);
            series_frequency.Points.DataBindXY(this.x_frequency, this.y);

            series_wavenumber.ChartType = SeriesChartType.Line;
            series_wavenumber["PixelPointWidth"] = "1";
            series_wavenumber.Color = Color.Black;
            series_wavenumber.MarkerStyle = MarkerStyle.Circle;
            series_wavenumber.MarkerSize = 5;
            series_wavenumber.MarkerColor = Color.White;
            series_wavenumber.MarkerBorderColor = Color.Black;
            series_wavenumber.MarkerBorderWidth = 1;

            series_period.ChartType = SeriesChartType.Line;
            series_period["PixelPointWidth"] = "1";
            series_period.Color = Color.Black;
            series_period.MarkerStyle = MarkerStyle.Circle;
            series_period.MarkerSize = 5;
            series_period.MarkerColor = Color.White;
            series_period.MarkerBorderColor = Color.Black;
            series_period.MarkerBorderWidth = 1;

            series_frequency.ChartType = SeriesChartType.Line;
            series_frequency["PixelPointWidth"] = "1";
            series_frequency.Color = Color.Black;
            series_frequency.MarkerStyle = MarkerStyle.Circle;
            series_frequency.MarkerSize = 5;
            series_frequency.MarkerColor = Color.White;
            series_frequency.MarkerBorderColor = Color.Black;
            series_frequency.MarkerBorderWidth = 1;

            // red noise
            series_rednoise_wavenumber.Points.DataBindXY(this.x_rednoise_wavenumber, this.y_rednoise);
            series_rednoise_period.Points.DataBindXY(this.x_rednoise_period, this.y_rednoise);
            series_rednoise_frequency.Points.DataBindXY(this.x_rednoise_frequency, this.y_rednoise);

            series_rednoise_wavenumber.ChartType = SeriesChartType.Line;
            series_rednoise_wavenumber.Color = Color.Red;

            series_rednoise_period.ChartType = SeriesChartType.Line;
            series_rednoise_period.Color = Color.Red;

            series_rednoise_frequency.ChartType = SeriesChartType.Line;
            series_rednoise_frequency.Color = Color.Red;

            //sig 90

            series_sig90_wavenumber.Points.DataBindXY(this.x_wavenumber_sig90, this.y_sig90);
            series_sig90_period.Points.DataBindXY(this.x_period_sig90, this.y_sig90);
            series_sig90_frequency.Points.DataBindXY(this.x_frequency_sig90, this.y_sig90);

            //series_sig90_wavenumber.Points.DataBindXY(this.x, this.y_sig90);
            series_sig90_wavenumber.ChartType = SeriesChartType.Line;
            series_sig90_wavenumber.Color = Color.LightBlue;
            series_sig90_wavenumber.BorderDashStyle = ChartDashStyle.DashDot;

            //series_sig90_period.Points.DataBindXY(this.x, this.y_sig90);
            series_sig90_period.ChartType = SeriesChartType.Line;
            series_sig90_period.Color = Color.LightBlue;
            series_sig90_period.BorderDashStyle = ChartDashStyle.DashDot;

            //series_sig90_frequency.Points.DataBindXY(this.x, this.y_sig90);
            series_sig90_frequency.ChartType = SeriesChartType.Line;
            series_sig90_frequency.Color = Color.LightBlue;
            series_sig90_frequency.BorderDashStyle = ChartDashStyle.DashDot;

            //sig 95

            series_sig95_wavenumber.Points.DataBindXY(this.x_wavenumber_sig95, this.y_sig95);
            series_sig95_period.Points.DataBindXY(this.x_period_sig95, this.y_sig95);
            series_sig95_frequency.Points.DataBindXY(this.x_frequency_sig95, this.y_sig95);

            //series_sig95_wavenumber.Points.DataBindXY(this.x, this.y_sig95);
            series_sig95_wavenumber.ChartType = SeriesChartType.Line;
            series_sig95_wavenumber.Color = Color.Blue;
            series_sig95_wavenumber.BorderDashStyle = ChartDashStyle.Dash;

            //series_sig95_period.Points.DataBindXY(this.x, this.y_sig95);
            series_sig95_period.ChartType = SeriesChartType.Line;
            series_sig95_period.Color = Color.Blue;
            series_sig95_period.BorderDashStyle = ChartDashStyle.Dash;

            //series_sig95_frequency.Points.DataBindXY(this.x, this.y_sig95);
            series_sig95_frequency.ChartType = SeriesChartType.Line;
            series_sig95_frequency.Color = Color.Blue;
            series_sig95_frequency.BorderDashStyle = ChartDashStyle.Dash;

            //sig99

            series_sig99_wavenumber.Points.DataBindXY(this.x_wavenumber_sig99, this.y_sig99);
            series_sig99_period.Points.DataBindXY(this.x_period_sig99, this.y_sig99);
            series_sig99_frequency.Points.DataBindXY(this.x_frequency_sig99, this.y_sig99);

            //series_sig99_wavenumber.Points.DataBindXY(this.x, this.y_sig99);
            series_sig99_wavenumber.ChartType = SeriesChartType.Line;
            series_sig99_wavenumber.Color = Color.DarkBlue;
            series_sig99_wavenumber.BorderDashStyle = ChartDashStyle.DashDotDot;

            //series_sig99_period.Points.DataBindXY(this.x, this.y_sig99);
            series_sig99_period.ChartType = SeriesChartType.Line;
            series_sig99_period.Color = Color.DarkBlue;
            series_sig99_period.BorderDashStyle = ChartDashStyle.DashDotDot;

            //series_sig99_frequency.Points.DataBindXY(this.x, this.y_sig99);
            series_sig99_frequency.ChartType = SeriesChartType.Line;
            series_sig99_frequency.Color = Color.DarkBlue;
            series_sig99_frequency.BorderDashStyle = ChartDashStyle.DashDotDot;

            chart_spectrum_plot.Series.Add(series_wavenumber);
            chart_spectrum_plot.Series.Add(series_period);
            chart_spectrum_plot.Series.Add(series_frequency);

            chart_spectrum_plot.Series.Add(series_rednoise_wavenumber);
            chart_spectrum_plot.Series.Add(series_rednoise_period);
            chart_spectrum_plot.Series.Add(series_rednoise_frequency);

            chart_spectrum_plot.Series.Add(series_sig90_wavenumber);
            chart_spectrum_plot.Series.Add(series_sig90_period);
            chart_spectrum_plot.Series.Add(series_sig90_frequency);

            chart_spectrum_plot.Series.Add(series_sig95_wavenumber);
            chart_spectrum_plot.Series.Add(series_sig95_period);
            chart_spectrum_plot.Series.Add(series_sig95_frequency);

            chart_spectrum_plot.Series.Add(series_sig99_wavenumber);
            chart_spectrum_plot.Series.Add(series_sig99_period);
            chart_spectrum_plot.Series.Add(series_sig99_frequency);

            this.xmin = this.x_wavenumber.Min();
            this.xmax = this.x_wavenumber.Max();
           
            // set up default plotting options           
            waveNumberToolStripMenuItem.Checked = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Wave Number";

            // set up default series to enable
            redNoiseNullHypothesisToolStripMenuItem.Checked = true;
            significance90ToolStripMenuItem.Checked = false;
            significance95ToolStripMenuItem.Checked = true;
            significance99ToolStripMenuItem.Checked = false;

            xaxisLinearToolStripMenuItem.Checked = true;
            yaxisLinearToolStripMenuItem.Checked = true;

            chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();

            chart_spectrum_plot.Legends[0].Docking = Docking.Top;
            chart_spectrum_plot.Legends[0].Alignment = StringAlignment.Center;
            chart_spectrum_plot.Legends[0].Font = new Font("Microsoft Sans Serif", 12);

            chart_spectrum_plot.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart_spectrum_plot.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

            chart_spectrum_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart_spectrum_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart_spectrum_plot.ChartAreas[0].BackColor = Color.Transparent;

            chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = this.xmin;
            chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = this.xmax;

            chart_spectrum_plot.ChartAreas[0].AxisX.IntervalAutoMode = IntervalAutoMode.VariableCount;
            chart_spectrum_plot.ChartAreas[0].AxisY.IntervalAutoMode = IntervalAutoMode.VariableCount;

            chart_spectrum_plot.ChartAreas[0].AxisX.LabelStyle.Format = "###.##";
            chart_spectrum_plot.ChartAreas[0].AxisY.LabelStyle.Format = "###.###";

            
            UpdateChartSettings();

            chart_spectrum_plot.Series[0].ToolTip = "#VALX, #VALY";
            chart_spectrum_plot.Series[1].ToolTip = "#VALX, #VALY";
            chart_spectrum_plot.Series[2].ToolTip = "#VALX, #VALY";
            chart_spectrum_plot.Series[3].ToolTip = "#VALX, #VALY";
            chart_spectrum_plot.Series[4].ToolTip = "#VALX, #VALY";

        }

        public Form_spectrum_plot(Cdatamaster datamasterToUse, string selecteddataseriesToUse, FormToolkit formtoolkitToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries = selecteddataseriesToUse;
            this.formtoolkit = formtoolkitToUse;

            this.SSA = false;
            this.fourier = false;
            this.MEM = true;

            Text = selecteddataseries;

            showSigTestToolStripMenuItem.Enabled = true;

            this.x_wavenumber = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
            this.x_period = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 1); // col 1 is period
            this.x_frequency = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 2); // col 2 is frequency
            this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            // spectrum
            series_wavenumber.Points.DataBindXY(this.x_wavenumber, this.y);
            series_period.Points.DataBindXY(this.x_period, this.y);
            series_frequency.Points.DataBindXY(this.x_frequency, this.y);

            series_wavenumber.ChartType = SeriesChartType.Line;
            series_wavenumber["PixelPointWidth"] = "1";
            series_wavenumber.Color = Color.Black;
            series_wavenumber.MarkerStyle = MarkerStyle.Circle;
            series_wavenumber.MarkerSize = 5;
            series_wavenumber.MarkerColor = Color.White;
            series_wavenumber.MarkerBorderColor = Color.Black;
            series_wavenumber.MarkerBorderWidth = 1;

            series_period.ChartType = SeriesChartType.Line;
            series_period["PixelPointWidth"] = "1";
            series_period.Color = Color.Black;
            series_period.MarkerStyle = MarkerStyle.Circle;
            series_period.MarkerSize = 5;
            series_period.MarkerColor = Color.White;
            series_period.MarkerBorderColor = Color.Black;
            series_period.MarkerBorderWidth = 1;

            series_frequency.ChartType = SeriesChartType.Line;
            series_frequency["PixelPointWidth"] = "1";
            series_frequency.Color = Color.Black;
            series_frequency.MarkerStyle = MarkerStyle.Circle;
            series_frequency.MarkerSize = 5;
            series_frequency.MarkerColor = Color.White;
            series_frequency.MarkerBorderColor = Color.Black;
            series_frequency.MarkerBorderWidth = 1;

            chart_spectrum_plot.Series.Add(series_wavenumber);
            chart_spectrum_plot.Series.Add(series_period);
            chart_spectrum_plot.Series.Add(series_frequency);

            // assign wavenumber, period, and frequency data into an array

            //this.xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
            //this.n = xtemp.Length;

            //xdata = new double[3, n]; // hold wavenumber, period, and frequency data
            //this.x = new double[n];

            //// assign data to series
            //for (int j = 0; j < 3; j++)
            //{
            //    this.xtemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, j); // col 0 is wavenumber
            //    for (int i = 0; i < xtemp.Length; i++)
            //    {
            //        xdata[j, i] = xtemp[i];
            //    }
            //}

            //this.series = chart_spectrum_plot.Series.Add(this.selecteddataseries);
            //this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber, col 1 is period, col 2 is frequency
            //for (int i = 0; i < n; i++)
            //{
            //    this.x[i] = xdata[0, i];
            //}
            //this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3); // col 3 is power

            this.xmin = this.x_wavenumber.Min();
            this.xmax = this.x_wavenumber.Max();

            // set up default plotting options           
            waveNumberToolStripMenuItem.Checked = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Component";

            // since there's no significance test, disable some options
            showSigTestToolStripMenuItem.Enabled = false;
            redNoiseNullHypothesisToolStripMenuItem.Enabled = false;
            significance90ToolStripMenuItem.Enabled = false;
            significance95ToolStripMenuItem.Enabled = false;
            significance99ToolStripMenuItem.Enabled = false;

            xaxisLinearToolStripMenuItem.Checked = true;
            yaxisLinearToolStripMenuItem.Checked = true;

            chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();

            chart_spectrum_plot.Legends[0].Docking = Docking.Top;
            chart_spectrum_plot.Legends[0].Alignment = StringAlignment.Center;
            chart_spectrum_plot.Legends[0].Font = new Font("Microsoft Sans Serif", 12);

            chart_spectrum_plot.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
            chart_spectrum_plot.ChartAreas[0].AxisY.MajorGrid.Enabled = false;

            chart_spectrum_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
            chart_spectrum_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
            chart_spectrum_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
            chart_spectrum_plot.ChartAreas[0].BackColor = Color.Transparent;

            //chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = this.xmin;
            //chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = this.xmax;

            chart_spectrum_plot.ChartAreas[0].AxisX.LabelStyle.Format = "###.##";
            chart_spectrum_plot.ChartAreas[0].AxisY.LabelStyle.Format = "###.###";

            chart_spectrum_plot.ChartAreas[0].AxisX.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart_spectrum_plot.ChartAreas[0].AxisY.LabelStyle.Font = new Font("Microsoft Sans Serif", 12);
            chart_spectrum_plot.ChartAreas[0].AxisX.TitleFont = new Font("Microsoft Sans Serif", 12);
            chart_spectrum_plot.ChartAreas[0].AxisY.TitleFont = new Font("Microsoft Sans Serif", 12);

            UpdateChartSettings();

            chart_spectrum_plot.Series[0].ToolTip = "#VALX, #VALY";

        }

        private void UpdateChartSettings()
        {
            try
            {
                if (SSA == true)
                {
                    if (wavenumber)
                    {
                        this.series_wavenumber.Enabled = true;
                        this.errorBarSeries_wavenumber.Enabled = true;

                        this.series_period.Enabled = false;
                        this.errorBarSeries_period.Enabled = false;

                        this.series_frequency.Enabled = false;
                        this.errorBarSeries_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        this.series_wavenumber.Enabled = false;
                        this.errorBarSeries_wavenumber.Enabled = false;

                        this.series_period.Enabled = true;
                        this.errorBarSeries_period.Enabled = true;

                        this.series_frequency.Enabled = false;
                        this.errorBarSeries_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        this.series_wavenumber.Enabled = false;
                        this.errorBarSeries_wavenumber.Enabled = false;

                        this.series_period.Enabled = false;
                        this.errorBarSeries_period.Enabled = false;

                        this.series_frequency.Enabled = true;
                        this.errorBarSeries_frequency.Enabled = true;
                    }

                }

                if (fourier == true)
                {
                    if (wavenumber)
                    {
                        this.series_wavenumber.Enabled = true;
                        this.series_period.Enabled = false;
                        this.series_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        this.series_wavenumber.Enabled = false;
                        this.series_period.Enabled = true;
                        this.series_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        this.series_wavenumber.Enabled = false;
                        this.series_period.Enabled = false;
                        this.series_frequency.Enabled = true;
                    }

                    if (fourier == true)
                    {
                        //chart_spectrum_plot.Series[this.selectedrednoise].Points.DataBindXY(this.x_rednoise, this.y_rednoise);
                        //chart_spectrum_plot.Series[this.selectedrednoise].ChartType = SeriesChartType.Line;
                        //chart_spectrum_plot.Series[this.selectedrednoise].Color = Color.Red;

                        //chart_spectrum_plot.Series[this.selectedsig90].Points.DataBindXY(this.x, this.y_sig90);
                        //chart_spectrum_plot.Series[this.selectedsig90].ChartType = SeriesChartType.Line;
                        //chart_spectrum_plot.Series[this.selectedsig90].Color = Color.Gray;
                        //chart_spectrum_plot.Series[this.selectedsig90].BorderDashStyle = ChartDashStyle.DashDot;

                        //chart_spectrum_plot.Series[this.selectedsig95].Points.DataBindXY(this.x, this.y_sig95);
                        //chart_spectrum_plot.Series[this.selectedsig95].ChartType = SeriesChartType.Line;
                        //chart_spectrum_plot.Series[this.selectedsig95].Color = Color.Gray;
                        //chart_spectrum_plot.Series[this.selectedsig95].BorderDashStyle = ChartDashStyle.Dash;

                        //chart_spectrum_plot.Series[this.selectedsig99].Points.DataBindXY(this.x, this.y_sig99);
                        //chart_spectrum_plot.Series[this.selectedsig99].ChartType = SeriesChartType.Line;
                        //chart_spectrum_plot.Series[this.selectedsig99].Color = Color.Gray;
                        //chart_spectrum_plot.Series[this.selectedsig99].BorderDashStyle = ChartDashStyle.DashDotDot;
                    }


                    // Enable range selection and zooming end user interface
                    chart_spectrum_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
                    chart_spectrum_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
                    chart_spectrum_plot.ChartAreas[0].BackColor = Color.Transparent;

                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0;
                    //chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = this.xmax;

                    //chart_spectrum_plot.ChartAreas[0].AxisX.Interval = 0.05;
                    //chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();

                }
                if (MEM)
                {
                    if (wavenumber)
                    {
                        this.series_wavenumber.Enabled = true;
                        this.series_period.Enabled = false;
                        this.series_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        this.series_wavenumber.Enabled = false;
                        this.series_period.Enabled = true;
                        this.series_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        this.series_wavenumber.Enabled = false;
                        this.series_period.Enabled = false;
                        this.series_frequency.Enabled = true;
                    }

                    // Enable range selection and zooming end user interface
                    chart_spectrum_plot.ChartAreas[0].CursorX.IsUserEnabled = true;
                    chart_spectrum_plot.ChartAreas[0].CursorX.IsUserSelectionEnabled = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.ScaleView.Zoomable = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.ScrollBar.IsPositionedInside = true;
                    chart_spectrum_plot.ChartAreas[0].BackColor = Color.Transparent;

                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0;
                }
            }
            catch
            {
            }

            if (fourier == true)
            {
                if (redNoiseNullHypothesisToolStripMenuItem.Checked == true)
                {
                    if (wavenumber)
                    {
                        series_rednoise_wavenumber.Enabled = true;
                        series_rednoise_period.Enabled = false;
                        series_rednoise_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_rednoise_wavenumber.Enabled = false;
                        series_rednoise_period.Enabled = true;
                        series_rednoise_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_rednoise_wavenumber.Enabled = false;
                        series_rednoise_period.Enabled = false;
                        series_rednoise_frequency.Enabled = true;
                    }
                    //chart_spectrum_plot.Series[this.selectedrednoise].Enabled = true;
                }
                if (redNoiseNullHypothesisToolStripMenuItem.Checked == false)
                {
                    if (wavenumber)
                    {
                        series_rednoise_wavenumber.Enabled = false;
                        series_rednoise_period.Enabled = false;
                        series_rednoise_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_rednoise_wavenumber.Enabled = false;
                        series_rednoise_period.Enabled = false;
                        series_rednoise_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_rednoise_wavenumber.Enabled = false;
                        series_rednoise_period.Enabled = false;
                        series_rednoise_frequency.Enabled = false;
                    }
                    
                    //chart_spectrum_plot.Series[this.selectedrednoise].Enabled = false;
                }

                if (significance90ToolStripMenuItem.Checked == true)
                {
                    if (wavenumber)
                    {
                        series_sig90_wavenumber.Enabled = true;
                        series_sig90_period.Enabled = false;
                        series_sig90_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_sig90_wavenumber.Enabled = false;
                        series_sig90_period.Enabled = true;
                        series_sig90_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_sig90_wavenumber.Enabled = false;
                        series_sig90_period.Enabled = false;
                        series_sig90_frequency.Enabled = true;
                    }
                    
                    //chart_spectrum_plot.Series[this.selectedsig90].Enabled = true;
                }
                if (significance90ToolStripMenuItem.Checked == false)
                {
                    if (wavenumber)
                    {
                        series_sig90_wavenumber.Enabled = false;
                        series_sig90_period.Enabled = false;
                        series_sig90_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_sig90_wavenumber.Enabled = false;
                        series_sig90_period.Enabled = false;
                        series_sig90_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_sig90_wavenumber.Enabled = false;
                        series_sig90_period.Enabled = false;
                        series_sig90_frequency.Enabled = false;
                    }
                    
                    //chart_spectrum_plot.Series[this.selectedsig90].Enabled = false;
                }


                if (significance95ToolStripMenuItem.Checked == true)
                {
                    if (wavenumber)
                    {
                        series_sig95_wavenumber.Enabled = true;
                        series_sig95_period.Enabled = false;
                        series_sig95_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_sig95_wavenumber.Enabled = false;
                        series_sig95_period.Enabled = true;
                        series_sig95_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_sig95_wavenumber.Enabled = false;
                        series_sig95_period.Enabled = false;
                        series_sig95_frequency.Enabled = true;
                    }
                    
                    //chart_spectrum_plot.Series[this.selectedsig95].Enabled = true;
                }
                if (significance95ToolStripMenuItem.Checked == false)
                {
                    if (wavenumber)
                    {
                        series_sig95_wavenumber.Enabled = false;
                        series_sig95_period.Enabled = false;
                        series_sig95_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_sig95_wavenumber.Enabled = false;
                        series_sig95_period.Enabled = false;
                        series_sig95_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_sig95_wavenumber.Enabled = false;
                        series_sig95_period.Enabled = false;
                        series_sig95_frequency.Enabled = false;
                    }
                    //chart_spectrum_plot.Series[this.selectedsig95].Enabled = false;
                }


                if (significance99ToolStripMenuItem.Checked == true)
                {
                    if (wavenumber)
                    {
                        series_sig99_wavenumber.Enabled = true;
                        series_sig99_period.Enabled = false;
                        series_sig99_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_sig99_wavenumber.Enabled = false;
                        series_sig99_period.Enabled = true;
                        series_sig99_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_sig99_wavenumber.Enabled = false;
                        series_sig99_period.Enabled = false;
                        series_sig99_frequency.Enabled = true;
                    }
                    //chart_spectrum_plot.Series[this.selectedsig99].Enabled = true;
                }
                if (significance99ToolStripMenuItem.Checked == false)
                {
                    if (wavenumber)
                    {
                        series_sig99_wavenumber.Enabled = false;
                        series_sig99_period.Enabled = false;
                        series_sig99_frequency.Enabled = false;
                    }
                    if (period)
                    {
                        series_sig99_wavenumber.Enabled = false;
                        series_sig99_period.Enabled = false;
                        series_sig99_frequency.Enabled = false;
                    }
                    if (frequency)
                    {
                        series_sig99_wavenumber.Enabled = false;
                        series_sig99_period.Enabled = false;
                        series_sig99_frequency.Enabled = false;
                    }
                    //chart_spectrum_plot.Series[this.selectedsig99].Enabled = false;
                }
            }

            //chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = x.Min();
            //chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = x.Max();

            chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();

            if (waveNumberToolStripMenuItem.Checked)
            {
                chart_spectrum_plot.ChartAreas[0].AxisX.IsReversed = false;
                //chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0; // x.Min();
                chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = x_wavenumber.Max();
                //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = 0; // x.Min();//x.Min();
                if (xaxisLinearToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0; // x.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = 0;
                }
                if (xaxisBase10ToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 1; // x.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = 0; // x.Min();//x.Min();
                }

                if (xaxisBaseEToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 1;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = 0;
                }
            }
            if (frequencyToolStripMenuItem.Checked)
            {
                chart_spectrum_plot.ChartAreas[0].AxisX.IsReversed = false;
                //chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0;
                //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = 0;//x.Min();
                chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = 0.5;
                if (xaxisLinearToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0; // x.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = 0.5;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = 0;
                }
                if (xaxisBase10ToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = x_frequency.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = Math.Log10(x_frequency.Min()); // x_frequency.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = 0.5;
                }

                if (xaxisBaseEToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = x_frequency.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = Math.Log(x_frequency.Min());
                    chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = 0.5;
                }
            }

            if (periodToolStripMenuItem.Checked)
            {
                chart_spectrum_plot.ChartAreas[0].AxisX.IsReversed = true;
                chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x_period.Max();
                //chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0; // x.Min();
                chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = x_period.Max();
                if (xaxisLinearToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x_period.Max();
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = 0; // x.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = x_period.Max();
                }
                if (xaxisBase10ToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x_period.Max();
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = x_period.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = x_period.Max();
                }

                if (xaxisBaseEToolStripMenuItem.Checked == true)
                {
                    chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x_period.Max();
                    chart_spectrum_plot.ChartAreas[0].AxisX.IsStartedFromZero = true;
                    chart_spectrum_plot.ChartAreas[0].AxisX.Minimum = x_period.Min();
                    chart_spectrum_plot.ChartAreas[0].AxisX.Maximum = x_period.Max();
                }
            }
        }

        private void waveNumberToolStripMenuItem_Click(object sender, EventArgs e)
        {
            wavenumber = true;
            frequency = false;
            period = false;

            waveNumberToolStripMenuItem.Checked = true;
            
            if (waveNumberToolStripMenuItem.Checked == true)
            {
                try
                {
                    frequencyToolStripMenuItem.Checked = false;
                    periodToolStripMenuItem.Checked = false;

                    //this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 0); // col 0 is wavenumber
                    //for (int i = 0; i < n; i++)
                    //{
                    //    this.x[i] = xdata[0, i];
                    //}


                    //double[,] xindex = new double[x.Length,x.Length];
                    //for (int i = 0; i < x.Length; i++)
                    //{
                    //    if (i == 0)
                    //    {
                    //        xindex[i, 0] = x[i];
                    //        xindex[i, 1] = 0;
                    //    }
                    //    else
                    //    {
                    //        xindex[i, 0] = x[i];
                    //        xindex[i, 1] = xindex[i - 1, 1] + 1;
                    //    }
                    //}

                    //this.xmax = this.x_wavenumber.Max();
                    //this.y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3);  // col 3 is power
                    if (SSA == true)
                    {
                        series_wavenumber.Enabled = true;
                        series_period.Enabled = false;
                        series_frequency.Enabled = false;

                        //this.error = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectederror, 3); //
                        //for (int i = 0; i < x.Length; i++)
                        //{
                        //    this.error_upper[i] = this.y[i] + this.error[i];
                        //    this.error_lower[i] = this.y[i] - this.error[i];
                        //}
                    }

                    //this.x_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 0);
                    if (fourier == true)
                    {
                        //for (int i = 0; i < n; i++)
                        //{
                        //    this.x_rednoise[i] = xdata_rednoise[0, i];
                        //}
                        //this.y_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 3);

                        ////this.x_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 0);
                        //this.x_sig90 = this.x;
                        //this.y_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 3);

                        ////this.x_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 0);
                        //this.x_sig95 = this.x;
                        //this.y_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 3);

                        ////this.x_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 0);
                        //this.x_sig99 = this.x;
                        //this.y_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 3);
                        chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Wave Number";
                    }
                    else
                    {
                        chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Component";
                    }
                    //chart_spectrum_plot.ChartAreas[0].AxisX.IsReversed = false;
                    //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = default(double);
                    //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x.Min();
                    //chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();
                }
                catch
                {
                    MessageBox.Show("Only the most recent chart can be modifed");
                }
            }
            UpdateChartSettings();
        }

        private void frequencyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frequency = true;
            wavenumber = false;
            period = false;
            waveNumberToolStripMenuItem.Checked = false;
            periodToolStripMenuItem.Checked = false; 

            frequencyToolStripMenuItem.Checked = true;
            if (frequencyToolStripMenuItem.Checked == true)
            {
                try
                {
                    //this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 2); // col 2 is frequency
                    //for (int i = 0; i < n; i++)
                    //{
                    //    this.x[i] = xdata[2, i];
                    //}

                    //double[] xtemp = new double[x.Length];
                    //double[] ytemp = new double[x.Length];
                    //double[] errortemp = new double[x.Length];
                    //double[] error_lowertemp = new double[x.Length];
                    //double[] error_uppertemp = new double[x.Length];

                    //for (int i = 0; i < x.Length; i++)
                    //{
                    //    xtemp[i] = x[i];
                    //}
                    //int[] xindex = new int[x.Length];
                    //for (int i = 0; i < x.Length; i++)
                    //{
                    //    if (i == 0)
                    //    {
                    //        xindex[i] = 0;
                    //    }
                    //    else
                    //    {
                    //        xindex[i] = xindex[i - 1] + 1;
                    //    }
                    //}
                    //Array.Sort(xtemp, xindex);
                    //x = xtemp;
                    //this.xmax = this.x.Max();
                    //ytemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3);  // col 3 is power
                    //xmax = this.x_frequency.Max();
                    //if (SSA == true)
                    //{

                    //    series_wavenumber.Enabled = false;
                    //    series_period.Enabled = false;
                    //    series_frequency.Enabled = true;
                    //    //errortemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectederror, 3); //
                    //    //for (int i = 0; i < x.Length; i++)
                    //    //{
                    //    //    error_lowertemp[i] = ytemp[i] + errortemp[i];
                    //    //    error_uppertemp[i] = ytemp[i] - errortemp[i];
                    //    //}
                    //}
                    
                    //for (int i = 0; i < x.Length; i++)
                    //{
                    //    y[i] = ytemp[xindex[i]];
                    //    error[i] = errortemp[xindex[i]];
                    //    error_lower[i] = error_lowertemp[xindex[i]];
                    //    error_upper[i] = error_uppertemp[xindex[i]];
                    //}



                    
                    if (fourier == true)
                    {
                        ////this.x_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 2);
                        //for (int i = 0; i < n; i++)
                        //{
                        //    this.x_rednoise[i] = xdata_rednoise[2, i];
                        //}
                        //this.y_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 3);

                        ////this.x_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 2);
                        //this.x_sig90 = this.x;
                        //this.y_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 3);
                        

                        ////this.x_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 2);
                        //this.x_sig95 = this.x;
                        //this.y_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 3);

                        ////this.x_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 2);
                        //this.x_sig99 = this.x;
                        //this.y_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 3);
                    }
                    chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Frequency";
                    //chart_spectrum_plot.ChartAreas[0].AxisX.IsReversed = false;
                    //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = default(double);
                    //chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();

                    //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x.Min();
                }
                catch
                {
                    MessageBox.Show("Only the most recent chart can be modifed");
                }
            }



            UpdateChartSettings();
        }

        private void periodToolStripMenuItem_Click(object sender, EventArgs e)
        {
            period = true;
            frequency = false;
            wavenumber = false;

            waveNumberToolStripMenuItem.Checked = false;
            frequencyToolStripMenuItem.Checked = false;
       
            periodToolStripMenuItem.Checked = true;
            if (periodToolStripMenuItem.Checked == true)
            {
                try
                {
                    //this.x = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 1); // col 1 is period
                    //for (int i = 0; i < n; i++)
                    //{
                    //    this.x[i] = xdata[1, i];
                    //}

                    //double[] xtemp = new double[x.Length];
                    //double[] ytemp = new double[x.Length];
                    //double[] errortemp = new double[x.Length];
                    //double[] error_lowertemp = new double[x.Length];
                    //double[] error_uppertemp = new double[x.Length];

                    //for (int i = 0; i < x.Length; i++)
                    //{
                    //    xtemp[i] = x[i];
                    //}
                    //int[] xindex = new int[x.Length];
                    //for (int i = 0; i < x.Length; i++)
                    //{
                    //    if (i == 0)
                    //    {
                    //        xindex[i] = 0;
                    //    }
                    //    else
                    //    {
                    //        xindex[i] = xindex[i - 1] + 1;
                    //    }
                    //}
                    //Array.Sort(xtemp, xindex);
                    //x = xtemp;

                    //this.xmax = this.x.Max();
                    //ytemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3);  // col 3 is power
 

                    //temp_y = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selecteddataseries, 3);  // col 3 is power
                    //this.xmax = this.x_period.Max();
                    //if (SSA == true)
                    //{
                    //    series_wavenumber.Enabled = false;
                    //    series_period.Enabled = true;
                    //    series_frequency.Enabled = false;
                    //    //errortemp = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectederror, 3); //
                    //    //for (int i = 0; i < x.Length; i++)
                    //    //{
                    //    //    error_lowertemp[i] = ytemp[i] + errortemp[i];
                    //    //    error_uppertemp[i] = ytemp[i] - errortemp[i];
                    //    //}


                    //    for (int i = 0; i < x.Length; i++)
                    //    {
                    //        y[i] = ytemp[xindex[i]];
                    //        error[i] = errortemp[xindex[i]];
                    //        error_lower[i] = error_lowertemp[xindex[i]];
                    //        error_upper[i] = error_uppertemp[xindex[i]];
                    //    }
                    //}

                    //if (fourier == true)
                    //{
                    //    //this.x_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 1);
                    //    for (int i = 0; i < n; i++)
                    //    {
                    //        this.x[i] = xdata[1, i];
                    //    }
                    //    this.temp_y_rednoise = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedrednoise, 3);

                    //    //this.x_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 1);
                    //    this.x_sig90 = this.x;
                    //    this.temp_y_sig90 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig90, 3);

                    //    //this.x_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 1);
                    //    this.x_sig95 = this.x;
                    //    this.temp_y_sig95 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig95, 3);

                    //    //this.x_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 1);
                    //    this.x_sig99 = this.x;
                    //    this.temp_y_sig99 = this.formtoolkit.get_oneColArray_from_datatable(datamaster, selectedsig99, 3);
                    //    // reverse values in y vector
                    //    //for (int i = 0; i < x.Length; i++)
                    //    //{
                    //    //    this.y[i] = temp_y[(x.Length-1) - i];
                    //    //    this.y_rednoise[i] = temp_y_rednoise[(x.Length-1) - i];
                    //    //    this.y_sig90[i] = temp_y_sig90[(x.Length - 1) - i];
                    //    //    this.y_sig95[i] = temp_y_sig95[(x.Length - 1) - i];
                    //    //    this.y_sig99[i] = temp_y_sig99[(x.Length - 1) - i];
                    //    //}
                    //}



                    chart_spectrum_plot.ChartAreas[0].AxisX.Title = "Period";
                    //chart_spectrum_plot.ChartAreas[0].AxisX.IsReversed = true;
                    //chart_spectrum_plot.ChartAreas[0].AxisX.RoundAxisValues();
                    //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = Double.MaxValue;
                    //chart_spectrum_plot.ChartAreas[0].AxisX.Crossing = x.Max();
                    //chart_spectrum_plot.ChartAreas[0].AxisY.IsMarksNextToAxis = false;
                }
                catch
                {
                    MessageBox.Show("Only the most recent chart can be modifed");
                }
            }
            UpdateChartSettings();
        }
       
       
        private void chart1_Click(object sender, EventArgs e)
        {

        }

        private void Form_plot_Load(object sender, EventArgs e)
        {

        }

        private void comboBox_chart_type_SelectedIndexChanged(object sender, EventArgs e)
        {
        }

        private void change_chart_type(string plottype)
        {

        }

        private void checkBox_showpoints_CheckedChanged(object sender, EventArgs e)
        {
        }


        private void ToolStripMenuItem_close_Click(object sender, EventArgs e)
        {
            //Application.Exit();
            this.Close();
        }

        private void ToolStripMenuItem_save_Click(object sender, EventArgs e)
        {
            // Create a new save file dialog
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            // Sets the current file name filter string, which determines 
            // the choices that appear in the "Save as file type" or 
            // "Files of type" box in the dialog box.
            saveFileDialog1.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|SVG (*.svg)|*.svg|GIF (*.gif)|*.gif|TIFF (*.tif)|*.tif";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            // Set image file format
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                ChartImageFormat format = ChartImageFormat.Bmp;

                if (saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ChartImageFormat.Bmp;
                }
                else if (saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ChartImageFormat.Jpeg;
                }
                else if (saveFileDialog1.FileName.EndsWith("emf"))
                {
                    format = ChartImageFormat.Emf;
                }
                else if (saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ChartImageFormat.Gif;
                }
                else if (saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ChartImageFormat.Png;
                }
                else if (saveFileDialog1.FileName.EndsWith("tif"))
                {
                    format = ChartImageFormat.Tiff;
                }
                //else if (saveFileDialog1.FileName.EndsWith("svg"))
                //{
                //    format = ChartImageFormat.Svg;
                //}

                // Save image
                chart_spectrum_plot.SaveImage(saveFileDialog1.FileName, format);
            }
        }

        private void ToolStripMenuItem_copy_Click(object sender, EventArgs e)
        {
            // create a memory stream to save the chart image    
            System.IO.MemoryStream stream = new System.IO.MemoryStream();

            // save the chart image to the stream    
            chart_spectrum_plot.SaveImage(stream, System.Drawing.Imaging.ImageFormat.Bmp);

            // create a bitmap using the stream    
            Bitmap bmp = new Bitmap(stream);

            // save the bitmap to the clipboard    
            Clipboard.SetDataObject(bmp);
        }

        private void ToolStripMenuItem_print_Click(object sender, EventArgs e)
        {
            chart_spectrum_plot.Printing.Print(true);
        }

        private void ToolStripMenuItem_print_preview_Click(object sender, EventArgs e)
        {
            chart_spectrum_plot.Printing.PrintPreview();
        }

        private void viewToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }


        private void powerVsWaveNumberToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void xaxisLinearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            xaxisLinearToolStripMenuItem.Checked = !xaxisLinearToolStripMenuItem.Checked;
            if (xaxisLinearToolStripMenuItem.Checked == true)
            {
                xaxisBaseEToolStripMenuItem.Checked = false;
                xaxisBase10ToolStripMenuItem.Checked = false;
                chart_spectrum_plot.ChartAreas[0].AxisX.IsLogarithmic = false;
            }
            UpdateChartSettings();

        }

        private void xaxisBase10ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            xaxisBase10ToolStripMenuItem.Checked = !xaxisBase10ToolStripMenuItem.Checked;
            if (xaxisBase10ToolStripMenuItem.Checked == true)
            {
                xaxisLinearToolStripMenuItem.Checked = false;
                xaxisBaseEToolStripMenuItem.Checked = false;
                chart_spectrum_plot.ChartAreas[0].AxisX.IsLogarithmic = true;
                chart_spectrum_plot.ChartAreas[0].AxisX.LogarithmBase = 10;
            }
            UpdateChartSettings();
        }

        private void xaxisBaseEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            xaxisBaseEToolStripMenuItem.Checked = !xaxisBaseEToolStripMenuItem.Checked;
            if (xaxisBaseEToolStripMenuItem.Checked == true)
            {
                xaxisLinearToolStripMenuItem.Checked = false;
                xaxisBase10ToolStripMenuItem.Checked = false;
                chart_spectrum_plot.ChartAreas[0].AxisX.IsLogarithmic = true;
                chart_spectrum_plot.ChartAreas[0].AxisX.LogarithmBase = Math.E;
            }
            UpdateChartSettings();
        }

        private void yaxisLinearToolStripMenuItem_Click(object sender, EventArgs e)
        {
            yaxisLinearToolStripMenuItem.Checked = !yaxisLinearToolStripMenuItem.Checked;
            if (yaxisLinearToolStripMenuItem.Checked == true)
            {
                yaxisBaseEToolStripMenuItem.Checked = false;
                yaxisBase10ToolStripMenuItem.Checked = false;
                chart_spectrum_plot.ChartAreas[0].AxisY.IsLogarithmic = false;
            }
            UpdateChartSettings();
        }

        private void yaxisBaseEToolStripMenuItem_Click(object sender, EventArgs e)
        {
            yaxisBaseEToolStripMenuItem.Checked = !yaxisBaseEToolStripMenuItem.Checked;
            if (yaxisBaseEToolStripMenuItem.Checked == true)
            {
                yaxisLinearToolStripMenuItem.Checked = false;
                yaxisBase10ToolStripMenuItem.Checked = false;
                chart_spectrum_plot.ChartAreas[0].AxisY.IsLogarithmic = true;
                chart_spectrum_plot.ChartAreas[0].AxisY.LogarithmBase = Math.E;
            }
            UpdateChartSettings();
        }

        private void yaxisBase10ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            yaxisBase10ToolStripMenuItem.Checked = !yaxisBase10ToolStripMenuItem.Checked;
            if (yaxisBase10ToolStripMenuItem.Checked == true)
            {
                yaxisLinearToolStripMenuItem.Checked = false;
                yaxisBaseEToolStripMenuItem.Checked = false;
                chart_spectrum_plot.ChartAreas[0].AxisY.IsLogarithmic = true;
                chart_spectrum_plot.ChartAreas[0].AxisY.LogarithmBase = 10;
            }
            UpdateChartSettings();
        }

        private void redNoiseNullHypothesisToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //if (redNoiseNullHypothesisToolStripMenuItem.Checked == false)
            //{
            //    redNoiseNullHypothesisToolStripMenuItem.Checked = true;
            //}
            redNoiseNullHypothesisToolStripMenuItem.Checked =! redNoiseNullHypothesisToolStripMenuItem.Checked;
            //if (redNoiseNullHypothesisToolStripMenuItem.Checked == true)
            //{
            //    chart_spectrum_plot.Series[this.selectedrednoise].Enabled = true;  
            //}
            //if (redNoiseNullHypothesisToolStripMenuItem.Checked == false)
            //{
            //    chart_spectrum_plot.Series[this.selectedrednoise].Enabled = false;
            //}
            UpdateChartSettings();
        }

        private void significance90ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            significance90ToolStripMenuItem.Checked = !significance90ToolStripMenuItem.Checked;
            //if (significance90ToolStripMenuItem.Checked == true)
            //{
            //    chart_spectrum_plot.Series[this.selectedsig90].Enabled = true;   
            //}
            //if (significance90ToolStripMenuItem.Checked == false)
            //{
            //    chart_spectrum_plot.Series[this.selectedsig90].Enabled = false;    
            //}
            UpdateChartSettings();
        }

        private void significance95ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            significance95ToolStripMenuItem.Checked = !significance95ToolStripMenuItem.Checked;
            //if (significance95ToolStripMenuItem.Checked == true)
            //{
            //    chart_spectrum_plot.Series[this.selectedsig95].Enabled = true;   
            //}
            //if (significance95ToolStripMenuItem.Checked == false)
            //{
            //    chart_spectrum_plot.Series[this.selectedsig95].Enabled = false;   
            //}
            UpdateChartSettings();
        }

        private void significance99ToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            significance99ToolStripMenuItem.Checked = !significance99ToolStripMenuItem.Checked;
            //if (significance99ToolStripMenuItem.Checked == true)
            //{
            //    chart_spectrum_plot.Series[this.selectedsig99].Enabled = true;   
            //}
            //if (significance99ToolStripMenuItem.Checked == false)
            //{
            //    chart_spectrum_plot.Series[this.selectedsig99].Enabled = false;   
            //}
            UpdateChartSettings();
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // create a memory stream to save the chart image    
            System.IO.MemoryStream stream = new System.IO.MemoryStream();

            // save the chart image to the stream    
            chart_spectrum_plot.SaveImage(stream, System.Drawing.Imaging.ImageFormat.Bmp);

            // create a bitmap using the stream    
            Bitmap bmp = new Bitmap(stream);

            // save the bitmap to the clipboard    
            Clipboard.SetDataObject(bmp);
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // Create a new save file dialog
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            // Sets the current file name filter string, which determines 
            // the choices that appear in the "Save as file type" or 
            // "Files of type" box in the dialog box.
            saveFileDialog1.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|SVG (*.svg)|*.svg|GIF (*.gif)|*.gif|TIFF (*.tif)|*.tif";
            saveFileDialog1.FilterIndex = 2;
            saveFileDialog1.RestoreDirectory = true;

            // Set image file format
            if (saveFileDialog1.ShowDialog() == DialogResult.OK)
            {
                ChartImageFormat format = ChartImageFormat.Bmp;

                if (saveFileDialog1.FileName.EndsWith("bmp"))
                {
                    format = ChartImageFormat.Bmp;
                }
                else if (saveFileDialog1.FileName.EndsWith("jpg"))
                {
                    format = ChartImageFormat.Jpeg;
                }
                else if (saveFileDialog1.FileName.EndsWith("emf"))
                {
                    format = ChartImageFormat.Emf;
                }
                else if (saveFileDialog1.FileName.EndsWith("gif"))
                {
                    format = ChartImageFormat.Gif;
                }
                else if (saveFileDialog1.FileName.EndsWith("png"))
                {
                    format = ChartImageFormat.Png;
                }
                else if (saveFileDialog1.FileName.EndsWith("tif"))
                {
                    format = ChartImageFormat.Tiff;
                }
                //else if (saveFileDialog1.FileName.EndsWith("svg"))
                //{
                //    format = ChartImageFormat.Svg;
                //}

                // Save image
                chart_spectrum_plot.SaveImage(saveFileDialog1.FileName, format);
            }
        }

        private void printPreviewToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart_spectrum_plot.Printing.Print(true);
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {
            chart_spectrum_plot.Printing.PrintPreview();
        }
    }
}

