﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Climate_toolkit
{
    public partial class Workspace : Form
    {
        private Cdatamaster datamaster;
        string selecteddataseries;


        public Workspace(Cdatamaster datamasterToUse, string selecteddataseriesToUse)
        {
            InitializeComponent();
            this.datamaster = datamasterToUse; // make a local copy this subform holds on to
            this.selecteddataseries = selecteddataseriesToUse;


            DataView viewdatagrid = new DataView(datamaster.Tables[this.selecteddataseries]);

            fill_combobox_with_datatablenames_selecteddataseries();
            comboBox_dataseriesname.Text = this.selecteddataseries;
            comboBox_dataseriesname.SelectedItem = this.selecteddataseries;
           
            fill_workspace_table_with_datatablenames();
        }

        public void fill_combobox_with_datatablenames_selecteddataseries()
        {
            comboBox_dataseriesname.Items.Clear();
            foreach (DataRow dr in datamaster.Tables["sites"].Rows)
            {
                {
                    comboBox_dataseriesname.Items.Add(dr["SiteID"].ToString());
                }
            }
        }

        private void comboBox_dataseriesname_SelectedIndexChanged(object sender, EventArgs e)
        {
            this.selecteddataseries = comboBox_dataseriesname.SelectedItem.ToString();
            fill_workspace_table_with_datatablenames();
        }

        public void fill_workspace_table_with_datatablenames()
        {
            dataGridView1.Rows.Clear();
            string nrow;
            string ncol;

            int n = 0;

            string arraysize;

            foreach (DataTable table in datamaster.Tables)
            {
                if (table.TableName != "sites" & table.TableName != "preprocess" & table.TableName != "stationarity"
                    & table.TableName != "Fourier" & table.TableName != "SSA" & table.TableName != "EOF"
                    & table.TableName != "Regression" & table.TableName != "AR" & table.TableName != "Projection"
                    & table.TableName != "ProjectionSum")
                {
                    if (table.TableName.Length >= this.selecteddataseries.Length)
                    {
                        if (table.TableName.Substring(0, this.selecteddataseries.Length) == this.selecteddataseries)
                        {
                            dataGridView1.Rows.Add();

                            nrow = Convert.ToString(table.Rows.Count);
                            ncol = Convert.ToString(table.Columns.Count);

                            arraysize = "[" + nrow + ", " + ncol + "]";

                            dataGridView1.Rows[n].Cells[0].Value = table.TableName;
                            dataGridView1.Rows[n].Cells[1].Value = arraysize;

                            n++;
                        }
                    }
                }
            }
        }
    }
}
